﻿<%@ Page Language="C#" AutoEventWireup="true" MasterPageFile="~/WebAdministrator/MasterTemplates/AuthenticatedMaster.Master"
    CodeBehind="ManageUsers.aspx.cs" Inherits="WebAdministrator.Authenticated.Accounts.ManageUsers" %>

<asp:Content ID="Content1" ContentPlaceHolderID="Content_Authenticated" runat="server">
    <h2>
        Users</h2>
    <asp:Label ID="lblShowingRecords" runat="server"></asp:Label>
    <asp:DropDownList ID="ddlPaging" runat="server" Width="50px" AutoPostBack="True"
        OnSelectedIndexChanged="ddlPaging_SelectedIndexChanged">
        <asp:ListItem Text="10" Value="10"></asp:ListItem>
        <asp:ListItem Text="20" Value="20"></asp:ListItem>
        <asp:ListItem Text="30" Value="30"></asp:ListItem>
        <asp:ListItem Text="40" Value="40"></asp:ListItem>
        <asp:ListItem Text="50" Value="50"></asp:ListItem>
    </asp:DropDownList>
    <br />
    <br />
    <div class="pagination" style="width: 400px; float: right; height: 30px;">
        <asp:Repeater ID="rptPager" runat="server">
            <ItemTemplate>
                <asp:LinkButton ID="lnkPage" runat="server" Text='<%# Eval("Text") %>' CommandArgument='<%#Eval("Value") %>'
                    CssClass='<%# (Convert.ToBoolean(Eval("Enabled").ToString())==true)?"curved":"active curved" %>'
                    Enabled='<%# Eval("Enabled") %>' OnClick="Page_Changed"></asp:LinkButton>
            </ItemTemplate>
        </asp:Repeater>
    </div>
    <style type="text/css">
        .userlist_table
        {
            padding: 0px;
        }
        .userlist_table th, td
        {
            padding: 0px 0px 0px 5px;
            vertical-align: middle;
        }
        .userlist_table td img
        {
            padding: 0px;
            margin-top: 2px;
        }
        .userlist_table_items
        {
            padding: 0px;
            margin: 0px;
        }
        .userlist_table_seperator
        {
            padding: 0px;
            margin: 0px;
            height: 2px;
        }
    </style>
    <asp:Repeater ID="rptUsers" runat="server" OnItemCommand="rptUsers_ItemCommand">
        <HeaderTemplate>
            <table class="userlist_table">
                <tr>
                    <th>
                    </th>
                    <th>
                        Email
                    </th>
                    <th>
                        First Name
                    </th>
                    <th>
                        Last Name
                    </th>
                    <th>
                        Active
                    </th>
                    <th>
                        Anonymous
                    </th>
                    <th colspan="4" width="10%">
                        Actions
                    </th>
                </tr>
        </HeaderTemplate>
        <ItemTemplate>
            <tr class="userlist_table_items">
                <td>
                    <img src="<%# ((string.IsNullOrEmpty(Eval("MyPhoto").ToString()))?"../../images/male-avatar.png":"/ImageHandler.ashx?file=" + Eval("MyPhoto").ToString() + "&file_location=/Uploads/" + Eval("RandomId").ToString()  + "/MyPhotos&h=32&w=32") %>"
                        alt="" height="32" width="32" />
                </td>
                <td>
                    <%# Eval("Email_Id") %>
                </td>
                <td>
                    <%# Eval("First_Name") %>
                </td>
                <td>
                    <%# Eval("Last_Name") %>
                </td>
                <td>
                    <%# (Boolean.Parse(Eval("IsActive").ToString())==true)?"Yes":"No" %>
                </td>
                <td>
                    <%# (Boolean.Parse(Eval("IsAnonymous").ToString()) == true) ? "Yes" : "No"%>
                </td>
                <td>
                    <a href='<%# "UserDetail.aspx?user_Id="+Eval("Id")%>'>
                        <img src="../../images/profile.png" title="Edit Profile" alt="Edit Profile" width="32"
                            height="32" /></a>
                </td>
                <td>
                    <asp:ImageButton ID="imgbtnProducts" runat="server" ImageUrl="../../images/edit-product.png"
                        ToolTip="Edit Products" AlternateText="Edit Products" CommandArgument='<%#Eval("Id").ToString()%>'
                        CommandName="GoUser" Height="32" Width="32"  style="padding:1px;" />
                </td>
                <td>
                    <asp:Button ID="btnDelete" runat="server" Text="Delete" CommandArgument='<%#Eval("Id").ToString()%>'
                        CommandName="DeleteUser" OnClientClick="return confirm('Are you sure to delete?');"
                        CssClass="delete" />
                </td>
                <td>
                   <%-- <asp:Button ID="btnGo" runat="server" Text="Go" CommandArgument='<%#Eval("Id").ToString()%>'
                        CommandName="GoUser" CssClass="delete" />--%>
                </td>
            </tr>
        </ItemTemplate>
        <AlternatingItemTemplate>
            <tr class="userlist_table_items">
                <td>
                    <img src="<%# ((string.IsNullOrEmpty(Eval("MyPhoto").ToString()))?"../../images/male-avatar.png":"/ImageHandler.ashx?file=" + Eval("MyPhoto").ToString() + "&file_location=/Uploads/" + Eval("RandomId").ToString()  + "/MyPhotos&h=32&w=32") %>"
                        alt="" height="32" width="32" />
                </td>
                <td>
                    <%# Eval("Email_Id")%>
                </td>
                <td>
                    <%# Eval("First_Name")%>
                </td>
                <td>
                    <%# Eval("Last_Name")%>
                </td>
                <td>
                    <%# (Boolean.Parse(Eval("IsActive").ToString())==true)?"Yes":"No" %>
                </td>
                <td>
                    <%# (Boolean.Parse(Eval("IsAnonymous").ToString()) == true) ? "Yes" : "No"%>
                </td>
                <td>
                    <a href='<%# "UserDetail.aspx?user_Id="+Eval("Id")%>'>
                        <img src="../../images/profile.png" title="Edit Profile" alt="Edit Profile" width="32"
                            height="32" /></a>
                </td>
                <td>
                    <asp:ImageButton ID="imgbtnProducts" runat="server" ImageUrl="../../images/edit-product.png"
                        ToolTip="Edit Products" AlternateText="Edit Products" CommandArgument='<%#Eval("Id").ToString()%>'
                        CommandName="GoUser" Height="32" Width="32"  style="padding:1px;" />
                </td>
                <td>
                    <asp:Button ID="btnDelete" runat="server" Text="Delete" CommandArgument='<%#Eval("Id").ToString()%>'
                        CommandName="DeleteUser" OnClientClick="return confirm('Are you sure to delete?');"
                        CssClass="delete" />
                </td>
                <td>
                   <%-- <asp:Button ID="btnGo" runat="server" Text="Go" CommandArgument='<%#Eval("Id").ToString()%>'
                        CommandName="GoUser" CssClass="delete" />--%>
                </td>
            </tr>
        </AlternatingItemTemplate>
        <SeparatorTemplate>
            <tr>
                <td colspan="10" style="height: 1px; background-color: #dddddd;">
                    &nbsp;
                </td>
            </tr>
        </SeparatorTemplate>
        <FooterTemplate>
            </table></FooterTemplate>
    </asp:Repeater>
    <div id="divNoList" runat="server" class="nobinds">
    </div>
</asp:Content>
