var select_durations = function() { 
    $('.choose_format').bind('click', function() {
      var chosen = $(this).attr('value').toUpperCase();
      $('input.duration').attr('disabled', 'disabled');
      $('.' + chosen).removeAttr('disabled');
      $('li.duration_wrap').addClass('disabled');
      $('.' + chosen + '_wrap').removeClass('disabled');
      $('.duration[checked=checked]').attr('checked', false)
    });
    $('ul.digital_format input').bind('click', function() {
      var input_target = $(this);
      console.log(input_target.attr('value'))
      $('.modal-box ul.digital_durations input').each(function(k, item) {
        if(item.hasClass(input_target.attr('value').toUpperCase())){
          item.removeClass('hide');
        } else {
          item.addClass('hide');
        }
      });
    });
  }


var Spinner = function() { 
  return {
    show: function() {
      var spinnerCSS = { 'margin-left' : '-25px', 'z-index' : '21000'}
      $('#globalSpinner').css(spinnerCSS).addClass('activeSpinner');
    },
    hide: function() {
      $('#globalSpinner').removeClass('activeSpinner').removeAttr('style');
    }
  };
}();

function $defined(obj){
  return (obj != undefined);
};

var delay = (function(){
  var timer = 0;
  return function(callback, ms){
    clearTimeout (timer);
    timer = setTimeout(callback, ms);
  }  
})();

function switch_multiaccount_url() {
  if($('#user_current_library').length > 0) {
    
    $('#user_current_library').change(function() {
      if(BYPASS_SITE_CHANGE_CONFIRMATION || confirm(LIBRARY_CHANGE_MESSAGE.replace('__DESTINATION__', $('#user_current_library option:selected').text()))){
        $.get(
          '/user/switch_libraries', 
          { libid : $('#user_current_library').val() },
          function(data) {
            window.location.hostname = String(data.new_host);
          }
        );
      }
    });
  }
}

var validate_jacket_image = function(this_image) {
  if(this_image.attr('src') != this_image.attr('fallback')) {
    var tmp = new Image();
    tmp.onerror = function(){
        this_image.attr('src', this_image.attr('fallback'));
    }
    tmp.onload = function() {
      if(this_image.attr('src') != this_image.attr('fallback') && (tmp.width <= 1 || tmp.height <= 1)) {
        this_image.attr('src', this_image.attr('fallback'));
      }
    };  
    tmp.src = this_image.attr('src');
  }
}

String.prototype.strip_scripts = function() {
  var stripped =  this.replace(/<script\b[^<]*(?:(?!<\/script>)<[^<]*)*<\/script>/gi, '');
  return stripped;
}

String.prototype.splice = function(idx, rem, str){
  return (this.slice(0,idx) + s + this.slice(idx + Math.abs(rem)));
}

//gets value from a serialized string i.e. search string or .serialized
String.prototype.get_val = function(name) {
  name = name.replace(/[\[]/, "\\\[").replace(/[\]]/, "\\\]");
  var regexS = "[\\?&]" + name + "=([^&#]*)";
  var regex = new RegExp(regexS);
  var results = regex.exec(this)
  if(results == null)
    return "";
  else
    return decodeURIComponent(results[1].replace(/\+/g, " "));
}

Array.prototype.in_array = function(p_val) {
  for(var i = 0, l = this.length; i < l; i++) {
    if(this[i] == p_val) {
      return true;
    }
  }
  return false;
}


Array.prototype.associate = function(keys){
  var obj = {}, length = Math.min(this.length, keys.length);
  for (var i = 0; i < length; i++) obj[keys[i]] = this[i];
  return obj;
}


String.prototype.capitalize = function() {
   return this.toLowerCase().replace( /(^|\s)([a-z])/g , function(m,p1,p2){ return p1+p2.toUpperCase(); } );
}

function tidyTitles(title){
	var values = title.split(" - ");
	if(values.length > 1){
		template = "<div style='width:250px;'><h3>__TITLE__</h3> __TEXT__</div>";
		return template.replace("__TITLE__", values[0]).replace('__TEXT__', values[1]);
	} else {
		template = "<div style='width:200px;'>__TEXT__</div>";
		return template.replace("__TEXT__", values[0]);
	}
}

function obj_size(obj) {
    var size = 0, key;
    for (key in obj) {
        if (obj.hasOwnProperty(key)) size++;
    }
    return size;
};

if( typeof $.validator !== 'undefined' ) {
  $.validator.addMethod("phoneUS", function(phone_number, element) {
      phone_number = phone_number.replace(/\s+/g, ""); 
    return this.optional(element) || phone_number.length > 9 &&
      phone_number.match(/^(1-?)?(\([2-9]\d{2}\)|[2-9]\d{2})-?[2-9]\d{2}-?\d{4}$/);
  }, "Please specify a valid US phone number.");
} 

function initialize_reading_options(){
  $('.fulfilment_modal').bind('click', function(e){
    e.preventDefault();
    var obj = $(this);
    $.getJSON(obj.attr('href'), function(data){
      if(data.html){
        var relative = obj;
        obj.popout({content: data.html, relativeTo: obj, offset: 130, aria_describtedby: "mobile-list-heading", width: "450px",
          callback: function(){
            $("#sms_submit_form").validate({
              rules: {
                phone_number: {
                  phoneUS: true
                }
              },
              errorPlacement: function(error, element) {
                $('#sms_submit_form').find('.submit_button').after(error);
              }
            });
            $('#sms_submit_form').on('submit', function(e) {
                e.preventDefault();
                $.ajax({
                  url: $(this).attr('action') + ".json",
                  dataType: 'json',
                  data: $(this).serialize(),
                  beforeSend: function() {
                    if ($("#sms_submit_form").valid() === false) {
                      return false;
                    }
                  }
                });
            });

            $("#email_submit_form").validate({
              rules: {
                email: {
                  email: true
                }
              },
              errorPlacement: function(error, element) {
                $('#email_submit_form').find('.submit_button').after(error);
              }
            });
            $('#email_submit_form').bind('submit', function(e) {
                e.preventDefault();
                $.ajax({
                  url: $(this).attr('action') + ".json",
                  dataType: 'json',
                  data: $(this).serialize(),
                  beforeSend: function() {
                    if ($("#email_submit_form").valid() === false) {
                      return false;
                    }
                  }
                });
            });
            
          }
        });
      }
      return;
    });
  });
}



function trigger_j_callback(callback_trigger,change_url, message_to_push) {
  if($('#' + callback_trigger).length > 0)
  {
    $.removeCookie('j_callback', { path: '/' });
    if(message_to_push != null)
    {
      $.getJSON("/messages/create_message.json",  {message:message_to_push });
    }

    if(change_url)
    {
      window.location.href = "#" + $('#' + callback_trigger).attr('id');
    }

    $('#' + callback_trigger).trigger('click');
  }
}

function get_largest(sortObj, min) {
  var largest = {
    key: null,
    val: null
  };
 
  for(var i in sortObj){
      if( sortObj[i]>largest.val ){
          largest.key = i;
          largest.val = sortObj[i];
      }
  }
  
  if(min) {
    if(largest.val >= min) {
      return largest;
    }
  } else {
    return largest;
  }
  
  return null;
}

function fake_stringify(arrayArg) {
  var stringArr = "";
  $.each( arrayArg, function(i, v) {
    stringArr = stringArr + "" + i + "=" + v + ",";
  });
  
  return stringArr;
}

function fake_parse(arrayString) {
  var toArr = arrayString.split(',');
  var newArr = {};
  $.each( toArr, function(i, v) {
    if(v.length > 0) {
      var splitKey = v.split('=');
      newArr[splitKey[0]] = parseInt(splitKey[1]);
    }
  });
  return newArr;
;}


function tabs() {
  var tab_id = $(this).attr('param');
  var parent = $('#' + $(this).parent('div').attr('id').replace('viewSelector_', ''));
  $(this).addClass('active').siblings().removeClass('active');
  parent.find('.tab[param="' + tab_id + '"]').show().siblings().hide();
}

function baseURL() {
    var url = location.href; 
    var baseURL = url.substring(0, url.indexOf('/', 14));
    return baseURL;
}

function j_add_extension(uri, ext) {
  var uri_hash = parseUri(uri);
   var return_uri = uri_hash['path'].replace(/\..*?$/,'') + ext;
   if(uri_hash['query'] != null && uri_hash['query'] != "") return_uri += "?" + uri_hash['query'];
   return return_uri;
}

function json_uri(uri) {
  var uri_hash = parseUri(uri);
   var return_uri =  uri_hash['uri'].replace(/\..*?$/,'') + ".json";
   if(uri_hash['query'] != null && uri_hash['query'] != "") return_uri += "?" + uri_hash['query'];
   return return_uri;
}

function swap_action(uri, action) {
  uri = uri.split('/');
  if ($.trim(uri[0]).length == 0 ) {
      swap_index = 2;
  } else {
    swap_index = 1;
  }
  uri[swap_index] = action;
  uri = uri.join('/') 
  return uri;
}

function parseUri (str) {
    var bits = str.match(/^(?:([^:\/?#.]+):)?(?:\/\/)?(([^:\/?#]*)(?::(\d*))?)((\/(?:[^?#](?![^?#\/]*\.[^?#\/.]+(?:[\?#]|$)))*\/?)?([^?#\/]*))?(?:\?([^#]*))?(?:#(.*))?/);
    return (bits)
      ? bits.associate(['uri', 'scheme', 'authority', 'domain', 'port', 'path', 'directory', 'file', 'query', 'fragment'])
      : null;
};

function custom_ils_error_popup(message) {
  $.modal('show', {content: message, fixed_width: "500px", hide_overflow: true});
}

function bind_live_plugins() {
	$('.popupContent .tabContainer').bctabs();
	
    $('#shelf_browse .viewSelector a').bctabs({param_change: true}); // TODO remove this line completely when popups are replaced .on would normally bind this but it doesn't work on mootools events
}


(function( $ ) {
  $.fn.simple_post = function() {
    return this.each(function() {
      this_link = $(this);  
      this_link.bind('click', function(e) {
        e.preventDefault();
       $.post(json_uri(this_link.attr('href')));
      });
    });
  };
})( jQuery );

$(window).bind('beforeunload', function() {
  if (!window.dont_spin) Spinner.show();
  window.dont_spin = false;
});


(function( $ ) {
  $.fn.setFocus = function() {
    return this.each(function() {
      var $this= $(this);
      if($this.is(':visible')) {
        $this.focus();
      }
    });
  };
})( jQuery );

(function( $ ) {
  // usage: $('#elem').enterkey(13, specialfunction);
  $.fn.enterkey = function(key, callback) {
    if(!callback || !key) { return; }
    $(this).keydown(function(e) {
       if(e.which == key) {
          callback();
          return false;
       }
    }); 
  };
})( jQuery );

(function( $ ) {
  $.fn.triggerDisable = function(options) {
    return this.each(function() {
      var $this = $(this);
      var $triggers = options.triggers;
      $triggers.bind('click', function(e) {
        var state = true;
        $triggers.each(function(i) {
          if($(this).attr('checked')){
            state = false;
          }
        });
        if (state == true) {
          $this.attr('disabled', 'disabled');
        } else {
          $this.removeAttr('disabled');
        }
      });
    });
  };
})( jQuery );

function init_filters_expanders() {
  $('.popup_more').bind('click', function(event){
    event.preventDefault();
    var this_obj = $(this);
    var request_url = j_add_extension(this_obj.attr('href'), '.json');
    if (globalAjaxCache[request_url]) {
      current_popout = $('#popout-box-content').html().replace(/(<([^>]+)>)/ig, '');
      request_popout = globalAjaxCache[request_url].replace(/(<([^>]+)>)/ig, '');
      if (current_popout != request_popout || $('#popout-box-content').is(":visible") == false) {
        this_obj.popout({
          content: globalAjaxCache[request_url],
          offset: (this_obj.outerWidth(false) + 13 )
        }); 
          $('.filterList').filterList();
      }
    } else {
      $.ajax({
        url: request_url,
        success: function(response, textResponse, jqXHR){
          var res_data = response.html.replace(/\n/g,'').replace(/\s/g,' ').replace(/  ,/g,' ');
          globalAjaxCache[request_url] = res_data;
          $(event.target).popout({
            content: res_data,
            offset: (this_obj.width() + 13 )
          });
          $('.filterList').filterList();
        }
      });
    }
  });
  
 /* $('.expandBtn.more').click(function(){
    $(this).parent('div').find('.remaining_filters').slideToggle();
     $(this).parent('div').find('.all.popup_more').toggle();
    var text = $(this).find('.action').text() == less ? more : less;
    $(this).find('.action').text(text);
    
  }); */
  
}

function page_id(path) {
  if (!path) {
    path = window.location.pathname;
  }
  path_parts = path.split('/');
  if (path_parts.length >= 4) {
    return path_parts[3]
  }
  return "";
}

  function last_term ( val ) {
    var arr = val.split( /,\s*/ );
    return arr[arr.length - 1]
  }
  
  function split( val ) {
      return val.split( /,\s*/ );
    }
    function extractLast( term ) {
      return split( term ).pop();
    }

$('.parentNav.program_site li.dropDown').hover(function() {
  $(this).find('.dropDownContent').show();
}, function() {
  $(this).find('.dropDownContent').slideUp();
})
$('body').click(function() { $('.parentNav.program_site .dropDownContent').hide(); })

Array.prototype.clean = function(deleteValue) {
  for (var i = 0; i < this.length; i++) {
    if (this[i] == deleteValue) {         
      this.splice(i, 1);
      i--;
    }
  }
  return this;
};

Array.prototype.set = function(key, value) {
  if (!this[key] || this.hasOwnProperty(key)) this[key] = value;
  return this;
}

String.prototype.contains = function(item, from){
  return this.indexOf(item, from) != -1;
}


toQueryString = function(obj) {
  var queryString = [];
  var quantity = 0;
  var pieces = [];
  $.each(obj, function(key, value){
    var single_piece = key + '=' + value;
    pieces.push(single_piece); 
  });

  return pieces.join('&');
};

String.prototype.parseQueryString = function() {
  var vars = this.split(/[&;]/);
  var rs = {};
  if (vars.length) {
    $.each(vars, function(i, val) {
      var pair = val.split('=');
      if (pair.length && pair.length == 2)  {
        rs[decodeURIComponent(pair[0])] = decodeURIComponent(pair[1].replace(/\+/g, '%20'));
      }
    });
  }
  return rs;
}

/*
 * Work-around for IE7 which does not properly support hovering menus
 */
if ($.browser === 'msie' && $.browser.version == '7.0') {
  $('#mainNav .dropDownContent a').hover(
    function() {
      $(this).parent('li').parent('ul').parent('div.dropDownContent').css('visibility', 'visible');
      $(this).parent('li').parent('ul').parent('li.navColumn').parent('ul').parent('div.dropDownContent').css('visibility', 'visible');
      $(this).parent('li').parent('ul').parent('li.navColumn').parent('ul').parent('li').parent('ul').parent('div.dropDownContent').css('visibility', 'visible');
    },
    function() {
      $(this).parent('li').parent('ul').parent('div.dropDownContent').css('visibility', 'hidden');
      $(this).parent('li').parent('ul').parent('li.navColumn').parent('ul').parent('div.dropDownContent').css('visibility', 'hidden');
      $(this).parent('li').parent('ul').parent('li.navColumn').parent('ul').parent('li').parent('ul').parent('div.dropDownContent').css('visibility', 'hidden');
    });
}

// Wrap the post action to include csrf key
$.ajaxPrefilter(function( options ) { //only wraps json requests
   // options.url = encodeURIComponent(options.url);
    if ( options.type.toLowerCase() == 'post'  ) {
      if ( (typeof DOAUTH !== "undefined") && DOAUTH == true) {
        options.data = options.data+'&authenticity_token='+ AUTH_TOKEN;
      }
    }
});

//on start of ajax function
$(document).ajaxSend(function(e, jqxhr, settings) {
  if (settings.dataType != "script") {
    if(typeof Spinner != 'undefined') {
      if (settings.show_spinner != false) {
        Spinner.show();
      }
    }
  }
});

//on success of ajax function
$(document).ajaxSuccess(function(e, xhr, settings) {
  if (settings.dataType != "script" && settings.dataType == 'json') {
   var data = jQuery.parseJSON(xhr.responseText);
   var settings = $.extend({}, data, settings);
   if (settings.error == "authentication") {
      if(settings.redirect) {
        $.modal('show', {source_url:settings.redirect, fixed_width: "400px", fixed_height: "270px", send_forms: true, aria_describedby: "aria_log_in"});
      } else {
        window.location.reload();
        return;
      }
    } else if (settings.custom_ils_error) {
     message = data.messages;
     custom_ils_error_popup(message[0].key);
     Messages.clear();
     $.fn.popout('hide_content');
   } else if (settings.reload) { 
      var url = window.location.href;
      var anchor_index = url.indexOf('#');
      if (anchor_index != -1) { url = url.substring(0, anchor_index); }
      window.location.href = url;
      return;
      
    }  else if (settings.static_html) {
      $.modal('show', {content:settings.static_html, send_forms: true, marked_for_reload: true});
    } else if (settings.html && (settings.render_as_popup)) {
      bind_live_plugins();
      $.modal('show', {content:settings.html, send_forms: true, marked_for_reload: true});
   }  else if (settings.redirect) {
      if(settings.render_as_popup){
        $.modal('show', {source_url:settings.redirect, send_forms: true, marked_for_reload: settings.marked_for_reload});
      } else {
        window.location.href = settings.redirect;
        return;
      }
    }
  }

  if(typeof Messages != 'undefined' && !settings.custom_ils_error) {
    Messages.show(settings.messages);
  }

  bind_live_plugins();
  if(typeof Spinner != 'undefined') {
    Spinner.hide();
  }
  $(this).trigger('contentchange');
});

//global ajax error handler

$(document).ajaxError(function(e, jqxhr, settings, exception){
  if (settings.show_spinner != false) {
    if(typeof Spinner != 'undefined') {
     Spinner.hide();
    }
  }
  console.error("Request Failed For: " + settings.url);
});

if($.browser.msie && $.browser.version.slice(0,3).indexOf("9") < 0) {
  // Allow us to pass variables to setInterval and setTimeout in Internet Explorer < 8 -> yes it's actually not normally allowed, it's crazy.                    
  (function (slice, Timeout, Interval) {
   function delegate(callback, $arguments) {
    $arguments = slice.call($arguments, 2);
      return function () {
        if((typeof callback.apply === "object" || typeof callback.apply === 'function') && callback.apply !== null) {
          callback.apply(null, $arguments);
        }
      };
    }
    window.setTimeout = function (callback, delay) {
      return Timeout(delegate(callback, arguments), delay);
    };
    window.setInterval = function (callback, delay) {
      return Interval(delegate(callback, arguments), delay);
    };
  }([].slice, setTimeout, setInterval));
}




// Foxy cart Helper Methods
var fc_minictart;

function silent_add_to_cart(e){
  var href = '';
  if (e.tagName == 'A') {
    href = e.href;
  } else if (e.tagName == 'FORM') {
    href = 'https://'+storedomain+'/cart?'+jQuery(e).serialize();
  }
  if (href.match("cart=(checkout|updateinfo)") || href.match("redirect=")) {
    return true;
  } else if (href.match("cart=view")) {
    /* Add your own modal window display logic here. Make sure to include the following:
       URL to load in the modal: href
       Call the following if an onClosed callback is available: fcc.events.cart.postprocess.execute(e)
    */
    return false;
  } else {
    // Add notification that product is being added here.
    jQuery.getJSON(href + '&output=json&empty=true&callback=?', function(data){
      // Automatically update JSON and minicart helper objects
      fcc.cart_update();
      FC.json = data
      fcc.events.cart.postprocess.execute();
      if($(e).attr('instantBuy')){
        window.location.href = "https://"+ storedomain +"/cart?cart=checkout";
      }
      // Add notification that the product has successfully been added here.
    });
    return false;
  }
}

function minicart_update(e, data) {
  fc_minicart = "";
  if($(".fc-cart-content") && typeof FC != "undefined") {
    for (i = 0; i < FC.json.products.length; i++) {
      fc_BuildFoxyCartRow(FC.json.products[i]);
    }
    // if you have some products in your cart, why not display it?
    if (typeof FC != "undefined" && FC.json.products.length > 0) {
      $(".fc-cart-content").show();
      $("#fc-empty-cart").hide();
      $(".fc-cart-content .cart-items").html(fc_minicart);      
    } else {
      $("#fc-empty-cart").show();
      $(".fc-cart-content").hide();
    }
  }
}

// This function is called by fc_BuildFoxyCart() for each product in your cart.
// Feel free to edit this function as needed to display each row of your cart.
function fc_BuildFoxyCartRow(product) {
  fc_minicart += "<tr class='fc_minicart_product'>";
  fc_minicart += "<td><img src='"+product.image+"'/></td>";
  fc_minicart += "<td>" + product.name + " - "+product.options.author+";&nbsp;<strong>"+product.options.format+"</strong><br><a class='fc_remove_item close_btn' href='https://"+sitedomain+".foxycart.com/cart?cart=update&output=json&quantity=0&id="+product.id+"'>Delete</a></td>";
  fc_minicart += "<td class=\"right-align\">"+product.quantity+ "<span class=\"disclaimer\">@ $"+fcc._currency_format(product.price_each)+"</span></td>";
  fc_minicart += "<td class=\"right-align\">$" + fcc._currency_format(product.price) +"</td>";
  fc_minicart += "</tr>";
}

function init_sharing() {
};

$('div.systemMessages div.sys_message a.close_btn').bind('click', function(e) {
  e.preventDefault();
  var hidden_ids = $.cookie('hidden_notices');
  var element_id = $(this).parent('div.sys_message').attr('id').replace(/[^0-9]/g,"");
  if(at_local_branch.length > 0){
    session = false;
  } else {
    session = 90;
  }
  if (hidden_ids){
    idArray = hidden_ids.split(":");
    idArray.push(element_id);
    $.cookie('hidden_notices', idArray.join(":"), { expires: session, path: '/' });
  } else{
    $.cookie('hidden_notices', element_id, { expires: session, path: '/' });
  }

  var how_many_msgs =  $(this).parent('div.sys_message').parent('div.systemMessages').find('div.sys_message').length;
  if (how_many_msgs > 1) {
    $(this).parent('div.sys_message').remove();
  } else {
    $(this).parent('div.sys_message').parent('div.systemMessages').remove();
  }
});

function email_check() {
  $('.modal-box').on('click', 'input#form_use_same_email', function(e) {
    var user_digital_email_textfield =  $('input#digital_email');
    var originalValue = user_digital_email_textfield.attr('data-original-email');
    if($("input#form_use_same_email").is(':checked')) {
      user_digital_email_textfield.removeAttr('disabled');
      user_digital_email_textfield.focus();
      user_digital_email_textfield.val("");
    } else {
      user_digital_email_textfield.attr('disabled', 'disabled');
      user_digital_email_textfield.val(originalValue);
    }
  });
}

var scrapes = 0;
var disabled = false;

(function( $ ) {
    $.fn.click_n_sub = function() {
      return this.each(function() {
        $(this).bind('click', function(e) {
          var $this= $(this);
          e.preventDefault();
          if (disabled == false) {
            scrapes++;
            if (scrapes >= 3) {
              disabled = true;
              $('.click_n_sub:not(.fetching)').html(od_localizations.wait_message);
              $('.digital_request span').html(od_localizations.wait_message);
            }
            $this.html(od_localizations.fetch_message);
            $this.addClass('fetching');
            $.getJSON(j_add_extension($(this).attr('href'), '.json'), function(data) {
              if(data.success && data.html) {
                $this.replaceWith(data.html);
                scrapes--;
                if ((scrapes <= 2) && (disabled == true)) {
                  disabled = false;
                  $('.click_n_sub:not(.fetching)').html(od_localizations.request_available);
                  $('.digital_request span').html(od_localizations.digital_request);
                }
              }
            });
          }
        });
      });
    };
  })( jQuery );

/** To support Array.indexOf in IE8
    Taken from https://developer.mozilla.org/en-US/docs/JavaScript/Reference/Global_Objects/Array/indexOf
    Under Creative Commons: Attribution-Sharealike license v2.5
 **/
if (!Array.prototype.indexOf) {
    Array.prototype.indexOf = function (searchElement /*, fromIndex */ ) {
        "use strict";
        if (this == null) {
            throw new TypeError();
        }
        var t = Object(this);
        var len = t.length >>> 0;
        if (len === 0) {
            return -1;
        }
        var n = 0;
        if (arguments.length > 1) {
            n = Number(arguments[1]);
            if (n != n) { // shortcut for verifying if it's NaN
                n = 0;
            } else if (n != 0 && n != Infinity && n != -Infinity) {
                n = (n > 0 || -1) * Math.floor(Math.abs(n));
            }
        }
        if (n >= len) {
            return -1;
        }
        var k = n >= 0 ? n : Math.max(len - Math.abs(n), 0);
        for (; k < len; k++) {
            if (k in t && t[k] === searchElement) {
                return k;
            }
        }
        return -1;
    }
}
