/*
	Static Class: Messages
	desc: message and error brokering
*/

var Messages = function() {
  return {
    show: function(messages) {
      if (messages && messages.length > 0) {
        Messages.clear();
        for (var i=0; i < messages.length; i++) {
          var message = messages[i];
          var message_consumed = false;
          for (var j = message.space.length; j >= 0 && !message_consumed; j--){
            var search_key = jQuery.makeArray(message.space.slice(0,j));
            for (var k = registered_messages.length - 1; k >= 0 && !message_consumed; k--){
              if (registered_messages[k].key.join("/") == search_key.join("/") && jQuery.inArray(message.type, jQuery.makeArray( registered_messages[k].type)) > -1) {
                if ($('#' + registered_messages[k].element).length > 0) {
                  var message_block = $('#' + registered_messages[k].element).parent('.messageContent').parent('.messaging');
                  var visible = true;
                  var parent = message_block.parent();

                  var visible = parent.css('display') != 'none' && parent.css('visibility') != 'hidden';
                  if (message_block.length > 0 && visible) {
                    var message_text = (message.key) ? message.key : registered_messages[k].default_message;
                    var new_message_text = message_text.strip_scripts(); //lets never eval again

                    $('#' + registered_messages[k].element).append('<p>' + new_message_text + '</p>');

                    message_block.addClass('displayMessage');

                    message_block.addClass(message.type);
                    message_consumed = true;
                  } else if (registered_messages[k].mode == 'suppress') {
                    message_consumed = true;
                  }
                }
              }
            }
            if(!message_consumed){
              
              // if you couldn't find a place to put the message then put it at the top.
              // this is a stop gap pending a more formal refactor of this code.
              // a better solution can be found here
              // http://stackoverflow.com/questions/366311/how-do-you-handle-rails-flash-with-ajax-requests
              
              var message_block = $('.top_message').parent('.messageContent').parent('.messaging');
              var visible = true;
              var parent = message_block.parent();

              var visible = parent.css('display') != 'none' && parent.css('visibility') != 'hidden';
              if (message_block.length > 0 && visible) {
                var message_text = (message.key) ? message.key : registered_messages[k].default_message;
                var new_message_text = message_text.strip_scripts(); //lets never eval again

                $('.top_message').append('<p>' + new_message_text + '</p>');

                message_block.addClass('displayMessage');

                message_block.addClass(message.type);
                message_consumed = true;
              } else if (registered_messages[k].mode == 'suppress') {
                message_consumed = true;
              }
            }
          }
        }
      }

    },
    clear: function() {
      for (var i=0; i < registered_messages.length; i++) {
        if ($('#' + registered_messages[i].element) && $('#' + registered_messages[i].element).parent('.messageContent').parent('.messaging')) {
          var msg_dom = $('#' + registered_messages[i].element);
          msg_dom.parent('.messageContent').parent('.messaging').removeClass('displayMessage');
          msg_dom.parent('.messageContent').parent('.messaging').removeClass('error');
          msg_dom.parent('.messageContent').parent('.messaging').removeClass('message');
          msg_dom.html('');
        }
      };
    }
  };
}();