// testing lines
// v2

(function() {

	// Localize jQuery variables
	var jQuery;
	var $;

	//
	// control variables for this chat widget
	//
	var _chats = {};      // object of chats:  _chats.ChatId = {ChatId, LineId} , _chats.chat_id.LineId
	var _chat_type = '';  // patron or agent

	var _chat_update_interval = 2000;
	var _title_interval = '';
	var _update_interval = '';
	var _update_running = 0;
	var _failed_updates = 0;
	var _allow_update_retry = 0;

	var _keyword        = 'askbplCA';
	var _widget_number  = '';
	var _mosio_popout_chat = 0; // controls style sheet loading
	var _mosio_popout_url = 'https://chat.mosio.com/par/chat/new_chat/askbplCA';
	var _mosio_popout_ref = '';
	var _original_title = '';
	var _widget_base_id = 'mosio_widget_expanded'; // used to parse chat ID from widget element id
	var _front_zindex = 1000;
	
	var _has_focus = 1;
	var _allow_title_flash = 1;
	var _clear_flash_handler;
	var _css_aaq_loaded = 0;
	var _hide_tab = 0;

	var _allow_sounds = '0';
	
	var _chat_id_cookie_name = 'mosio_chat_session';
	
	var _is_embedded = 0;
	var _is_literati = 0;
	
	var _debug = 0;

	

	//
	// Always load our own jquery, it is a combined file of jquery & jqueryui
	//
	var script_tag = document.createElement('script');
	script_tag.setAttribute("type","text/javascript");
	script_tag.setAttribute("src", "../../content/home/js/widget_chat_jquery_ui-1.7.2.min.js");
	if (script_tag.readyState) {
		script_tag.onreadystatechange = function () { // For old versions of IE
			if (this.readyState == 'complete' || this.readyState == 'loaded') {
				handler_script_onload();
			}
		};
	}
	else {
		script_tag.onload = handler_script_onload;
	}
	// Try to find the head, otherwise default to the documentElement
	(document.getElementsByTagName("head")[0] || document.documentElement).appendChild(script_tag);




	/**
	* Called when jQuery files is loaded.  Runs noConflict, sets the $ alias 
	* locally, then calls the jQuery ready function.
	*/
	function handler_script_onload() {
		// Restore $ and window.jQuery to their previous values and store the
		// new jQuery in our local jQuery variable
		jQuery = window.jQuery.noConflict(true);

		// set local alias for $ var
		$ = jQuery;


		if (window.jQuery !== undefined) {
			append_error('Window Jquery version: ' + window.jQuery.fn.jquery);
		}
		append_error('function Jquery version: ' + jQuery.fn.jquery);

		
		// save document's original title for resetting after flashing title notification
		_original_title = jQuery(document).attr('title');
		
		//
		// set jQuery ready 
		//
		jQuery(document).ready(function($) {
			//
			// Load CSS
			//
			
			if ( ! _mosio_popout_chat) {
				// load css to style widget
				// _mosio_popout_chat already loads the css it needs
			
				var css_link = $("<link>", { rel: "stylesheet", type: "text/css", href: "https://chat.mosio.com/par../widget_styled.css?" + Math.floor(Math.random()*10000000) } );
				css_link.appendTo('head');
				
				if (_is_embedded) {
					var css_link = $("<link>", { rel: "stylesheet", type: "text/css", href: "https://chat.mosio.com/par../widget_embed.css?" + Math.floor(Math.random()*10000000) } );
					css_link.appendTo('head');
				}
			
			}

			if ('' == _keyword) {
				//
				// no keyword, invalid widget
				//
				console.info('Invalid keyword, not loading.');
			}
			else {
				//
				// initialize page
				//
				var jsonp_url = "https://chat.mosio.com/par/chat/cb_init_page?callback=?";
				var json_params = { "keyword" : _keyword, "mosio_chat_session" : readCookie(_chat_id_cookie_name), "wid" : _widget_number };
				
				jQuery.getJSON(jsonp_url, json_params, function(data) { return cb_init_page(data); });

				// add handler to check window focus for title notification
				window.onblur = function () { _has_focus = 0; };
				window.onfocus = function () { _has_focus = 1; };
			}
			
		});
	}




	/**
	* Initialize the page.
	*   Patrons : load the tab, add a click handler
	*		Data    : { type, html }
	*
	*   Agents  : initialize all live chats
	*		Data    : { type, <data for initialize_chats> }
	*
	*/
	function cb_init_page(data) {
		// check data
		if (typeof data === 'undefined' || ! data) {
			alert("Cannot load chat widget.");
			return;
		}

		_allow_title_flash = 0;
		
		if (typeof data.type !== 'undefined') {
			// set chat type
			_chat_type = data.type;
			addDataHtml(data);

			if ('patron' == data.type) {
				// add handler to tab to expand into window on click
				//$('#mosio_widget_tab').click( function () { handler_patron_start_chat(); });
				$('#mosio_widget_tab').click( function () { handler_patron_start_chat_popout(); });
				
				if (_is_embedded || data.has_chat) {
					// start a chat if this is embedded widget, or if live chat is found
					handler_patron_start_chat();
				}
				
				//
				// Update tab image
				//

				if (_hide_tab) {
					// hide-tab option set, do not display tab
					jQuery('#mosio_widget_tab').css( {backgroundImage : 'none', backgroundColor : 'transparent', width: '1px', height: '1px' } );
				}
				else if (typeof data.tab_url !== 'undefined' && data.tab_url.length) {
					// custom tab
					jQuery('#mosio_widget_tab').css( 
						{
							backgroundImage : 'url(' + data.tab_url + ')', 
							width:  data.tab_width + 'px', 
							height: data.tab_height + 'px',
							top:    data.tab_top,
							bottom: data.tab_bottom,
							left:   data.tab_left,
							right:  data.tab_right
						} 
					);
				}
				else {
					// default tab
					jQuery('#mosio_widget_tab').css('background-image', 'url(https://chat.mosio.com/par/images/widget/tab_aaq2.png)');
					
					// look for custom placement
					if (typeof data.tab_top !== 'undefined' && data.tab_top.length) {
						jQuery('#mosio_widget_tab').css( 
							{
								top:    data.tab_top,
								bottom: data.tab_bottom,
								left:   data.tab_left,
								right:  data.tab_right
							} 
						);
					}
				}
				
				if (_is_literati) {
					append_error('updating widget placement to 10%');
					jQuery('#mosio_widget_tab').css('top', '10%');
				}
				
			}
			else if ('agent' == data.type) {
				initialize_chats(data);
			}
		}
		
		append_error(data);

		_allow_title_flash = 1;
	}


	/**
	* Start a chat by getting a chat Id from the server
	*/
	function handler_patron_start_chat() {
    if ('agent' == _chat_type) {
    	// agent does not start a chat
    	return;
    }

		if ( ! _mosio_popout_chat && ! _is_embedded) {
			// no longer show chat window on website.  Only show in pop-out
			return;
		}

 		// hide the tab
		jQuery('#mosio_widget_tab').hide();

   	// close any chat windows that currently exist
   	$('div.mosio_chat_window a.mosio_close_btn').click();
   	
   	// get widget html & chat ids (patron only gets one id)
    var jsonp_url = "https://chat.mosio.com/par/chat/cb_init_widget?callback=?";
    
    $.getJSON(jsonp_url, { "keyword" : _keyword, "mosio_chat_session" : readCookie(_chat_id_cookie_name) }, function(data) {
    	
    	addDataHtml(data);

    	if (typeof data.is_contact_form != 'undefined' && data.is_contact_form) {
    		initialize_aaq(data);
    	}
    	else {
    		initialize_chats(data);
    	}

			if ( ! _is_embedded && ! data.has_chat && ! data.is_contact_form) {
				//alert("showing");
				jQuery('#mosio_widget_tab').show();
			}
  	});
	}


	/**
	* new popout chat
	*/
	function handler_patron_start_chat_popout() {
    if ('agent' == _chat_type) {
    	// agent does not start a chat
    	return;
    }

		mosio_chat_window = window.open(_mosio_popout_url,'mosio_chat','height=430,width=490');
		if (window.focus) {
			mosio_chat_window.focus();
		}
		return false;
	}


	/**
	* initialize the Ask A Question module
	*/
	function initialize_aaq(data) {
		
		if ( ! _mosio_popout_chat && ! _css_aaq_loaded) {
			// append ask a question form CSS
			var css_link = $("<link>", { rel: "stylesheet", type: "text/css", href: "https://chat.mosio.com/par../widget_ask_a_question.css?" + Math.floor(Math.random()*10000000) } );
			css_link.appendTo('head');
			_css_aaq_loaded = 1;
		}
		
		// add handler to submit button for Ask A Question
		jQuery('#mosio_ask_a_question .mosio_submit_aaq').click( function () {  ask_question(this); });
	
		// add handler to close link
		jQuery('#mosio_ask_a_question .mosio_close_btn').click( function () { close_chat_window( jQuery(this).parent()); jQuery('#mosio_widget_tab').show(); } );
		
		
		// add handler for when response method changes, update examples
		jQuery('#response_method_chat').click( 
			function () {  
				jQuery('input.mosio_response_address').attr('placeholder', '').hide()
				jQuery('.mosio_example').text('');
			} 
		).click(); // fire!
		jQuery('#response_method_email').click( 
			function () {  
				jQuery('input.mosio_response_address').attr('placeholder', 'Enter Email Address').show();
				jQuery('.mosio_example').text('ex: myemail@example.com');
			} 
		);
		jQuery('#response_method_sms').click( 
			function () {  
				jQuery('input.mosio_response_address').attr('placeholder', 'Enter Mobile Number').show();
				jQuery('.mosio_example').text('ex: 415-555-5555');
			} 
		);

		
		
		// bring to front
		jQuery('#mosio_ask_a_question').css('zIndex', _front_zindex);
		_front_zindex++;
		

		if ( ! _is_embedded) {
			add_draggable('#mosio_ask_a_question');
		}
	}

	/**
	* Loop through a list of new_chat_ids, and initialize the chats from chat_window_html
	* 
	* Data :   { new_chat_ids, chat_window_html }
	*/
	function initialize_chats(data) {

		if (typeof data.new_chat_ids === 'undefined') {
			//append_error("No chat ids found.");
			return false;
		}

		if (typeof data.chat_window_html === 'undefined') {
			append_error("Cannot load new chat window html");
			return false;
		}
		
		//
		// loop through new chat ids
		// load the chat windows
		// add to master _chats object
		//
		
		
		// chat counter for positioning
		var chat_count = jQuery('.mosio_chat_window').length; // # of chats currently open

		for (var idx2 in data.new_chat_ids) {
			//append_error("Loop index: " + idx2);
			chat_id = data.new_chat_ids[idx2];

			if ('______array' == chat_id) {
				//console.info('Chat Id is ______array, skipping');
				continue;
			}

//			append_error('new chat ids constructor: ' + chat_id.constructor);
//			append_error(typeof chat_id);
//			if (typeof chat_id == 'string') {
//				append_error("String value: " + chat_id);
//			}

			//append_error("INIT: Checking " + chat_id);

			if (typeof _chats[chat_id] !== 'undefined') {
				if (_chats[chat_id].ChatId == chat_id) {
					//append_error("already have chat_id: " + chat_id);
				}
				else {
					append_error("Chat ID not undefined, but does not match: " + chat_id + ' - ' + _chats.chat_id.ChatId);
				}
				continue;
			}
			
			
			if (typeof data.chat_window_html[chat_id] === 'undefined' || ! data.chat_window_html[chat_id]) {
				//append_error("Cannot load chat window for chat id.");
				//append_error("Cannot load chat window for chat id: " + chat_id);
				//append_error("type: " + typeof data.chat_window_html[chat_id]);
				//append_error('New chat ids length: ' + data.new_chat_ids.length);
				continue;
			}
			

			_chats[chat_id] = {ChatId : chat_id, LineId : 0}

			//append_error(data.chat_window_html[chat_id]);
			
			// load html
			//console.log('calling addhtml from initialize_chats - ' + typeof data.chat_window_html[chat_id]);
			//console.log(data.chat_window_html[chat_id]);
			//console.log(data.chat_window_html);
			//console.log('--- ' + [].toString() + ' ---');
			addHtml(data.chat_window_html[chat_id]);
			
			// immediately expand chats
			chat_elem_id = '#mosio_widget_expanded' + chat_id;

			
			if ( ! _is_embedded) {

				// position this chat window
				chat_count++;
				var step_width = 60;
				var pos_right = chat_count * step_width;
				append_error('screen width: ' + screen.width + ', pos right: ' + pos_right);
				if (pos_right > (screen.width - step_width)) {
					pos_right = Math.floor(Math.random()*800);
					append_error('too far, now: ' + pos_right);
				}
				$(chat_elem_id).css({ position: 'fixed', bottom: '0px', right: pos_right + 'px'});


				add_draggable(chat_elem_id);
//				//
//				// add draggable for movement
//				// need to set width & height, after movement .mosio_chat_window div just gets expanded, 
//				// need to return it to regular size so it does not hide elements from being clicked on
//				//
//				var width_pre = $(chat_elem_id).css('width'); // also used below for draggable resetting on stop
//				var height_pre = $(chat_elem_id).css('height');
//				$(chat_elem_id).draggable({ cursor: "move", handle: "div.handlebar", stack: ".mosio_chat_window", addClasses: false, 
//					start: function(event, ui) { 
//									append_error('width post: ' + $(this).css('width'));
//									append_error('height post: ' + $(this).css('height'));
//									$(this).css( {width: width_pre, height: height_pre});
//								},
//	
//					stop: function(event, ui) { 
//									append_error('width post: ' + $(this).css('width'));
//									append_error('height post: ' + $(this).css('height'));
//									$(this).css( {width: width_pre, height: height_pre});
//								}
//					
//					 });
			}
			
			
//			// show the window
//			$(chat_elem_id).show();
			
			
			// catch enter key pressed in textarea, but not shift-enter
			$(chat_elem_id + ' .mosio_textarea').keyup( function (k) { catchEnter(k, this); } );

			// add handler to submit button to send text
			$(chat_elem_id + ' .mosio_submit').click( function () { add_line(this); });

			// add a handler to the stop chat link
			$(chat_elem_id + ' .mosio_stop_btn').click( function () { stop_chat(true, this); } );

			// add handler to close link
			$(chat_elem_id + ' .mosio_close_btn').click( function () { close_chat_window(this); } );
			
			// add handler to restart link
			$(chat_elem_id + ' .mosio_restart_btn').click( function () { restart_chat_window(this); } );
			
			
			// bring to front
			$(chat_elem_id).click( 
					function () { 
							$(this).css('zIndex', _front_zindex);
							if ($('div.mosio_handlebar', this).length) {
								$('div.mosio_handlebar', this).css('zIndex', _front_zindex);
							}
							_front_zindex++;
							append_error('zIndex: ' + _front_zindex);
							return true;
					} 
			);
			//$(chat_elem_id).mousedown( function () { $(this).css('zIndex', _front_zindex); _front_zindex++; append_error('zIndex: ' + _front_zindex); return true; } );
			
			// focus on textarea
			//$(chat_elem_id + ' .mosio_textarea').click( function () { $(this).focus(); } );
			
			
			// flash title
			flash_title('New Chat! (' + jQuery('.mosio_chat_window').length + ')');
			playSound(1);
			
			//
			// IE 9 giving problems on some pages, delay showing window by 0.1 seconds
			//
			setInterval( function () { $(chat_elem_id).show(); }, 100);
			
			
			if ('patron' == _chat_type) {
				set_chat_id_cookie(chat_id);
			}
			
			
		}

		// start updating chats
		start_updating();
		
		
		//append_error("New _chats: " + JSON.stringify(_chats));
		
	}


	/**
	* Make an element draggable, supply the ID
	*/
	function add_draggable(chat_elem_id) {
		//
		// add draggable for movement
		// need to set width & height, after movement .mosio_chat_window div just gets expanded, 
		// need to return it to regular size so it does not hide elements from being clicked on
		//
		
		if ($('div.mosio_handlebar', $(chat_elem_id)).length) {
		
			var width_pre = $(chat_elem_id).css('width'); // also used below for draggable resetting on stop
			var height_pre = $(chat_elem_id).css('height');
			$(chat_elem_id).draggable({ cursor: "move", handle: "div.mosio_handlebar", stack: ".mosio_chat_window", addClasses: false, zIndex : _front_zindex,
				start: function(event, ui) { 
//								append_error('width post: ' + $(this).css('width'));
//								append_error('height post: ' + $(this).css('height'));
								$(this).css( {width: width_pre, height: height_pre});
							},
	
				stop: function(event, ui) { 
//								append_error('width post: ' + $(this).css('width'));
//								append_error('height post: ' + $(this).css('height'));
								$(this).css( {width: width_pre, height: height_pre});
								$(this).css('zIndex', _front_zindex); 
								_front_zindex++; 
							}
				
				 });
				 
		}
	}



	/**
	* check server for updates from other side of chat
	*/
	function update_chats() {
		//
		// check if update is already running
		//
		
		//append_error('running: update chats');
		
		if (_update_running) {
			_failed_updates++;
			console.info("Update already running.");
		}
		
		
		if ( ! _allow_update_retry) {

			if (_failed_updates > 15) {
				// too many failed updates stop updating altogether
				append_error("Cannot update chat anymore.");
				append_error("Please reload page");
				if ('agent' == _chat_type) {
					if (jQuery('#chat_agents_online').length) {
						jQuery('#chat_agents_online').html('<div class="error reconnecting_to_chat">Connection error, reconnecting to chat server.</div>');
						//jQuery("#chat_status_online").hide(); 
						//jQuery("#chat_status_offline").hide();
						stop_updating();
						setTimeout( function () { _allow_update_retry = 1; start_updating(); }, 5000);
					}
					else {
						// only alert as last resort
						alert("Trouble updating chat, please reload page.");
						stop_updating();
					}
				}
				return;
			}

			if (_failed_updates > 10) {
				// pause for some seconds, then re-start updating
				// set _allow_update_retry to skip the failure checking on the first delayed run
				stop_updating();
				setTimeout( function () { _allow_update_retry = 1; start_updating(); }, 5000);
				append_error("stopping updating, waiting a few seconds, then starting again. " + _failed_updates);
				jQuery('#chat_agents_online').html('<div class="notify reconnecting_to_chat">Connection error, reconnecting to chat server.</div>');
				return;
			}

		}
		
		
		// reset _allow_update_retry, this is only set after delayed updating due to failures
		_allow_update_retry = 0;
		

		if (_update_running) {
			return;
		}


		
		_update_running = 1;  // limits the amount of updates we can run at the same time.
		
		
		// force set chats
		//_chats = { "KIPQIANNBMHFZM" : {ChatId : "KIPQIANNBMHFZM", LineId : 0, ManuallySet : 1} };
		
		
		// call server for actual update
		//var json_chats = JSON.stringify(_chats);
		//var jsonp_url = "https://chat.mosio.com/par/chat/cb_update_chats?json=" + json_chats + "&callback=?";
		var jsonp_url = "https://chat.mosio.com/par/chat/cb_update_chats?callback=?";

		//append_error('---');
		//append_error(json_chats);
		//append_error('update chats: ' + jsonp_url);
		//append_error('---');

		jQuery.getJSON(jsonp_url, {json : _chats, keyword : _keyword}, function(data) { cb_update_chats(data);  _update_running = 0; _failed_updates = 0; jQuery('#chat_agents_online div.reconnecting_to_chat').remove(); })
			.error(function() { _update_running = 0; _failed_updates++; append_error('Chat update failed: ' + _failed_updates); }); // append a function to clean up on error
	}


	/**
	* patron sends a message via the web interface, notify the server, update display
	*/
	function add_line(submit_btn_obj) {

		chat_obj = $(submit_btn_obj).parent().parent().parent();
		w_id = '#' + $(chat_obj).attr('id');
		
		chat_id = getChatIdFromWidgetId(w_id);

		append_error("adding line to chat_id: " + chat_id);


		// set line_id
		line_id = 0;
		for (var idx in _chats) {
			if (_chats[idx].ChatId == chat_id) {
				line_id = _chats[idx].LineId;
			}
		}

    if (typeof chat_id === "undefined" || ! chat_id.length) {
    	// no chat id set, start the chat over
    	append_error('no chat id set.  window id: ' + w_id);
    	return;
    }

		//
		// Check text was entered, warn if not
		//
		if ( ! $(w_id + ' .mosio_textarea').val().length) {
			append_error('textarea val: (' + $(w_id + ' .mosio_textarea').val() + ')');
			$(w_id + ' .mosio_widget_messages').append("<p>please enter some text</p>");
			$(w_id + ' .mosio_widget_messages p').fadeOut(5000);
			return;
		}

		append_error('textarea val: (' + $(w_id + ' .mosio_textarea').val() + ')');


		// pause updating
		stop_updating();

    // ping server to add line
    var jsonp_url = "https://chat.mosio.com/par/chat/cb_add_line?chat_id=" + chat_id + "&line_id=" + line_id + "&callback=?";
   	$.getJSON(jsonp_url, {new_line : $(w_id + ' .mosio_textarea').val()}, function(data) { cb_update_chats(data); });

   	// clear textarea
   	$(w_id + ' .mosio_textarea').val('').focus();
	}


	/**
	* Update the chat display after sending or receiving a message.  
	* This is the call back handler for:
	*   update_chats()
	*   add_line()
	*/
	function cb_update_chats(data) {
		//
		// loop through all chats and update displays
		//
		
		//append_error('starting cb_update_chats');
		
		for (var idx in _chats) {

			//append_error('cb_update_chats :: loop index: ' + idx);
			
			if (typeof _chats[idx] === 'undefined') {
				append_error('Chat index idx is undefined: ' + idx);
				continue;
			}
			
			var chat = _chats[idx];

			if (typeof chat.ChatId === 'undefined') {
				append_error('Chat id is undefined: ' + idx);
				continue;
			}

			var chat_id = chat.ChatId;
			var chat_elem_id = '#mosio_widget_expanded' + chat_id;
			var chat_data = data[chat_id];
			
			//console.info(chat_data);
			
			// make sure chat_id is found in data returned, add_line only returns one chat's worth of data
			if (typeof chat_data === 'undefined') {
				append_error('chat_data undefined');
				continue;
			}
			
			//
			// update line_id for chat
			//
			if (_chats[idx].LineId < chat_data.line_id) {
				_chats[idx].LineId = chat_data.line_id;
				append_error("new line_id (" + chat_data.line_id + ") for chat: " + chat_id);
			}
			else {
				//append_error("NOT ADDING:  line_id (" + chat_data.line_id + ") for chat: " + chat_id);
			}

			//
			// update display
			//
			update_display(chat_data, chat_elem_id);
		}
		

		if (typeof data.play_sound != 'undefined' && data.play_sound) {
			append_error('playing sound: ' + data.play_sound);
			playSound(0);
		}



		// initialize any new chats
		if (_mosio_popout_chat) {
			initialize_chats(data);
		}
		
		// update chat agents online for agents
		if (typeof data.agent_online_html !== 'undefined' && jQuery('#chat_agents_online').length) {
			jQuery('#chat_agents_online').html(data.agent_online_html);
		}

		
		append_error(data);
	}


	/**
	* Update the chat display after sending or receiving a message
	*/
	function update_display(data, w_id) {
		// update html

		if (typeof data === 'undefined') {
			append_error("Data is undefined for Widget ID: " + w_id);
			return;
		}


		if (typeof data.html != 'undefined' && data.html.length) {
			$(w_id + ' .mosio_widget_chat').append(data.html);
			//$(w_id + ' .mosio_widget_chat').animate({ scrollTop: $(w_id + ' .mosio_widget_chat').attr("scrollHeight") }, 0);
			$(w_id + ' .mosio_widget_chat').animate({ scrollTop: 100000 }, 0);
			
			if ( ! _has_focus) {
				flash_title('New Message in Chat!');
			}
			
		}


		if (typeof data.chat_finished != "undefined" && data.chat_finished) {
			append_error("Other side has left the chat.");
			stop_chat(false, w_id);
			return;
		}

		append_error(data);

		if (typeof data.reload_page != "undefined" && data.reload_page) {
			alert("Please reload this page.");
			stop_updating();
			return;
		}

		start_updating();  // safe to call even if currently updating, needed by add_line
	}







	/**
	* Stop a chat
	*/
	function stop_chat(cb_server, stop_btn_obj_or_w_id) {
		if (typeof stop_btn_obj_or_w_id == 'object') {
			chat_obj = $(stop_btn_obj_or_w_id).parent().parent().parent();
			w_id = '#' + $(chat_obj).attr('id');
		}
		else {
			w_id = stop_btn_obj_or_w_id;
		}

		jQuery(w_id + ' .mosio_submit').remove();
		jQuery(w_id + ' .mosio_stop_btn').remove();
		jQuery(w_id + ' .mosio_close_btn').show();
		
		
		//jQuery(w_id + ' .mosio_textarea').attr("placeholder", "Chat stopped, please close to start a new chat.").attr("disabled", "true");
		jQuery(w_id + ' .mosio_textarea').val('Chat stopped, please close to start a new chat.').attr("disabled", "true").css( { backgroundColor : '#f0f0f0', color : '#000' } );
		
		chat_id = getChatIdFromWidgetId(w_id);

		// remove this from chats
		var new_chats = {};
		for (var idx in _chats) {
			if (idx != chat_id) {
				new_chats[chat_id] = _chats[idx];
			}
		}
		_chats = new_chats;

		if ('patron' == _chat_type) {
			// patrons always stop updating after chat is over
			// agents never stop updating
			stop_updating();
			
			if ( ! _is_embedded) {
				// show tab again
				jQuery('#mosio_widget_tab').show();
			}
			else {
				// embedded, show restart chat button, hide close button
				jQuery(w_id + ' .mosio_close_btn').hide();
				jQuery(w_id + ' .mosio_restart_btn').show();
			}
		}

    if (cb_server) {
    	append_error("pinging server to stop chat");
	    var jsonp_url = "https://chat.mosio.com/par/chat/cb_stop_chat?chat_id=" + chat_id + "&callback=?";
	    $.getJSON(jsonp_url, function(data) { append_error(data); });
		}

		append_error('Chat has been stopped.');


		console.log('new chats after stopping: ');
		console.log(_chats);
		
		return false;
	}


	/**
	* Delete the div containing a chat window
	*/
	function close_chat_window(close_btn_obj) {
		chat_obj = $(close_btn_obj).parent().parent().parent();
		w_id = '#' + $(chat_obj).attr('id');

		$(w_id).remove();
	}


	/**
	* Start a new chat after a patron has closed an embedded chat
	*
	*/
	function restart_chat_window(restart_btn_obj) {
		close_chat_window(restart_btn_obj);
		handler_patron_start_chat();
	}
	

	/**
	*
	*/
	function ask_question(submit_btn_obj) {
		var question = jQuery('#mosio_ask_a_question .mosio_textarea').val();
		var response_method = jQuery("input:radio[name='mosio_response_method']:checked").val();
		var response_address = jQuery('#mosio_ask_a_question .mosio_response_address').val();
		
    console.info({ "keyword" : _keyword, "question" : question, "response_method" : response_method, "response_address" : response_address});
    
    // change send button text
    jQuery('#mosio_ask_a_question .mosio_submit_aaq').text('Sending...');
    
    jQuery('#mosio_ask_a_question .mosio_notify').html('').hide();
    
    var jsonp_url = "https://chat.mosio.com/par/chat/cb_ask_question?callback=?";
    
    var json_params = { "keyword" : _keyword, 
    										"question" : question, 
    										"response_method" : response_method, 
    										"response_address" : response_address, 
    										"ref" : _mosio_popout_ref
    									};
    

    // chat requested from embedded widget, pop out window with new chat question
    if (_is_embedded && ! _mosio_popout_chat && 'chat' == response_method) {
    	// starting an embedded chat, show pop-out now
			var new_chat_url = _mosio_popout_url + '/0?question=' + escape(question);
			console.log(new_chat_url);
			mosio_chat_window = window.open(new_chat_url,'mosio_chat','height=430,width=490');
			if (window.focus) {
				mosio_chat_window.focus();
			}

			jQuery('#mosio_ask_a_question .mosio_textarea').val('');
			jQuery('#mosio_ask_a_question .mosio_response_address').val('');
			jQuery('#mosio_ask_a_question .mosio_notify').html('Starting chat in a new window').show();
			jQuery('#mosio_ask_a_question .mosio_submit_aaq').text('Submit');

    	return;
    }



   	jQuery.getJSON(jsonp_url, json_params, 
		   							function(data) {
									   	// clear textarea
									   	if (typeof data.success != 'undefined' && data.success) {
										   	jQuery('#mosio_ask_a_question .mosio_textarea').val('');
										   	jQuery('#mosio_ask_a_question .mosio_response_address').val('');
										  }
									   	//jQuery('#mosio_ask_a_question .mosio_notify').html(data.response).stop(true, true).show().fadeOut(7000);
									   	jQuery('#mosio_ask_a_question .mosio_notify').html(data.response).show();
							   	    jQuery('#mosio_ask_a_question .mosio_submit_aaq').text('Submit');
							   	    
							   	    if (typeof data.force_reload != 'undefined' && data.force_reload) {
							   	    	// started chat, reload page to show it
							   	    	window.location.reload();
							   	    }
		
		   		 					}
   		 						);
	}





	/**
	* Catch enter on keypress & submit, but not shift-enter
	*/
	function catchEnter(k, textarea_obj) {

		chat_obj = $(textarea_obj).parent().parent();
		w_id = '#' + $(chat_obj).attr('id');

		if (k.keyCode == 13) {
			append_error('enter caught');
			if (k.shiftKey !== true) {
				// submit line
				add_line($(w_id + ' .mosio_submit'));
			}
			return false;
		}
	}









	/******************************************************************
	*
	*
	*  Helper functions
	*
	*
	******************************************************************/









	/**
	* Add data.html to window in appropriate place
	*/
	function addDataHtml(data) {
//		console.log('1: ' + typeof data + "\n" + typeof data.html);
//		console.log(data);
		if (typeof data === 'undefined' || ! data) {
			return false;
		}

		if (typeof data.html !== 'undefined' && data.html) {
		//if (typeof data.html === 'string' && data.html) {
//			console.log('2: ' + typeof data.html);
//			console.log('--2--');
//			console.log(data.html);
			addHtml(data.html);
			return true;
		}
		
		// alert any notify's in the params
		if (typeof data.notify !== 'undefined' && data.notify) {
			alert(data.notify);
		}
		
		
		return false;
	}


	/**
	* Add an html string to the widget container
	*/
	function addHtml(new_html) {
		if ('______array' == new_html) {
			// ignore ______array marker ([].toString())
			return;
		}
		
		//
		// append html
		//
		//console.log('3: ' + typeof new_html + "\n" + new_html);
		if ($('#mosio-widget-container').length > 0) {
			$('#mosio-widget-container').append(new_html);
		}
		else {
			// create the mosio-widget-container element
			$('body').append('<div id="#mosio-widget-container">' + new_html + '</div>');
		}
	}




	/**
	* Set an interval to check for updates to the chat
	*/
	function start_updating() {
		if ('' == _update_interval) {
			//_update_interval = setInterval( function () { update_chats(); append_error('post: ' + JSON.stringify(_chats)); }, 7000);
			//_update_interval = setTimeout(update_chats, 1000); // run the update only once
			
			// call right away
			update_chats();
			//append_error('setting update interval');
			_update_interval = setInterval(update_chats, _chat_update_interval);
		}
	}


	/**
	* Clear interval checking for updates to the chat
	*/
	function stop_updating() {
		console.info("called stop_updating, chat type: " + _chat_type);
		if (_update_interval != "") {
			clearInterval(_update_interval);
			_update_interval = "";
		}
	}


	/**
	* Flash browser title to get attention for new chat
	*/
	function flash_title(new_title) {
		if (_allow_title_flash) {
			if (typeof scrollWindowTitle == 'function') {
				// use title function already in mo' platform
				//append_error('Flashing scrollWindowTitle.');
				scrollWindowTitle(_original_title, new_title + ' ');
			}
			else {
				append_error('Flashing updateWindowTitle.');
				updateWindowTitle(new_title);
			}
		}
		else {
			append_error('not flashing.');
		}
	}
	
	
	/**
	* Flash title for new message notification
	*/
	function updateWindowTitle(new_title) {
		if ('' == _title_interval) {
			_title_interval = setInterval(function() {document.title = document.title == new_title ? '*** ' + new_title + ' ***' : new_title;}, 500);
    	//window.onmousemove = function() { clearInterval(_title_interval); document.title = _original_title; window.onmousemove = null; _title_interval = '';};
    	
    	_clear_flash_handler = 
    		function(event) { 
    					clearInterval(_title_interval); 
    					document.title = _original_title; 
    					jQuery().mo = null; 
    					_title_interval = ''; 
    					unbind_mousemove();
    		};
    	jQuery(document).bind('mousemove', _clear_flash_handler);
    	jQuery(document).bind('click', _clear_flash_handler);
    }
	}
	

	/**
	* Play a sound notification
	*/
	function playSound(is_new_chat) {
		if ( ! _allow_sounds) {
			append_error("not playing sound.");
			return;
		}
		
		var song_url = '/musicplayer/mosio_alert.mp3';
		if ( ! is_new_chat) {
			song_url = '/par/images/yourturn02.mp3';
		}

		append_error('Playing: ' + song_url);

		var player_html = '<object type="application/x-shockwave-flash" ' +
		'data="/musicplayer/musicplayer.swf?&autoplay=true&song_url=' + song_url + '&random=' + Math.floor(Math.random()) + '" ' +
		'width="17" height="17">' +
		'<param name="movie" ' +
		'value="/musicplayer/musicplayer.swf?&autoplay=true&song_url=' + song_url + '&" />' +
		'</object>';
	
		jQuery("#sound_holder").css('display', 'none').html(player_html).show();
	}


	/**
	* unbind the mousemove associated with _clear_flash_handler
	*/
	function unbind_mousemove() {
   	append_error('unbinding mousemove');
   	jQuery(document).unbind('mousemove', _clear_flash_handler);
   	jQuery(document).unbind('click', _clear_flash_handler);
	}
	
	
	/**
	* Get the chat id from the widget id if we are an agent
	*/
	function getChatIdFromWidgetId(w_id) {
		return w_id.substring(_widget_base_id.length + 1);
	}


	/**
	* append an error to the error div for debugging
	*/
	function append_error(data) {
    if (_debug) {

	    // initialize .mosio_error div if not found
	    if ( ! $('div.mosio_error').length) {
	    	$('body').append('<div class="mosio_error"></div>');
	    }
	
	
	    if (typeof data === 'object' && data.error && data.error.length) {
	    	$('div.mosio_error').prepend('<p>' + data.error + '</p>');
	    }
	    else if (typeof data === 'string' && data.length) {
	    	$('div.mosio_error').prepend('<p>' + data + '</p>');
	    }

	  }
	}



	/**
	* Set chat id cookie - mainly for IE
	*/
	
	function set_chat_id_cookie(chat_id) {
		if (typeof chat_id != 'undefined') {
			createCookie(_chat_id_cookie_name, chat_id);
			append_error("Adding cookie for chat id: " + chat_id);
		}
	}
	


	/**
	* from quirksmode: http://www.quirksmode.org/js/cookies.html
	*/
	function createCookie(name,value,days) {
		if (days) {
			var date = new Date();
			date.setTime(date.getTime()+(days*24*60*60*1000));
			var expires = "; expires="+date.toGMTString();
		}
		else {
			var expires = "";
		}
		document.cookie = name+"="+value+expires+"; path=/";
	}
	function readCookie(name) {
		var nameEQ = name + "=";
		var ca = document.cookie.split(';');
		for(var i=0;i < ca.length;i++) {
			var c = ca[i];
			while (c.charAt(0)==' ') {
				c = c.substring(1,c.length);
			}
			if (c.indexOf(nameEQ) == 0) {
				return c.substring(nameEQ.length,c.length);
			}
		}
		return null;
	}
	function eraseCookie(name) {
		createCookie(name,"",-1);
	}



})(); // We call our anonymous function immediately



