﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Data.Entity;
using System.Data;
using System.Web;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;
using IntelSkill.Models;
using IntelSkill.Utilities;

namespace IntelSkill.Controllers
{
    public class HomeController : Controller
    {
        private StringCryptography stringCryptography;

        public ActionResult About()
        {
            ViewBag.Title = "IntelSkill - About us";
            return View();
        }
        public ActionResult Howitworks()
        {
            ViewBag.Title = "IntelSkill - How it works";
            return View();
        }
        public ActionResult Index()
        {
            ViewBag.Title = "IntelSkill - Home";

            var model = new SignInModel();

            GetSignInCookies(ref model);


            return View(model);
        }

        private void GetSignInCookies(ref SignInModel model)
        {
            HttpCookie cookie = Request.Cookies["Login"];

            if (cookie != null)
            {
                stringCryptography = new StringCryptography();
                model.RememberMe = true;
                model.Email = cookie.Values[0];
                model.Password = cookie.Values[1];
            }

        }

        public ActionResult Review()
        {
            return View();

        }

        [HttpPost]
        public ActionResult Index(string btnSignup = "")
        {
            if (btnSignup.ToLower() == "signup")
            {
                if (Request.Form["home_signup_textbox"] != null)
                {
                    Session["SignUpEmail"] = Request.Form["home_signup_textbox"].ToString();

                    return RedirectToAction("Registration", "Account");
                }
            }
            return View();
        }


    }
}
