﻿using System;
using System.Collections.Generic;
using System.Text.RegularExpressions;
using System.Linq;
using System.Data.Entity;
using System.Data;
using System.Web;
using System.Web.Mvc;
using IntelSkill.DAL;
using IntelSkill.Models;
using IntelSkill.Repository;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Drawing.Text;
using System.Drawing.Imaging;
using System.IO;
using System.Web.UI.WebControls;
using IntelSkill.Utilities;

namespace IntelSkill.Controllers
{
    public class ReaderController : Controller
    {
        private IUsersRepository usersRepository;
        private IReaderRepository ReaderRepository;
        private IContentRepository ContentRepository;

        private AccessModel accessAccount = null;

        private StringCryptography stringCryptography;

        public const int PageSize = 6;
        string pagemessage = string.Empty;
        string pagemessagetype = string.Empty;

        public ReaderController()
        {
            this.usersRepository = new UsersRepository(new SQLDBContext());
            this.ReaderRepository = new ReaderRepository(new SQLDBContext());
            this.ContentRepository = new ContentRepository(new SQLDBContext());

        }


        #region ReaderClassSubscription

        //GET://ReaderSubscription/
        public ActionResult ClassSubscription(ReaderModel model, List<ReaderContentModel> list, string id, string Quiz, string keyword, string Classes, string Pubhlisher, string Category, string ddlHasQuiz, int? page = 1, int PublisherUserid = 0)
        { 
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();
            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion

            ViewBag.Userid = id;
            ViewBag.Pubid = PublisherUserid;

            _ObjectInitializer(model, PublisherUserid, id);
            if (id != null)
            {
                ViewBag.Parameter = ((PublisherUserid != 0 ? "&PublisherUserid=" + ViewBag.Pubid : "") + "" + (id != null ? "&id=" + ViewBag.Userid : "") + "" + (!string.IsNullOrEmpty(keyword) ? "&keyword=" + keyword : "") + "" + (!string.IsNullOrEmpty(Classes) ? "&Classes=" + Classes : "") + "" + (!string.IsNullOrEmpty(Pubhlisher) ? "&Pubhlisher=" + Pubhlisher : "") + "" + (!string.IsNullOrEmpty(Category) ? "&Category=" + Category : "") + "" + (!string.IsNullOrEmpty(ddlHasQuiz) ? "&ddlHasQuiz=" + ddlHasQuiz : ""));
            }
            if (keyword == "Enter Class Name Or Publisher Name")
            {
                keyword = null;
            }
            if (Pubhlisher != null || keyword != null || Category != null || ddlHasQuiz != null || Classes != null)
            {

                model.IsStep2 = true;
                model.IsAdvancedSearch = false;
                id = id.Replace(" ", "");
                model.Search = true;
                if (!string.IsNullOrWhiteSpace(id) && id != "0")
                {
                    _ObjectInitializer(model, PublisherUserid, id);

                    model.UserId = Convert.ToInt32(id);

                }
                LoadSearchData(keyword, model, Classes, Pubhlisher, Category, ddlHasQuiz, page.Value);
                if (model.TotalClassContent != null)
                {
                    if (model.TotalClassContent.Count() > 0)
                    {
                        if (page <= 1)
                        {
                            model.PageClassContent = model.TotalClassContent.Take(PageSize).ToList();
                        }
                        else
                        {
                            model.PageClassContent = model.TotalClassContent.Skip(PageSize * (page.Value - 1)).Take(PageSize).ToList();

                        }

                        PopulatePagingData(model.TotalClassContent.Count, "Reader", "ClassSubscription", page);
                        model.CurrentPage = page.Value;

                    }
                }
                LoadPageSelectedCategoriesPublishers(Pubhlisher, Category);
                ViewBag.Quiz = ddlHasQuiz;
                ViewBag.Classes = Classes;
            }


            else
            {


                model.UserId = Convert.ToInt32(id);
                model.PublisheruserId = PublisherUserid;
                model.IsStep2 = true;


                LoadAllClasses(id, ref model, page ?? 0, PublisherUserid);

                LoadCategoriesPublishers();

                model.IsAdvancedSearch = false;
                if (Session["ReaderContentModel"] != null)
                {
                    Session["ReaderContentModel"] = null;
                }
            }
            SetMenuProperties("", "All Publishers", ViewBag.PageNavigation, "");
            return View(model);

        }

        //Post://ReaderSubscription/
        [HttpPost]
        public ActionResult ClassSubscription(string searchtext, string Subscribeid, string SendRequestid, string btnsubmit, FormCollection coll, ReaderModel model)
        {

            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();
            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion


            int? page = 1;



            int id = model.UserId;
            string uid = Convert.ToString(id);
            int mid = model.PublisheruserId;
            ViewBag.Userid = id;
            ViewBag.Pubid = mid;

            model.IsStep2 = true;

            string search_query = model.keyword;
            var ddlCategoryvalue = coll.GetValues("Categrys")[0].ToString();
            var ddlPublishervalue = coll.GetValues("PubNames")[0].ToString();
            string ddlselectclass = Request.Form["SelectClassType"];
            string ddlHasQuiz = Request.Form["IsHaveQuiz"];

            if (ddlselectclass != "Public" && ddlselectclass != "Private")
            {
                ddlselectclass = null;
            }



            if (ddlHasQuiz != "Yes" && ddlHasQuiz != "No")
            {
                ddlHasQuiz = null;

            }
            ViewBag.Quiz = ddlHasQuiz;
            ViewBag.Classes = ddlselectclass;
            ViewBag.Pubhlisher = ddlPublishervalue;
            ViewBag.Category = ddlCategoryvalue;

            model.IsAdvancedSearch = false;



            #region Subscribe And Request
            ClassSubscription objsub = new ClassSubscription();
            if ((btnsubmit == "Subscribe" || btnsubmit == "Send Request") && btnsubmit != null)
            {
                if (Request.QueryString["btnpage"] != null)
                {
                    page = Convert.ToInt32(Request.QueryString["btnpage"]);

                }

                if (btnsubmit == "Subscribe")
                {
                    objsub.ClassId = Convert.ToInt32(Subscribeid);
                    objsub.SubscriptionStatus = 1;//Subscribe Status
                    objsub.SubscriptionDate = System.DateTime.Now;
                    model.ValidationMessage = "You have Subscribed Successfully.";

                }
                else
                {
                    objsub.ClassId = Convert.ToInt32(SendRequestid);
                    objsub.SubscriptionStatus = 2;//Request Status
                    objsub.RequestedDate = System.DateTime.Now;
                    model.ValidationMessage = "Request Sent Successfully.";

                }
                objsub.RequestedUserId = id;

               
                ReaderRepository.SaveClassChanges(objsub);
                ReaderRepository.Save();


                if (Session["ReaderContentModel"] != null)
                {
                    ViewBag.Userid = null;
                    model = Session["ReaderContentModel"] as ReaderModel;
                    if (model.TotalClassContent != null)
                    {
                        if (model.TotalClassContent.Count() > 0)
                        {
                            List<ReaderContentModel> ClsModel = new List<ReaderContentModel>();
                            foreach (var item in model.TotalClassContent)
                            {
                                var count = ReaderRepository.GetClassSubcriptionCount(item.ClassId);
                                item.Count = count;
                                ClsModel.Add(item);
                            }
                            if (ClsModel.Count > 0)
                            {
                                model.ValidationMessage = null;
                                model.TotalClassContent = null;
                                model.TotalClassContent = ClsModel;
                                if (btnsubmit == "Subscribe")
                                {
                                    model.ValidationMessage = "You have Subscribed Successfully.";
                                }
                                if (btnsubmit == "Send Request")
                                {
                                    model.ValidationMessage = " Request Sent Successfully.";
                                }


                            }
                            model.ClassSubscription = ReaderRepository.GetClassSubscription(Convert.ToInt32(uid));
                        }
                    }
                }
                else
                {
                    _ObjectInitializer(model, mid, uid);

                }
                model.ValidationMessageType = "success";

            }

            #endregion


            // Search Functionality
            #region Search
            


            else
            //if (btnsubmit == "search")
            {

                _ObjectInitializer(model, mid, uid);
                ViewBag.Userid = null;

                model.PublisheruserId = 0;


                if (string.IsNullOrEmpty(search_query) && string.IsNullOrEmpty(ddlselectclass) && string.IsNullOrEmpty(ddlPublishervalue) && string.IsNullOrEmpty(ddlCategoryvalue) && string.IsNullOrEmpty(ddlHasQuiz))
                {
                    model.ValidationMessageType = "warning";
                    model.ValidationMessage = "Please enter keyword to search.";
                }
                else
                {
                    LoadSearchData(search_query, model, ddlselectclass, ddlPublishervalue, ddlCategoryvalue, ddlHasQuiz, page.Value);
                    model.Search = true;
                    model.ValidationMessageType = "success";

                    if (model.TotalClassContent != null && model.TotalClassContent.Count > 0)
                    {

                        model.ValidationMessage = "Search result(s) found (" + model.TotalClassContent.Count() + ")";
                    }
                    else
                    {
                        model.ValidationMessageType = "warning";
                        model.ValidationMessage = " No Search result(s) found ";
                    }

                }


            }
            #endregion



            if (model.TotalClassContent != null)
            {
                if (model.TotalClassContent.Count() > 0)
                {
                    if (page <= 1)
                    {
                        model.PageClassContent = model.TotalClassContent.Take(PageSize).ToList();
                    }
                    else
                    {
                        model.PageClassContent = model.TotalClassContent.Skip(PageSize * (page.Value - 1)).Take(PageSize).ToList();

                    }

                    PopulatePagingData(model.TotalClassContent.Count, "Reader", "ClassSubscription", page);


                }
            }

           
            LoadSelectedCategoriesPublishers(coll);

            if (id != 0)
            {
                ViewBag.Parameter = ((mid != 0 ? "&PublisherUserid=" + mid : "") + "" + (id != 0 ? "&id=" + id : "") + "" + (!string.IsNullOrEmpty(search_query) ? "&keyword=" + search_query : "") + "" + (!string.IsNullOrEmpty(ddlselectclass) ? "&Classes=" + ddlselectclass : "") + "" + (!string.IsNullOrEmpty(ddlPublishervalue) ? "&Pubhlisher=" + ddlPublishervalue : "") + "" + (!string.IsNullOrEmpty(ddlCategoryvalue) ? "&Category=" + ddlCategoryvalue : "") + "" + (!string.IsNullOrEmpty(ddlHasQuiz) ? "&ddlHasQuiz=" + ddlHasQuiz : ""));
            }

            SetMenuProperties("", "All Publishers", ViewBag.PageNavigation, "");
            model.CurrentPage = page.Value;
            return View(model);


        }


        //Functions://ReaderSubscription/
        private void _ObjectInitializer(ReaderModel model, int PublisherUserid, string id)
        {

            ViewBag.Userid = id;
            if (!string.IsNullOrWhiteSpace(id))
            {

                model.form = new Users();


                model.AllPublishers = ReaderRepository.GetAllPublisher();

                model.ClassSubscription = ReaderRepository.GetClassSubscription(Convert.ToInt32(id));


                if (PublisherUserid == 0)
                {
                    var allPublishers = model.AllPublishers.FirstOrDefault();
                     if(allPublishers!=null)
                    {
                        model.TotalClassContent = ReaderRepository.GetAllClass(allPublishers.UserId).ToList();
                        model.PublisherName = ReaderRepository.GetPublisherName(allPublishers.UserId);
                        model.PublisheruserId = model.AllPublishers.FirstOrDefault().UserId;
                        ViewBag.PageNavigation = ReaderRepository.GetPublisherName(allPublishers.UserId);

                        ViewBag.Pubid = model.PublisheruserId;
                    }
                    else
                    {
                        model.ValidationMessageType = "warning";
                        model.ValidationMessage = "There are no publisher classes";
                    }

                }
                else
                {
                    model.TotalClassContent = ReaderRepository.GetAllClass(PublisherUserid).ToList();
                    model.PublisherName = ReaderRepository.GetPublisherName(PublisherUserid);

                    ViewBag.PageNavigation = ReaderRepository.GetPublisherName(PublisherUserid);
                    ViewBag.Pubid = PublisherUserid;
                }

            }
        }
        private void LoadAllClasses(string id, ref ReaderModel model, int page, int PublisherUserid)
        {
            if (PublisherUserid == 0)
            {

                var allPublishers = model.AllPublishers.FirstOrDefault();
                if (allPublishers != null)
                {

                    model.TotalClassContent = ReaderRepository.GetAllClass(allPublishers.UserId).ToList();
                }
                else
                {

                    model.TotalClassContent = ReaderRepository.GetAllClass(PublisherUserid).ToList();
                }
            }
            if (model.TotalClassContent != null)
            {
                if (page <= 1)
                {
                    model.PageClassContent = model.TotalClassContent.Take(PageSize).ToList();
                }
                else
                {
                    model.PageClassContent = model.TotalClassContent.Skip(PageSize * (page - 1)).Take(PageSize).ToList();

                }

                PopulatePagingData(model.TotalClassContent.Count, "Reader", "ClassSubscription", page);
                model.CurrentPage = page;
            }
        }
        private void PopulatePagingData(int totalRows, string controllerName, string actionName, int? page = 1)
        {
            int pageCount = 0;
            if (ViewBag.ContentPreview == null)
            {
                double dblPageCount = (double)((decimal)totalRows / PageSize);
                pageCount = (int)Math.Ceiling(dblPageCount);

            }
            else
            {
                pageCount = totalRows;
            }

            ViewBag.CurrentPage = page;
            ViewBag.PageCount = pageCount;
            ViewBag.PagingNavigation = "/" + controllerName + "/" + actionName;
            ViewBag.EnablePaging = pageCount > 1;
        }
        #endregion

        #region ReaderDashboard

        //GET://ReaderDashboard/
        public ActionResult Dashboard(List<ReaderContentModel> list, string id, int? page = 1, string IsPublisher = null, string Quiz = null, string keyword = null, string Classes = null, string Pubhlisher = null, string Category = null)
        {
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();
            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion

            var model = new ReaderModel();
            model.form = new Users();
            model.catForm = new Categories();
            string DefaultClassName = string.Empty;
            string DefaultPublisherName = string.Empty;

            int classId = 0;
            Int32.TryParse(id, out classId);


            ReaderRepository.GetAllClass(accessAccount.CurrentUserId, ref model.ReaderClasses, ref model.ReaderPublisher, ref model.ReaderContents, ref DefaultPublisherName, ref DefaultClassName, classId);

            if (!string.IsNullOrEmpty(Quiz) || !string.IsNullOrEmpty(keyword) || !string.IsNullOrEmpty(Classes) || !string.IsNullOrEmpty(Pubhlisher) || !string.IsNullOrEmpty(Category))
            {
                LoadSearchData(keyword, model, Classes, Pubhlisher, Category, Quiz, page.Value);

                ViewBag.Parameter = ((!string.IsNullOrEmpty(keyword) ? "&keyword=" + keyword : "") + "" + (!string.IsNullOrEmpty(Classes) ? "&Classes=" + Classes : "") + "" + (!string.IsNullOrEmpty(Pubhlisher) ? "&Pubhlisher=" + Pubhlisher : "") + "" + (!string.IsNullOrEmpty(Category) ? "&Category=" + Category : "") + "" + (!string.IsNullOrEmpty(Quiz) ? "&Quiz=" + Quiz : ""));
                if (!string.IsNullOrEmpty(Quiz) || !string.IsNullOrEmpty(Classes) || !string.IsNullOrEmpty(Pubhlisher) || !string.IsNullOrEmpty(Category))
                {
                    model.IsAdvancedSearch = true;
                }
                else
                {
                    model.IsAdvancedSearch = false;
                }
                ViewBag.Quiz = Quiz;
                ViewBag.Classes = Classes;
                SetMenuProperties(DefaultPublisherName+ " Dashboard - IntelSkill.Com", DefaultPublisherName, "", "");
            }
            else
            {
                model.TotalClassContent = model.ReaderContents.OrderBy(p => p.ContentId).ToList();
                ViewBag.Parameter = (!string.IsNullOrEmpty(id) ? "&id=" + id : "");
                model.IsSearchClass = false;
                model.IsAdvancedSearch = false;
                SetMenuProperties(DefaultPublisherName+" " +DefaultClassName + " Dashboard - IntelSkill.Com", DefaultPublisherName, DefaultClassName, "");
            }
            if (model.TotalClassContent != null && model.TotalClassContent.Count > 0)
            {
                if (page <= 1)
                {
                    model.PageClassContent = model.TotalClassContent.Take(PageSize).ToList();
                }
                else
                {
                    model.PageClassContent = model.TotalClassContent.Skip(PageSize * (page.Value - 1)).Take(PageSize).ToList();
                }

            }
            PopulatePagingData(model.TotalClassContent.Count, "Reader", "Dashboard", page);
            model.CurrentPage = page.Value;

            if (model.ReaderClasses != null && model.ReaderClasses.Count > 0)
            {
                var publisherid = (from publsid in model.ReaderClasses where publsid.ClassId == classId select publsid.PublisherUserId.Value).FirstOrDefault();
                if (publisherid != 0)
                {
                    var ClsId = 0;
                    if (IsPublisher == "true")
                    {
                        ClsId = (from clsid in model.ReaderClasses where clsid.PublisherUserId == publisherid select clsid.ClassId).FirstOrDefault<int>();
                    }
                    else
                    {
                        ClsId = (from clsid in model.ReaderClasses where clsid.PublisherUserId == publisherid && clsid.ClassId == Convert.ToInt32(id) select clsid.ClassId).FirstOrDefault<int>();
                    }

                    ViewBag.ClassId = ClsId;
                }
                else
                {
                    ViewBag.ClassId = model.ReaderClasses[0].ClassId;
                }
                if (!string.IsNullOrEmpty(id))
                {
                    model.ClassForm = (from cls in model.ReaderClasses where cls.ClassId == Convert.ToInt32(id) select cls).FirstOrDefault();
                }
                else
                {
                    model.ClassForm = model.ReaderClasses[0];
                }
                if (model.ClassForm != null)
                {
                    model.ClassPay = ReaderRepository.GetClassPaymentDetails(model.ClassForm.ClassId, accessAccount.CurrentUserId);
                }
            }

            if (TempData["ClassPaymentModel"] != null)
            {
                var ClassPaymentModel = TempData["ClassPaymentModel"] as ReaderModel;
                if (model.ClassForm != null)
                {
                    model.ValidationMessage = ClassPaymentModel.ValidationMessage + model.ClassForm.ClassName;
                }
                model.ValidationMessageType = ClassPaymentModel.ValidationMessageType;

                ViewBag.IsClassSucced = true;
            }
            _ObjectInitialize(ref model);
            ViewBag.IsPublisher = true;
            LoadPageSelectedCategoriesPublishersForReader(Pubhlisher, Category);
            return View(model);
        }
        public ActionResult Preview(int ContentId = 0, int ClassId = 0, int? page = 1)
        {
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();

            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion


            var model = new ReaderModel();
            if (ContentId != 0)
            {

                Contents cnt = ContentRepository.GetContentListById(ContentId).FirstOrDefault();
                model.ContentTitle = cnt.ContentTitle;
                List<ContentPages> listcontPages = ContentRepository.GetContentPages(cnt.ContentId).ToList();
                model.ReaderPageDesc = new List<ContentPages>();
                if (listcontPages.Count > 0)
                {
                    for (int j = 1; j <= listcontPages.Count(); j++)
                    {
                        ContentPages pageObj = new ContentPages();
                        pageObj.ContentPageId = j;
                        pageObj.PageDescription = listcontPages[j - 1].PageDescription;
                        pageObj.ContentId = listcontPages[j - 1].ContentId;
                        model.ReaderPageDesc.Add(pageObj);
                    }


                }

                ViewBag.Parameter = ("&ContentId=" + ContentId + "" + "&ClassId=" + ClassId);

                if (model.ReaderPageDesc != null && model.ReaderPageDesc.Count > 0)
                {
                    List<ContentPages> ContPages = new List<ContentPages>();
                    ViewBag.ContentPreview = true;
                    PopulatePagingData(model.ReaderPageDesc.Count, "Reader", "Preview", page);
                    if (page >= 1)
                    {
                        ContPages = model.ReaderPageDesc.FindAll(p => p.ContentPageId == page);
                    }
                    if (model.ReaderPageDesc.Count == page)
                    {
                        if (cnt.QuizId != null)
                        {
                            model.QuizId = cnt.QuizId.Value;
                            model.QuestAns = ReaderRepository.QuestionAnswer(model.QuizId).ToList();
                        }
                    }
                    model.ContentPageDesc = ContPages.FirstOrDefault().PageDescription;

                }
            }



            //Users Logo = UserRepository.GetSignInDetails(ViewBag.UserName);
            //if (Logo != null)
            //{
            //    ViewBag.CompanyLogo = Logo.CompanyLogo;
            //}
            string DefaultClassName = string.Empty;
            string DefaultPublisherName = string.Empty;

            int classId = 0;
            Int32.TryParse(Convert.ToString(ClassId), out classId);
            ReaderRepository.GetAllClass(accessAccount.CurrentUserId, ref model.ReaderClasses, ref model.ReaderPublisher, ref model.ReaderContents, ref DefaultPublisherName, ref DefaultClassName, classId);

            ViewBag.IsPublisher = true;

            ViewBag.ClassId = ClassId;
            SetMenuProperties("Dashboard", DefaultPublisherName, DefaultClassName, model.ContentTitle);
            return View(model);
        }
        //Post://ReaderDashboard/
        [HttpPost]
        public ActionResult Dashboard(ReaderModel model, List<ReaderContentModel> list, FormCollection collection, string id, string btnSubmit, string Subscribeid, string SendRequestid)
        {
            int? page = 1;
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();

            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            #endregion

            model.form = new Users();
            model.catForm = new Categories();
            model.IsSearchClass = false;
            model.IsAdvancedSearch = false;
            string search_query = null;
            if (!string.IsNullOrEmpty(model.keyword))
            {
                search_query = model.keyword.Trim();
            }
            var ddlCategoryvalue = collection.GetValues("Categrys")[0].ToString();
            var ddlPublishervalue = collection.GetValues("PubNames")[0].ToString();
            string ddlselectclass = Request.Form["SelectClassType"];
            string ddlHasQuiz = Request.Form["IsHaveQuiz"];
            if (ddlselectclass != "Public" && ddlselectclass != "Private")
            {
                ddlselectclass = null;
            }

            if (ddlHasQuiz != "Yes" && ddlHasQuiz != "No")
            {
                ddlHasQuiz = null;

            }

            ViewBag.Quiz = ddlHasQuiz;
            ViewBag.Classes = ddlselectclass;
            ViewBag.Pubhlisher = ddlPublishervalue;
            ViewBag.Category = ddlCategoryvalue;

            #region Subscrition & Send Request

            ClassSubscription objsub = new ClassSubscription();
            if (btnSubmit == "Subscribe" && btnSubmit != null)
            {

                if (Request.QueryString["btnpage"] != null)
                {
                    page = Convert.ToInt32(Request.QueryString["btnpage"]);

                }
                objsub.ClassId = Convert.ToInt32(Subscribeid);
                objsub.RequestedUserId = accessAccount.CurrentUserId;
                objsub.SubscriptionStatus = 1;//Subscribe Status
                objsub.SubscriptionDate = System.DateTime.Now;
                ReaderRepository.SaveClassChanges(objsub);
                ReaderRepository.Save();
                model.IsSearchClass = true;
                LoadSearchData(search_query, model, ddlselectclass, ddlPublishervalue, ddlCategoryvalue, ddlHasQuiz, page ?? 0);
                model.ValidationMessageType = "success";
                model.ValidationMessage = "You have Subscribed Successfully.";
            }
            else if (btnSubmit == "Send Request" && btnSubmit != null)
            {
                if (Request.QueryString["btnpage"] != null)
                {
                    page = Convert.ToInt32(Request.QueryString["btnpage"]);

                }
                objsub.ClassId = Convert.ToInt32(SendRequestid);
                objsub.SubscriptionStatus = 2;//Request Status
                objsub.RequestedUserId = accessAccount.CurrentUserId;
                objsub.RequestedDate = System.DateTime.Now;
                ReaderRepository.SaveClassChanges(objsub);
                ReaderRepository.Save();
                model.IsSearchClass = true;
                LoadSearchData(search_query, model, ddlselectclass, ddlPublishervalue, ddlCategoryvalue, ddlHasQuiz, page ?? 0);
                model.ValidationMessageType = "success";
                model.ValidationMessage = "You have sent Request Successfully.";
            }

            #endregion
            #region Search
            else
            {
              


                if (string.IsNullOrEmpty(search_query) && string.IsNullOrEmpty(ddlselectclass) && string.IsNullOrEmpty(ddlPublishervalue) && string.IsNullOrEmpty(ddlCategoryvalue) && string.IsNullOrEmpty(ddlHasQuiz))
                {
                    model.IsSearchClass = true;
                    model.ValidationMessageType = "warning";
                    model.ValidationMessage = "Please enter keyword to search.";
                }
                else
                {
                    LoadSearchData(search_query, model, ddlselectclass, ddlPublishervalue, ddlCategoryvalue, ddlHasQuiz, page.Value);

                    model.ValidationMessageType = "success";
                    if (model.TotalClassContent != null && model.TotalClassContent.Count > 0)
                    {
                        model.ValidationMessage = "Search keyword found (" + model.TotalClassContent.Count() + ") results";
                    }
                    else
                    {
                        model.IsSearchClass = true;
                        model.ValidationMessageType = "warning";
                        model.ValidationMessage = "Search keyword not found";
                    }
                }




            }
            #endregion
            LoadSelectedCategoriesPublishersReader(collection);

            LoadDefaultData(model, id);

            if (model.TotalClassContent != null && model.TotalClassContent.Count > 0)
            {
                if (page <= 1)
                {
                    model.PageClassContent = model.TotalClassContent.Take(PageSize).ToList();
                }
                else
                {
                    model.PageClassContent = model.TotalClassContent.Skip(PageSize * (page.Value - 1)).Take(PageSize).ToList();
                }
                PopulatePagingData(model.TotalClassContent.Count, "Reader", "Dashboard", page);
            }

            SetMenuProperties("Dashboard", "", "", "");
            if (model.ReaderClasses != null && model.ReaderClasses.Count > 0)
            {
                if (!string.IsNullOrEmpty(id))
                {
                    model.ClassForm = (from cls in model.ReaderClasses where cls.ClassId == Convert.ToInt32(id) select cls).FirstOrDefault();
                }
                else
                {
                    model.ClassForm = model.ReaderClasses[0];
                }
                if (model.ClassForm != null)
                {
                    model.ClassPay = ReaderRepository.GetClassPaymentDetails(model.ClassForm.ClassId, accessAccount.CurrentUserId);
                }
            }
            ViewBag.Parameter = ((!string.IsNullOrEmpty(search_query) ? "&keyword=" + search_query : "") + "" + (!string.IsNullOrEmpty(ViewBag.Classes) ? "&Classes=" + ViewBag.Classes : "") + "" + (!string.IsNullOrEmpty(ViewBag.Pubhlisher) ? "&Pubhlisher=" + ViewBag.Pubhlisher : "") + "" + (!string.IsNullOrEmpty(ViewBag.Category) ? "&Category=" + ViewBag.Category : "") + "" + (!string.IsNullOrEmpty(ViewBag.Quiz) ? "&Quiz=" + ViewBag.Quiz : ""));
            ViewBag.IsPublisher = true;
            model.CurrentPage = page.Value;
            return View(model);
            //return RedirectToAction("Index", "ReaderDashboard");
        }

        //view Report

        public ActionResult ViewReport(ReaderModel model, int Quizid = 0)
        {

            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();
            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion
            ViewBag.DisplayName = accessAccount.DisplayName;
            ViewBag.CompanyLogo = accessAccount.PublisherCompanyLogo;

            model.QuizForm = new Quizzes();
            model.TotalQuizes = new List<QuizReports>();

            //model.Quizinformation = new QuizReport();
            model.form = new Users();

          
              
          

            model.QuestionType = ReaderRepository.GetQuestions();
            model.TotalQuizes = ReaderRepository.GetNumberOfQuizes(accessAccount.CurrentUserId);
            List<Quizzes> Quizzes = new List<Quizzes>();
            foreach (var QuizId in model.TotalQuizes)
            {
                Quizzes Quiz = ReaderRepository.GetQuizzesbyId(QuizId.QuizId.Value);
                Quizzes.Add(Quiz);
            }
            model.Quizzes = Quizzes;

            if (Quizid == 0 && model.TotalQuizes.Count > 0)
            {
                Quizid = model.TotalQuizes.FirstOrDefault().QuizId.Value;

            }
            model.Quizinformation = ReaderRepository.GetQizDetails(accessAccount.CurrentUserId, Quizid);

            string QuizName = (from Name in model.Quizzes where Name.QuizId == Quizid select Name.QuizTitle).FirstOrDefault();

            // ViewBag.SideMenuNavigation = "Quiz";
            ViewBag.PageNavigation = QuizName;
            if (model.TotalQuizes.Count > 0)
            {
                if (model.Quizinformation.QuizEndTime != null)
                {
                    TimeSpan Examduration = (model.Quizinformation.QuizEndTime.Value).Subtract(model.Quizinformation.QuizStartTime.Value);
                    model.Quizduration = Examduration;
                }


                if (model.Quizinformation.MatchingQuest == null)
                {
                    model.Quizinformation.MatchingQuest = 0;
                }
                if (model.Quizinformation.TrueorFalseQuest == null)
                {
                    model.Quizinformation.TrueorFalseQuest = 0;
                }
                if (model.Quizinformation.MatchingQuest == null)
                {
                    model.Quizinformation.MatchingQuest = 0;
                }
                if (model.Quizinformation.FillInBlanksQuest == null)
                {
                    model.Quizinformation.FillInBlanksQuest = 0;
                }

                if (model.Quizinformation.MulitpleChoiceAns == null)
                {
                    model.Quizinformation.MulitpleChoiceAns = 0;
                }
                if (model.Quizinformation.TrueorFalseAns == null)
                {
                    model.Quizinformation.TrueorFalseAns = 0;
                }
                if (model.Quizinformation.MatchingAns == null)
                {
                    model.Quizinformation.MatchingAns = 0;
                }
                if (model.Quizinformation.FillInBlanksAns == null)
                {
                    model.Quizinformation.FillInBlanksAns = 0;
                }
                model.TotalQuestions = (model.Quizinformation.MulitpleChoiceQuest.Value + model.Quizinformation.TrueorFalseQuest.Value + model.Quizinformation.FillInBlanksQuest.Value + model.Quizinformation.MatchingQuest.Value);
                model.Totalcorrectanswers = (model.Quizinformation.MulitpleChoiceAns.Value + model.Quizinformation.TrueorFalseAns.Value + model.Quizinformation.FillInBlanksAns.Value + model.Quizinformation.MatchingAns.Value);
                model.score = model.Totalcorrectanswers * 100 / model.TotalQuestions;


                if (model.Quizinformation.MulitpleChoiceQuest.Value != 0)
                    model.MultipleQuestinsPercentage = model.Quizinformation.MulitpleChoiceAns.Value * 100 / model.Quizinformation.MulitpleChoiceQuest.Value;

                if (model.Quizinformation.FillInBlanksQuest.Value != 0)
                    model.FillBlanksQuestinsPercentage = model.Quizinformation.FillInBlanksAns.Value * 100 / model.Quizinformation.FillInBlanksQuest.Value;

                if (model.Quizinformation.TrueorFalseQuest.Value != 0)
                    model.TrueFalseQuestinsPercentage = model.Quizinformation.TrueorFalseAns.Value * 100 / model.Quizinformation.TrueorFalseQuest.Value;

                if (model.Quizinformation.MatchingQuest.Value != 0)
                    model.MatchingQuestinsPercentage = model.Quizinformation.MatchingAns.Value * 100 / model.Quizinformation.MatchingQuest.Value;
            }

            model.ViewReport = true;
            _ObjectInitialize(ref model);
            ViewBag.IsPublisher = false;
            ViewBag.Quizid = Quizid;
            SetMenuProperties("Dashboard", "Quiz Results", ViewBag.PageNavigation, "");
            return View(model);
        }

        public ActionResult PercentImage()
        {
            var percentString = Request.QueryString["Percent"];
            var percent = 0;
            if (!int.TryParse(percentString, out percent))
                return View();
            if (percent < 0 || percent > 100)
                return View();

            byte[] byteArrayIn = SaveRadialIndicator(percent);

            return File(byteArrayIn, "image/png");

        }

        private static byte[] SaveRadialIndicator(int percent)
        {
            int percentchecking = percent;
            ReaderModel model = new ReaderModel();
            using (Bitmap bitmap = new Bitmap(100, 100))
            using (Graphics objGraphics = Graphics.FromImage(bitmap))
            {
                // Initialize graphics
                objGraphics.Clear(Color.White);
                objGraphics.SmoothingMode = SmoothingMode.AntiAlias;
                objGraphics.TextRenderingHint = TextRenderingHint.ClearTypeGridFit;

                // Fill pie
                // Degrees are taken clockwise, 0 is parallel with x
                // For sweep angle we must convert percent to degrees (90/25 = 18/5)
                Rectangle rectangle = new Rectangle(5, 5, 90, 90);

                //startAngle = 0.0F;
                //sweepAngle = 90f;

                HatchBrush hBrush = new HatchBrush(HatchStyle.LargeCheckerBoard, Color.Coral, Color.Blue);
                Brush b1 = new SolidBrush(Color.Blue);

                Brush linearGradientBrush = new LinearGradientBrush(
          new Rectangle(5, 5, 90, 90), Color.DeepSkyBlue, Color.White, 45);
                Brush linearGradientBrush1 = new LinearGradientBrush(
         new Rectangle(5, 5, 90, 90), Color.Red, Color.White, 45);
                Brush linearGradientBrush2 = new LinearGradientBrush(
         new Rectangle(5, 5, 90, 90), Color.Yellow, Color.White, 45);
                Brush linearGradientBrush3 = new LinearGradientBrush(
        new Rectangle(5, 5, 90, 90), Color.Green, Color.White, 45);



                float startAngle = -90.0f;
                float sweepAngle = 0.0f;
                if (percent > 0)
                {
                    startAngle = -90.0f;
                    sweepAngle = 0.0f;
                    if (percent < 20)
                    {
                        sweepAngle = PercentageAngle(percentchecking);
                        objGraphics.FillPie(Brushes.DeepSkyBlue, rectangle, startAngle, sweepAngle);
                    }
                    else
                    {
                        sweepAngle = PercentageAngle(20.0F);
                        objGraphics.FillPie(Brushes.DeepSkyBlue, rectangle, startAngle, sweepAngle);
                    }
                }





                if (percent > 20)
                {
                    startAngle += sweepAngle;
                    if (percent < 50)
                    {
                        percentchecking = percentchecking - 20;
                        sweepAngle = PercentageAngle(percentchecking);
                        objGraphics.FillPie(Brushes.Red, rectangle, startAngle, sweepAngle);
                    }
                    else
                    {
                        sweepAngle = PercentageAngle(30.0F);
                        objGraphics.FillPie(Brushes.Red, rectangle, startAngle, sweepAngle);
                    }
                }



                if (percent > 50)
                {
                    startAngle += sweepAngle;
                    if (percent < 75)
                    {
                        percentchecking = percentchecking - 50;
                        sweepAngle = PercentageAngle(percentchecking);
                        objGraphics.FillPie(Brushes.Yellow, rectangle, startAngle, sweepAngle);
                    }
                    else
                    {
                        sweepAngle = PercentageAngle(20.0F);
                        objGraphics.FillPie(Brushes.Yellow, rectangle, startAngle, sweepAngle);
                    }
                }


                if (percent > 75 && percent <= 100)
                {
                    startAngle += sweepAngle;
                    if (percent < 100)
                    {
                        percentchecking = percentchecking - 70;
                        sweepAngle = PercentageAngle(percentchecking);
                        objGraphics.FillPie(Brushes.Green, rectangle, startAngle, sweepAngle);
                    }
                    else
                    {
                        sweepAngle = PercentageAngle(30.0F);
                        objGraphics.FillPie(Brushes.Green, rectangle, startAngle, sweepAngle);
                    }
                }
                // Draw circles
                rectangle = new Rectangle(5, 5, 90, 90);
                objGraphics.DrawEllipse(Pens.LightGray, rectangle);
                rectangle = new Rectangle(20, 20, 60, 60);
                objGraphics.DrawEllipse(Pens.LightGray, rectangle);

                // Fill inner circle with white
                rectangle = new Rectangle(21, 21, 58, 58);
                objGraphics.FillEllipse(Brushes.White, rectangle);

                // Draw text on image
                // Use rectangle for text and align text to center of rectangle
                var font = new Font("Bold", 13, FontStyle.Bold);
                StringFormat stringFormat = new StringFormat();
                stringFormat.Alignment = StringAlignment.Center;
                stringFormat.LineAlignment = StringAlignment.Center;

                rectangle = new Rectangle(20, 40, 62, 20);
                objGraphics.DrawString(percent + "%", font, Brushes.Black, rectangle, stringFormat);

                // Save indicator to file
                objGraphics.Flush();
                using (var ms = new MemoryStream())
                {
                    bitmap.Save(ms, ImageFormat.Png);

                    return ms.ToArray();
                }
            }
        }
        private static float PercentageAngle(float input)
        {
            float totalAngle = (float)(360 * input / 100);
            return totalAngle;

        }

        //Functions://ReaderDashboard/
        private void _ObjectInitialize(ref ReaderModel model)
        {
            if (model.ReaderClasses == null)
                model.ReaderClasses = new List<Classes>();

            if (model.ReaderContents == null)
                model.ReaderContents = new List<ReaderContentModel>();

            if (model.ReaderPublisher == null)
                model.ReaderPublisher = new List<Users>();

            if (model.TotalQuizes == null)
                model.TotalQuizes = new List<QuizReports>();
        }
        public void LoadDefaultData(ReaderModel model, string id)
        {

            string DefaultClassName = string.Empty;
            string DefaultPublisherName = string.Empty;
            int classId = 0;
            Int32.TryParse(id, out classId);
            ReaderRepository.GetAllClass(accessAccount.CurrentUserId, ref model.ReaderClasses, ref model.ReaderPublisher, ref model.ReaderContents, ref DefaultPublisherName, ref DefaultClassName, classId);
        }

        #endregion

        #region ExamModule

        //GET://Exam/
        public ActionResult ExamQuestions(int QuizId = 0, int ClassId = 0)
        {
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();

            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion

            var model = new ReaderModel();
            model.ClassId = ClassId;
            LoadQuizDetails(model, QuizId);
            LoadRandomOrStaticQuestions(model, QuizId);
            LoadIndex(model);

            #region InsertQuizReport

            List<QuizReports> ListQuizRpts = ReaderRepository.QuizReportList(QuizId, accessAccount.CurrentUserId);
            if (ListQuizRpts.Count < model.QuizForm.AttemptLimit)
            {

                QuizReports QuizRpt = new QuizReports();
                QuizRpt.QuizId = QuizId;
                QuizRpt.QuizStartTime = DateTime.Now;

                var TotalMutipleChoiceQuest = from MultipleQuest in model.QuestAns where MultipleQuest.QuestionTypeId == 1 select MultipleQuest;
                if (TotalMutipleChoiceQuest.Count() > 0)
                    QuizRpt.MulitpleChoiceQuest = TotalMutipleChoiceQuest.Count();
                else
                    QuizRpt.MulitpleChoiceQuest = 0;


                var TotalFillinBlankQuest = from FillinBlankQuest in model.QuestAns where FillinBlankQuest.QuestionTypeId == 2 select FillinBlankQuest;
                if (TotalFillinBlankQuest.Count() > 0)
                    QuizRpt.FillInBlanksQuest = TotalFillinBlankQuest.Count();
                else
                    QuizRpt.FillInBlanksQuest = 0;

                var TotalTrueOrFalseQuest = from TrueOrFalseQuest in model.QuestAns where TrueOrFalseQuest.QuestionTypeId == 3 select TrueOrFalseQuest;
                if (TotalTrueOrFalseQuest.Count() > 0)
                    QuizRpt.TrueorFalseQuest = TotalTrueOrFalseQuest.Count();
                else
                    QuizRpt.TrueorFalseQuest = 0;

                var TotalMatchingQuest = from MatchingQuest in model.QuestAns where MatchingQuest.QuestionTypeId == 4 select MatchingQuest;
                if (TotalMatchingQuest.Count() > 0)
                    QuizRpt.MatchingQuest = TotalMatchingQuest.Count();
                else
                    QuizRpt.MatchingQuest = 0;

                QuizRpt.CandidateUserId = accessAccount.CurrentUserId;
                QuizRpt.PassingScore = model.QuizForm.PassingScore.Value;
                QuizRpt.PassedScore = 0;


                QuizRpt.AttendedOrder = ListQuizRpts.Count + 1;

                ReaderRepository.InsertQuizReport(QuizRpt);
                ReaderRepository.Save();

                QuizReports LastQuizRpt = ReaderRepository.QuizReportList(QuizId, accessAccount.CurrentUserId).LastOrDefault();

                foreach (var Questions in model.QuestAns)
                {
                    QuestionAnswerInfo Quest = new QuestionAnswerInfo();
                    Quest.QuestionId = Questions.QuestionId;
                    Quest.QuizReportId = LastQuizRpt.QuizReportId;
                    ReaderRepository.InsertQuestionAnswerInfo(Quest);
                    ReaderRepository.Save();
                }


                model.IsAttemptLimitOver = false;
                model.IsLeaveExam = true;
                ViewBag.TotalAttemptLimitCount = (ListQuizRpts.Count + 1) + "/" + (model.QuizForm.AttemptLimit);
            }
            else
            {
                model.IsAttemptLimitOver = true;
                model.QuizForm.ExamTimed = false;
            }

            #endregion

            model.QuestionCount = 1;

            ViewBag.IsPublisher = true;
            ViewBag.ClassId = ClassId;
            return View(model);
        }
        public ActionResult ResultPage(int QuizId = 0, int ClassId = 0)
        {
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();

            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion

            var model = new ReaderModel();

            QuizReports LastQuizRpt = ReaderRepository.QuizReportList(QuizId, accessAccount.CurrentUserId).LastOrDefault();
            if (LastQuizRpt != null)
            {

                model.Percentage = LastQuizRpt.PassedScore.Value;
            }
            model.IsLeaveExam = false;
            model.ClassId = ClassId;
            LoadQuizDetails(model, QuizId);
            LoadIndex(model);
            model.IsWrongsList = false;
            ViewBag.IsPublisher = true;
            if (model.ClassId != 0)
            {
                ViewBag.ClassId = model.ClassId;
            }
           
            return View(model);
        }
        public ActionResult QuizTimeOut(int QuizId = 0, int ClassId = 0)
        {
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();

            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion  
            var model = new ReaderModel();
            model.ClassId = ClassId;
            LoadQuizDetails(model, QuizId);

            LoadIndex(model);
            ViewBag.IsPublisher = true;
            if (model.ClassId != 0)
            {
                ViewBag.ClassId = model.ClassId;
            }
           
            return View(model);
        }


        //Post://Exam/
        [HttpPost]
        public ActionResult ExamQuestions(int QuizId, FormCollection collection, string btnSubmit, int ClassId = 0)
        {
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();

            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            #endregion

            var model = new ReaderModel();

            #region Finish

            if (btnSubmit == "Finish")
            {

                model.QuestAns = ReaderRepository.GetQuestionAns(QuizId, accessAccount.CurrentUserId).OrderBy(p => p.QuestionAnswerInfoId).ToList();

                List<SelectListItem> AnswersList = new List<SelectListItem>();
                if (collection.AllKeys != null)
                {
                    var exp = new Regex("[a-zA-Z]");
                   
                    foreach (var item in collection.AllKeys)
                    {
                        var matches = exp.Matches(item);
                        if (matches.Count == 0)
                        {
                            string value = collection[item].Trim();
                            if (!string.IsNullOrEmpty(value))
                            {
                                SelectListItem sl = new SelectListItem();
                                sl.Text = Convert.ToString(item);
                                sl.Value = Convert.ToString(value);


                                AnswersList.Add(sl);
                            }
                        }

                    }

                }

                List<int> CorrectQuestionId = new List<int>();
                List<int> WrongQuestionId = new List<int>();
                string UserAnswer = null;
                List<QuestionAnswerInfo> QuestInfo = ReaderRepository.GetQuestionAnsInfo(QuizId, accessAccount.CurrentUserId);
                foreach (var CorrectAns in model.QuestAns)
                {
                    foreach (var UserAns in AnswersList)
                    {
                        bool? IsCorrectAnswer = null;
                        if (CorrectAns.QuestionId == Convert.ToInt32(UserAns.Text))
                        {
                            QuestionAnswerInfo Quest = (from QuestionInfo in QuestInfo where QuestionInfo.QuestionId == CorrectAns.QuestionId select QuestionInfo).FirstOrDefault();

                            if (CorrectAns.QuestionTypeId == 3 || CorrectAns.QuestionTypeId == 2)
                            {
                                if (CorrectAns.Answers.FirstOrDefault().AnswerValue.ToLower().Trim() == UserAns.Value.ToLower().Trim())
                                {
                                    UserAns.Value = CorrectAns.Answers.FirstOrDefault().AnswerId.ToString();
                                }
                                else { UserAnswer = UserAns.Value; UserAns.Value = "0"; }
                            }
                            if (CorrectAns.QuestionTypeId == 4)
                            {
                                List<string> UserSelectAnsId = UserAns.Value.Split(',').ToList<string>();

                                List<string> IdList = new List<string>();
                                string UserAnswerValue = string.Empty;


                                for (int i = 0; i < UserSelectAnsId.Count; i++)
                                {
                                    string AnsList = (from Ans in CorrectAns.Answers where Ans.QuestionId == CorrectAns.QuestionId && Ans.AnswerGroup == "GroupB" && Ans.AnswerId == Convert.ToInt32(UserSelectAnsId[i]) select Ans.OrderBy).FirstOrDefault();
                                    UserAnswerValue += AnsList;
                                }


                                UserAns.Value = "0"; UserAnswer = UserAnswerValue;
                                List<QuestionAnswers> AnwsList = (from Ans in CorrectAns.Answers where Ans.QuestionId == CorrectAns.QuestionId && Ans.AnswerGroup == "GroupB" orderby Ans.OrderBy select Ans).ToList();

                                string MatchingAnswer = string.Empty;
                                foreach (var List in AnwsList)
                                {
                                    MatchingAnswer += List.OrderBy;

                                }
                                if (UserAnswer == MatchingAnswer)
                                {
                                    CorrectQuestionId.Add(CorrectAns.QuestionId);
                                    IsCorrectAnswer = true;
                                }
                                else
                                {
                                    WrongQuestionId.Add(CorrectAns.QuestionId);
                                    IsCorrectAnswer = false;
                                }


                            }
                            else
                            {
                                if (CorrectAns.CorrectAnswerId == Convert.ToInt32(UserAns.Value))
                                {
                                    CorrectQuestionId.Add(CorrectAns.QuestionId);
                                    IsCorrectAnswer = true;
                                }
                                else
                                {
                                    WrongQuestionId.Add(CorrectAns.QuestionId);
                                    IsCorrectAnswer = false;
                                }


                            }

                            if (UserAns.Value == "0")
                            {
                                Quest.Answer = UserAnswer;
                            }
                            else
                            {
                                QuestionAnswerModel Answer = (from Ans in model.QuestAns where Ans.QuestionId == CorrectAns.QuestionId select Ans).FirstOrDefault();
                                Quest.Answer = (from Ans in Answer.Answers where Ans.AnswerId == Convert.ToInt32(UserAns.Value) select Ans.AnswerValue).FirstOrDefault();
                            }
                            Quest.IsCorrectAnswer = IsCorrectAnswer;
                            ReaderRepository.UpdateQuestionAnswerInfo(Quest);
                            ReaderRepository.Save();
                        }

                    }
                }


                if (CorrectQuestionId.Count() > 0)
                {
                    model.Percentage = CorrectQuestionId.Count() * 100 / model.QuestAns.Count();

                }
                else
                {
                    model.Percentage = 0;
                }

                #region InsertCorrectAnswers

                QuizReports LastQuizRpt = ReaderRepository.QuizReportList(QuizId, accessAccount.CurrentUserId).LastOrDefault();
                LastQuizRpt.QuizEndTime = DateTime.Now;

                List<int> MultipleChoiceCount = new List<int>();
                List<int> FillBlankCount = new List<int>();
                List<int> TrueFalseCount = new List<int>();
                List<int> MactchingCount = new List<int>();
                for (int i = 0; i < CorrectQuestionId.Count(); i++)
                {

                    var TotalMutipleChoiceAns = from MultipleAns in model.QuestAns
                                                where MultipleAns.QuestionTypeId == 1
                                                    && MultipleAns.QuestionId == CorrectQuestionId[i]
                                                select MultipleAns;

                    if (TotalMutipleChoiceAns.Count() > 0)
                    {
                        int MultipleAnsCount = TotalMutipleChoiceAns.Count();
                        MultipleChoiceCount.Add(MultipleAnsCount);
                    }

                    var TotalFillinBlankAns = from FillinBlankAns in model.QuestAns
                                              where FillinBlankAns.QuestionTypeId == 2
                                                  && FillinBlankAns.QuestionId == CorrectQuestionId[i]
                                              select FillinBlankAns;
                    if (TotalFillinBlankAns.Count() > 0)
                    {
                        int BlanksAnsCount = TotalFillinBlankAns.Count();
                        FillBlankCount.Add(BlanksAnsCount);
                    }

                    var TotalTrueOrFalseAns = from TrueOrFalseAns in model.QuestAns
                                              where TrueOrFalseAns.QuestionTypeId == 3
                                                  && TrueOrFalseAns.QuestionId == CorrectQuestionId[i]
                                              select TrueOrFalseAns;
                    if (TotalTrueOrFalseAns.Count() > 0)
                    {
                        int TrueOrFalseAnsCount = TotalMutipleChoiceAns.Count();
                        TrueFalseCount.Add(TrueOrFalseAnsCount);
                    }

                    var TotalMatchingAns = from MatchingAns in model.QuestAns
                                           where MatchingAns.QuestionTypeId == 4
                                               && MatchingAns.QuestionId == CorrectQuestionId[i]
                                           select MatchingAns;
                    if (TotalMatchingAns.Count() > 0)
                    {
                        int MatchingAnsCount = TotalMutipleChoiceAns.Count();
                        MactchingCount.Add(MatchingAnsCount);
                    }
                }

                if (MultipleChoiceCount.Count > 0)
                    LastQuizRpt.MulitpleChoiceAns = MultipleChoiceCount.Count;
                else
                    LastQuizRpt.MulitpleChoiceAns = 0;

                if (FillBlankCount.Count > 0)
                    LastQuizRpt.FillInBlanksAns = FillBlankCount.Count;
                else
                    LastQuizRpt.FillInBlanksAns = 0;

                if (TrueFalseCount.Count > 0)
                    LastQuizRpt.TrueorFalseAns = TrueFalseCount.Count;
                else
                    LastQuizRpt.TrueorFalseAns = 0;

                if (MactchingCount.Count > 0)
                    LastQuizRpt.MatchingAns = MactchingCount.Count;
                else
                    LastQuizRpt.MatchingAns = 0;

                LastQuizRpt.PassedScore = model.Percentage;
                if (LastQuizRpt.PassingScore > LastQuizRpt.PassedScore)
                {
                    LastQuizRpt.QuizResult = "Fail";
                }
                else if (LastQuizRpt.PassingScore <= LastQuizRpt.PassedScore)
                {
                    LastQuizRpt.QuizResult = "Pass";
                }
                ReaderRepository.UpdateQuizReport(LastQuizRpt);
                ReaderRepository.Save();
                #endregion


                return RedirectToAction("ResultPage", "Reader", new { QuizId = QuizId, ClassId = ClassId });

            }
            #endregion
            model.IsLeaveExam = false;
            return View(model);
        }

        [HttpPost]
        public ActionResult ResultPage(ReaderModel model, int QuizId = 0)
        {
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();

            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            #endregion

            model.QuestAns = ReaderRepository.ResultQuestionAnswers(QuizId, accessAccount.CurrentUserId).OrderBy(p => p.QuestionAnswerInfoId).ToList();
            model.QuestAnsData = (from WrongAns in model.QuestAns where WrongAns.IsCorrectAnswer != true select WrongAns).OrderBy(p => p.QuestionAnswerInfoId).ToList();
            if (model.QuestAnsData != null)
            {
                model.CorrectAnswersCount = model.QuestAns.Count - model.QuestAnsData.Count;
            }

            LoadQuizDetails(model, QuizId);
            LoadIndex(model);
            ViewBag.IsPublisher = true;
            if (model.ClassId != 0)
            {
                ViewBag.ClassId = model.ClassId;
            } 

            QuizReports LastQuizRpt = ReaderRepository.QuizReportList(QuizId, accessAccount.CurrentUserId).LastOrDefault();
            model.QuizReportForm = new QuizReports();
            model.QuizReportForm.QuizStartTime = LastQuizRpt.QuizStartTime;
            model.QuizReportForm.QuizEndTime = LastQuizRpt.QuizEndTime;
            model.Percentage = LastQuizRpt.PassedScore.Value;

            model.QuestionCount = 1;
            model.IsWrongsList = true;
            return View(model);
        }


        //Functions://Exam/
        private void LoadQuizDetails(ReaderModel model, int QuizId)
        {
            model.QuizForm = new Quizzes();
            Quizzes Quiz = ReaderRepository.GetQuizDetails(QuizId);
            if (Quiz != null)
            {
                model.QuizForm.QuizId = Quiz.QuizId;
                model.QuizForm.QuizTitle = Quiz.QuizTitle;
                model.QuizForm.Instructions = Quiz.Instructions;
                model.QuizForm.PassingScore = Quiz.PassingScore;
                model.QuizForm.TimeAllowed = Quiz.TimeAllowed;
                model.QuizForm.DisplayAnswers = Quiz.DisplayAnswers;
                model.QuizForm.ExamTimed = Quiz.ExamTimed;
                model.QuizForm.QuestionOrder = Quiz.QuestionOrder;
                model.QuizForm.QuestionAmount = Quiz.QuestionAmount;
                model.QuizForm.AttemptLimit = Quiz.AttemptLimit;
                model.QuizForm.FeedbackPass = Quiz.FeedbackPass;
                model.QuizForm.FeedbackFail = Quiz.FeedbackFail;


            }
        }
        private void LoadRandomOrStaticQuestions(ReaderModel model, int QuizId)
        {
            model.QuestAns = new List<QuestionAnswerModel>();
            model.RandomQuestAns = new List<QuestionAnswerModel>();
            int QuestionAmount = model.QuizForm.QuestionAmount != null ? model.QuizForm.QuestionAmount.Value :0;
            model.QuestAns = ReaderRepository.QuestionAnswer(QuizId).OrderBy(p => p.QuestionId).Take(QuestionAmount).ToList();
            if (model.QuizForm.QuestionOrder == true)
            {
                var random = new Random();

                int size = model.QuestAns.Count;
                while (size > 0)
                {
                    size--;
                    int index = (new Random()).Next(0, size);
                    QuestionAnswerModel elem = model.QuestAns[index];
                    model.QuestAns[index] = model.QuestAns[size];
                    model.RandomQuestAns.Add(elem);
                }
                model.QuestAns = model.RandomQuestAns.ToList();
            }
        }
        private void LoadIndex(ReaderModel model)
        {
            string DefaultClassName = string.Empty;
            string DefaultPublisherName = string.Empty;

            int classId = 0;

            Int32.TryParse(Convert.ToString(model.ClassId), out classId);
            ReaderRepository.GetAllClass(accessAccount.CurrentUserId, ref model.ReaderClasses, ref model.ReaderPublisher, ref model.ReaderContents, ref DefaultPublisherName, ref DefaultClassName, classId);
            SetMenuProperties("Dashboard", DefaultPublisherName, DefaultClassName, model.QuizForm.QuizTitle);

        }

        #endregion

        #region ClassPayment

        public ActionResult ClassPayment(int ClassId = 0)
        {
            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();
            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            else if (!string.IsNullOrEmpty(accessAccount.AccessCode))
            {
                return RedirectToAction("BuildClass", "Publisher");
            }
            #endregion

            var model = new ReaderModel();
            string DefaultClassName = string.Empty;
            string DefaultPublisherName = string.Empty;

            ReaderRepository.GetAllClass(accessAccount.CurrentUserId, ref model.ReaderClasses, ref model.ReaderPublisher, ref model.ReaderContents, ref DefaultPublisherName, ref DefaultClassName, ClassId);

            #region YearMonthDropDownFor Expiry Date
            List<SelectListItem> ExpirationDateMonthDropDown = new List<SelectListItem>();
            DateTime now = DateTime.Now;
            for (int i = 1; i <= 12; i++)
            {
                SelectListItem slMonth = new SelectListItem();
                DateTime month = new DateTime(2000, i, 1);
                var currentmonth = now.Month;
                ListItem li = new ListItem(month.ToString("MMM (M)"), month.ToString("MM"));

                // DateTime month = new DateTime(2000, i, 1);
                //ListItem li = new ListItem(now.ToString("MMM (M)"), now.ToString("MM"));
                slMonth.Text = Convert.ToString(li.Text);
                slMonth.Value = Convert.ToString(li.Value);

                ExpirationDateMonthDropDown.Add(slMonth);
                int mon = DateTime.Now.Month;
                int yr = DateTime.Now.Year;


            }
            List<SelectListItem> ExpirationDateYearDropDown = new List<SelectListItem>();
            for (int i = 0; i <= 11; i++)
            {
                SelectListItem slYear = new SelectListItem();
                String year = (DateTime.Today.Year + i).ToString();
                ListItem li = new ListItem(year, year);
                slYear.Text = Convert.ToString(li.Text);
                slYear.Value = Convert.ToString(li.Value);

                ExpirationDateYearDropDown.Add(slYear);

            }
            ViewData["MonthNames"] = ExpirationDateMonthDropDown;
            ViewData["YearNames"] = ExpirationDateYearDropDown;
            #endregion
            ViewBag.ClassId = ClassId;
            model.ClassPay = new ClassPayment();
            model.ClassPay.ClassId = ClassId;
            ViewBag.IsPublisher = true;
            SetMenuProperties("Dashboard", DefaultPublisherName, DefaultClassName, "Payment");

            return View(model);
        }

        [HttpPost]
        public ActionResult ClassPayment(ReaderModel model, FormCollection collection)
        {

            #region Check Authentication
            ActionResult loginActionResult = UserAuthentication();
            if (accessAccount.CurrentUserId == 0)
                return loginActionResult;
            #endregion


            if (ValidateClasssPayment(model, collection))
            {
                ClassPayment clspay = new Models.ClassPayment();
                clspay.ClassId = model.ClassPay.ClassId;

                clspay.CreditCardHolderName = model.ClassPay.CreditCardHolderName;
                clspay.CreditCardNumber = model.ClassPay.CreditCardNumber;
                stringCryptography = new StringCryptography();
                clspay.CVVNumber = stringCryptography.GetMD5HashData(model.ClassPay.CVVNumber);
                clspay.PaidDate = DateTime.Now;
                clspay.PaymentStatus = true;
                clspay.ReaderUserId = accessAccount.CurrentUserId;

                var ExpiryMonth = collection.GetValues("Months")[0].ToString();
                var ExpiryYear = collection.GetValues("Years")[0].ToString();
                clspay.CardExpiryMonth = Convert.ToInt32(ExpiryMonth);
                clspay.CardExpiryYear = Convert.ToInt32(ExpiryYear);
                ReaderRepository.InsertClassPaymenet(clspay);
                ReaderRepository.Save();
                model.ValidationMessageType = "success";
                model.ValidationMessage = "Your Payment has been done successfully. You have been subscribed to ";
                TempData["ClassPaymentModel"] = model;
                return RedirectToAction("Dashboard", "Reader", new { id = model.ClassPay.ClassId });
            }
            else
            {
                model.ValidationMessage = pagemessage;
                model.ValidationMessageType = "error";
                string DefaultClassName = string.Empty;
                string DefaultPublisherName = string.Empty;
                ReaderRepository.GetAllClass(accessAccount.CurrentUserId, ref model.ReaderClasses, ref model.ReaderPublisher, ref model.ReaderContents, ref DefaultPublisherName, ref DefaultClassName, model.ClassPay.ClassId.Value);

                #region YearMonthDropDownFor Expiry Date
                List<SelectListItem> ExpirationDateMonthDropDown = new List<SelectListItem>();
                DateTime now = DateTime.Now;
                for (int i = 1; i <= 12; i++)
                {
                    SelectListItem slMonth = new SelectListItem();
                    DateTime month = new DateTime(2000, i, 1);
                    ListItem li = new ListItem(month.ToString("MMM (M)"), month.ToString("MM"));
                    // DateTime month = new DateTime(2000, i, 1);
                    //ListItem li = new ListItem(month.ToString("MMM (M)"), month.ToString("MM"));

                    slMonth.Text = Convert.ToString(li.Text);
                    slMonth.Value = Convert.ToString(li.Value);
                    if (collection.GetValues("Months").Count() > 0)
                    {
                        if (!string.IsNullOrEmpty(collection.GetValues("Months")[0]))
                        {
                            if (collection.GetValues("Months")[0] == slMonth.Value)
                            {
                                slMonth.Selected = true;

                            }
                        }
                    }
                    ExpirationDateMonthDropDown.Add(slMonth);
                    int mon = DateTime.Now.Month;
                    int yr = DateTime.Now.Year;

                }
                List<SelectListItem> ExpirationDateYearDropDown = new List<SelectListItem>();
                for (int i = 0; i <= 11; i++)
                {
                    SelectListItem slYear = new SelectListItem();
                    String year = (DateTime.Today.Year + i).ToString();
                    ListItem li = new ListItem(year, year);
                    slYear.Text = Convert.ToString(li.Text);
                    slYear.Value = Convert.ToString(li.Value);
                    if (collection.GetValues("Years").Count() > 0)
                    {
                        if (!string.IsNullOrEmpty(collection.GetValues("Years")[0]))
                        {
                            if (collection.GetValues("Years")[0] == slYear.Value)
                            {
                                slYear.Selected = true;

                            }
                        }
                    }

                    ExpirationDateYearDropDown.Add(slYear);

                }
                ViewData["MonthNames"] = ExpirationDateMonthDropDown;
                ViewData["YearNames"] = ExpirationDateYearDropDown;
                #endregion

                ViewBag.ClassId = model.ClassPay.ClassId;
                ViewBag.IsPublisher = true;
                SetMenuProperties("Dashboard", DefaultPublisherName, DefaultClassName, "Payment");
            }
            return View(model);
        }

        private bool ValidateClasssPayment(ReaderModel model, FormCollection collection)
        {
            bool retval = true;


            if (string.IsNullOrEmpty(model.ClassPay.CreditCardHolderName))
            {

                pagemessage += "* Name is required.<br/>"; retval = false;
            }
            else
            {
                if (model.ClassPay.CreditCardHolderName.Length < 4)
                {
                    pagemessage += "* Name must be greater than 4 Characters.<br/>";
                    retval = false;
                }

            }
            if (model.ClassPay.CreditCardNumber == null)
            { pagemessage += "* Credit Card Number is required.<br/>"; retval = false; }
            else
            {
                bool IsNumeric = true;
                List<char> chars = model.ClassPay.CreditCardNumber.ToList<char>();
                IsNumeric = !chars.Any(c => !Char.IsNumber(c));

                if (!IsNumeric)
                {
                    pagemessage += "*Credit Card Number must be numbers.<br/>";
                    retval = false;
                }
                else if (model.ClassPay.CreditCardNumber.ToString().Length != 16)
                {
                    pagemessage += "*Credit Card Number must be 16 digits.<br/>";
                    retval = false;
                }
            }
            if (string.IsNullOrEmpty(model.ClassPay.CVVNumber))
            { pagemessage += "* CVV Number is required.<br/>"; retval = false; }
            else
            {
                bool IsNumeric = true;
                List<char> chars = model.ClassPay.CVVNumber.ToList<char>();
                IsNumeric = !chars.Any(c => !Char.IsNumber(c));

                if (!IsNumeric)
                {
                    pagemessage += "* CVV Number must be numbers.<br/>";
                    retval = false;
                }
                if (model.ClassPay.CVVNumber.Length != 3)
                {
                    pagemessage += "* CVV Number must be 3 digits.<br/>";
                    retval = false;
                }
            }
            if (collection.GetValues("Months").Count() > 0)
            {
                if (string.IsNullOrEmpty(collection.GetValues("Months")[0])) { pagemessage += "* Month is required.<br/>"; retval = false; }
                else
                {
                    DateTime now = DateTime.Now;
                    if (now.Month > Convert.ToInt32(collection.GetValues("Months")[0]))
                    {
                        if (collection.GetValues("Years").Count() > 0 && !string.IsNullOrEmpty(collection.GetValues("Years")[0]))
                        {
                            if (now.Year == Convert.ToInt32(collection.GetValues("Years")[0]))
                            {
                                pagemessage += "*Month should not be less than the current year.<br/>"; retval = false;
                            }
                        }
                    }
                }
            }
            if (collection.GetValues("Years").Count() > 0)
            {
                if (string.IsNullOrEmpty(collection.GetValues("Years")[0])) { pagemessage += "* Year is required.<br/>"; retval = false; }
            }

            return retval;
        }
        #endregion

        #region Common

        private ActionResult UserAuthentication()
        {
            RedirectToRouteResult returnAction = null;

            if (Session["AccessModel"] != null)
            {
                accessAccount = (AccessModel)Session["AccessModel"];
            }
            else
            {
                returnAction = RedirectToAction("SignIn", "Account");
            }

            if (accessAccount != null)
            {
                ViewBag.DisplayName = accessAccount.DisplayName;
                ViewBag.CompanyLogo = accessAccount.PublisherCompanyLogo;
                ViewBag.CurrentUser_FirstName = accessAccount.CurrentUser_FirstName;
                ViewBag.CurrentUser_LastName = accessAccount.CurrentUser_LastName;
                ViewBag.PublisherUser_FirstName = accessAccount.PublisherUser_FirstName;
                ViewBag.PublisherUser_LastName = accessAccount.PublisherUser_LastName;
                return null;
            }
            else
            {
                accessAccount = new AccessModel();

                return returnAction;
            }
        }

        private void SetMenuProperties(string DefaultName, string mainmenu_name, string sidemenu_name, string pagenavigation_name)
        {
            ViewBag.Title = "IntelSkill - " + pagenavigation_name;
            ViewBag.DefaultName = DefaultName;
            ViewBag.MenuNavigation = mainmenu_name;
            ViewBag.SideMenuNavigation = sidemenu_name;
            ViewBag.PageNavigation = pagenavigation_name;
            if (string.IsNullOrEmpty(ViewBag.MenuNavigation) && string.IsNullOrEmpty(ViewBag.SideMenuNavigation) && string.IsNullOrEmpty(ViewBag.PageNavigation))
            {
                ViewBag.Title = "IntelSkill - " + ViewBag.DefaultName;
            }
            else if (!string.IsNullOrEmpty(ViewBag.PageNavigation))
            {
                ViewBag.Title = "IntelSkill - " + ViewBag.PageNavigation;
            }
            else
            {
                ViewBag.Title = "IntelSkill - " + ViewBag.MenuNavigation + " - " + ViewBag.SideMenuNavigation;
            }

        }

        private void SearchResults(string searchtext, ref ReaderModel model, int page, int UserId)
        {

            model.TotalClassContent = ReaderRepository.GetClasses(searchtext).ToList();
            if (model.IsStep2 != true)
            {
                model.TotalClassContent = ReaderRepository.GetClassbyPublisher(searchtext, UserId).ToList();
                if (model.TotalClassContent.Count() == 0)
                {
                    model.TotalClassContent = ReaderRepository.GetContents(searchtext, accessAccount.CurrentUserId).ToList();
                }
            }


        }

        //Advanced Search
        private void AdvanceSearchResults(string clastype, string CatsId, string Pubsid, string IsQuiz, ref ReaderModel model, int page, int userid)
        {

            model.ClassContentModel = ReaderRepository.AdvancedSearchClasses(clastype, CatsId, Pubsid, IsQuiz).ToList();
            if (model.IsStep2 != true)
            {
                model.ClassContentModel = ReaderRepository.AdvancedSearchClassesbyPublisher(clastype, CatsId, Pubsid, IsQuiz, userid).ToList();
            }

        }

        public void LoadSearchData(string search_query, ReaderModel model, string ddlselectclass, string ddlPublishervalue, string ddlCategoryvalue, string ddlHasQuiz, int page)
        {
            int userid = 0;
            if (model.UserId != 0)
            {
                userid = model.UserId;

            }
            else
            {
                userid = accessAccount.CurrentUserId;
            }

            if (!string.IsNullOrEmpty(search_query))
            {

                SearchResults(search_query, ref model, 1, userid);
                if (model.TotalClassContent.Count() > 0)
                {

                    if (model.TotalClassContent.FirstOrDefault().ClassId > 0)
                    {
                        model.IsSearchClass = true;

                    }
                }

            }

            if (!string.IsNullOrEmpty(ddlselectclass) || !string.IsNullOrEmpty(ddlPublishervalue) || !string.IsNullOrEmpty(ddlCategoryvalue) || !string.IsNullOrEmpty(ddlHasQuiz))
            {
                model.IsAdvancedSearch = true;
                AdvanceSearchResults(ddlselectclass, ddlCategoryvalue, ddlPublishervalue, ddlHasQuiz, ref model, 1, userid);
                if (model.ClassContentModel.Count() > 0)
                {
                    if (!string.IsNullOrEmpty(search_query))
                    {
                        if (model.TotalClassContent.Count() > 0)
                        {
                            List<ReaderContentModel> FilterClasses = new List<ReaderContentModel>();
                            foreach (var ContentModel in model.TotalClassContent)
                            {
                                foreach (var ClassContentModel in model.ClassContentModel)
                                {
                                    if (ContentModel.ClassId == ClassContentModel.ClassId)
                                    {
                                        FilterClasses.Add(ContentModel);
                                    }
                                }
                            }
                            model.ClassContentModel = FilterClasses;
                            model.TotalClassContent = model.ClassContentModel;
                        }
                        else
                        {
                            model.IsSearchClass = true;
                            model.TotalClassContent = null;
                        }

                    }
                    else
                    {
                        model.TotalClassContent = model.ClassContentModel;
                        model.IsSearchClass = true;
                    }
                }
                else
                {
                    model.TotalClassContent = model.ClassContentModel;
                    model.IsSearchClass = true;
                }


            }




            model.ClassSubscription = ReaderRepository.GetClassSubscription(userid);
            if (Session["ReaderContentModel"] != null)
            {
                Session["ReaderContentModel"] = null;
                Session["ReaderContentModel"] = model;
            }
            else
            {
                Session["ReaderContentModel"] = model;
            }

        }
        private void LoadCategoriesPublishers()
        {
            #region Load Categories And Publishers
            // For Categories Loading.
            List<SelectListItem> CategoryName = new List<SelectListItem>();

            List<Categories> listCatg = ReaderRepository.Getallcategories().ToList();

            foreach (var CatgName in listCatg)
            {
                SelectListItem sl = new SelectListItem();
                sl.Text = Convert.ToString(CatgName.CategoryName);
                sl.Value = Convert.ToString(CatgName.CategoryId);
                CategoryName.Add(sl);
            }

            // For Publishers Loading.
            List<SelectListItem> PubNames = new List<SelectListItem>();

            List<Users> PbNames = ReaderRepository.GetAllPublisher().ToList();
            foreach (var PName in PbNames)
            {
                SelectListItem s2 = new SelectListItem();
                s2.Text = Convert.ToString(PName.FirstName + "" + PName.LastName);
                s2.Value = Convert.ToString(PName.UserId);
                PubNames.Add(s2);
            }
            ViewData["ddlContentCatg"] = CategoryName;
            ViewData["ddlPublisherNames"] = PubNames;
            #endregion

        }
        private void LoadSelectedCategoriesPublishers(FormCollection coll)
        {
            #region Load Publisher,Category in DropDown
            var ddlCategoryvalue = coll.GetValues("Categrys")[0].ToString();
            var ddlPublishervalue = coll.GetValues("PubNames")[0].ToString();
            List<SelectListItem> CategoryName = new List<SelectListItem>();
            List<Categories> listCatg = ReaderRepository.Getallcategories().ToList();
            foreach (var CatgName in listCatg)
            {
                SelectListItem sl = new SelectListItem();
                sl.Text = Convert.ToString(CatgName.CategoryName);
                sl.Value = Convert.ToString(CatgName.CategoryId);
                if ((!string.IsNullOrEmpty(ddlCategoryvalue)))
                {

                    if (ddlCategoryvalue == Convert.ToString(CatgName.CategoryId))
                    {
                        sl.Selected = true;

                    }
                }

                CategoryName.Add(sl);

            }

            List<SelectListItem> PubNames = new List<SelectListItem>();

            List<Users> PbNames = ReaderRepository.GetAllPublisher().ToList();



            foreach (var PName in PbNames)
            {
                SelectListItem s2 = new SelectListItem();
                s2.Text = Convert.ToString(PName.FirstName + "" + PName.LastName);
                s2.Value = Convert.ToString(PName.UserId);

                if ((!string.IsNullOrEmpty(ddlPublishervalue)))
                {

                    if (ddlPublishervalue == Convert.ToString(PName.UserId))
                    {
                        s2.Selected = true;
                    }
                }

                PubNames.Add(s2);
            }

            ViewData["ddlContentCatg"] = CategoryName;
            ViewData["ddlPublisherNames"] = PubNames;
            #endregion
        }
        private void LoadPageSelectedCategoriesPublishers(string Pubhlisher, string Category)
        {
            #region Load Publisher,Category in DropDown
            List<SelectListItem> CategoryName = new List<SelectListItem>();
            List<Categories> listCatg = ReaderRepository.Getallcategories().ToList();
            foreach (var CatgName in listCatg)
            {
                SelectListItem sl = new SelectListItem();
                sl.Text = Convert.ToString(CatgName.CategoryName);
                sl.Value = Convert.ToString(CatgName.CategoryId);
                if ((!string.IsNullOrEmpty(Category)))
                {

                    if (Category == Convert.ToString(CatgName.CategoryId))
                    {
                        sl.Selected = true;

                    }
                }

                CategoryName.Add(sl);

            }

            List<SelectListItem> PubNames = new List<SelectListItem>();
            List<Users> PbNames = ReaderRepository.GetAllPublisher().ToList();
            foreach (var PName in PbNames)
            {
                SelectListItem s2 = new SelectListItem();
                s2.Text = Convert.ToString(PName.FirstName + "" + PName.LastName);
                s2.Value = Convert.ToString(PName.UserId);

                if ((!string.IsNullOrEmpty(Pubhlisher)))
                {

                    if (Pubhlisher == Convert.ToString(PName.UserId))
                    {
                        s2.Selected = true;
                    }
                }

                PubNames.Add(s2);
            }

            ViewData["ddlContentCatg"] = CategoryName;
            ViewData["ddlPublisherNames"] = PubNames;
            #endregion
        }
        private void LoadSelectedCategoriesPublishersReader(FormCollection coll)
        {
            #region Load Publisher,Category in DropDown
            var ddlCategoryvalue = coll.GetValues("Categrys")[0].ToString();
            var ddlPublishervalue = coll.GetValues("PubNames")[0].ToString();
            List<SelectListItem> CategoryName = new List<SelectListItem>();
            List<Categories> listCatg = ReaderRepository.Getallcategories().ToList();
            foreach (var CatgName in listCatg)
            {
                SelectListItem sl = new SelectListItem();
                sl.Text = Convert.ToString(CatgName.CategoryName);
                sl.Value = Convert.ToString(CatgName.CategoryId);
                if ((!string.IsNullOrEmpty(ddlCategoryvalue)))
                {

                    if (ddlCategoryvalue == Convert.ToString(CatgName.CategoryId))
                    {
                        sl.Selected = true;

                    }
                }

                CategoryName.Add(sl);

            }

            List<SelectListItem> PubNames = new List<SelectListItem>();
            List<Users> PbNames = ReaderRepository.GetAllPublisherForReader(accessAccount.CurrentUserId).ToList();
            foreach (var PName in PbNames)
            {
                SelectListItem s2 = new SelectListItem();
                s2.Text = Convert.ToString(PName.FirstName + "" + PName.LastName);
                s2.Value = Convert.ToString(PName.UserId);

                if ((!string.IsNullOrEmpty(ddlPublishervalue)))
                {

                    if (ddlPublishervalue == Convert.ToString(PName.UserId))
                    {
                        s2.Selected = true;
                    }
                }

                PubNames.Add(s2);
            }

            ViewData["ddlContentCatg"] = CategoryName;
            ViewData["ddlPublisherNames"] = PubNames;
            #endregion
        }
        private void LoadPageSelectedCategoriesPublishersForReader(string Pubhlisher, string Category)
        {
            #region Load Publisher,Category in DropDown
            List<SelectListItem> CategoryName = new List<SelectListItem>();
            List<Categories> listCatg = ReaderRepository.Getallcategories().ToList();
            foreach (var CatgName in listCatg)
            {
                SelectListItem sl = new SelectListItem();
                sl.Text = Convert.ToString(CatgName.CategoryName);
                sl.Value = Convert.ToString(CatgName.CategoryId);
                if ((!string.IsNullOrEmpty(Category)))
                {

                    if (Category == Convert.ToString(CatgName.CategoryId))
                    {
                        sl.Selected = true;

                    }
                }

                CategoryName.Add(sl);

            }

            List<SelectListItem> PubNames = new List<SelectListItem>();
            List<Users> PbNames = ReaderRepository.GetAllPublisherForReader(accessAccount.CurrentUserId).ToList();
            foreach (var PName in PbNames)
            {
                SelectListItem s2 = new SelectListItem();
                s2.Text = Convert.ToString(PName.FirstName + "" + PName.LastName);
                s2.Value = Convert.ToString(PName.UserId);

                if ((!string.IsNullOrEmpty(Pubhlisher)))
                {

                    if (Pubhlisher == Convert.ToString(PName.UserId))
                    {
                        s2.Selected = true;
                    }
                }

                PubNames.Add(s2);
            }

            ViewData["ddlContentCatg"] = CategoryName;
            ViewData["ddlPublisherNames"] = PubNames;
            #endregion
        }
        #endregion


    }
}
