﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using IntelSkill.Models;
using IntelSkill.Repository;
using System.Data;


namespace IntelSkill.DAL
{
    public class ContentRepository : IContentRepository
    {
        private SQLDBContext sqldbcontext;

        public ContentRepository(SQLDBContext sqldbcontext)
        {
            this.sqldbcontext = sqldbcontext;
        }

        public IEnumerable<Contents> GetContentList(string ContentTitle, int UserId)
        {
            var Contentdetails = (from c in sqldbcontext.Contents where (c.ContentTitle == ContentTitle && c.PublisherUserId == UserId) select c);
            return Contentdetails.ToList();
        }

        public IEnumerable<Contents> GetContentListById(int ContentId)
        {
            var Contentdetails = (from c in sqldbcontext.Contents where (c.ContentId == ContentId) select c);
            return Contentdetails.ToList();
        }

        public List<Contents> GetContentListbyUserId(int UserID)
        {


            List<Contents> Contdetails = (from c in sqldbcontext.Contents where (c.PublisherUserId == UserID) select c).ToList();


            return Contdetails;
        }

        public int GetContentId(string ContentTitle)
        {
            int ContentId = (from c in sqldbcontext.Contents where (c.ContentTitle == ContentTitle) select c.ContentId).FirstOrDefault<int>();
            return ContentId;
        }


        public IEnumerable<Contents> GetAllContentList()
        {
            return sqldbcontext.Contents.ToList();
        }

        public IEnumerable<ContentPages> GetContentPages(int ContentId)
        {
            var contentId = (from c in sqldbcontext.ContentPages where (c.ContentId == ContentId) select c);
            return contentId.ToList();
        }

        public List<ContentCategories> GetContentCategory(int ContentId)
        {
            var CategoryId = (from c in sqldbcontext.ContentCategories where (c.ContentId == ContentId) select c).ToList();
            return CategoryId;
        }

        public string GetContentTitle(int ContentId)
        {
            string contentTitle = (from c in sqldbcontext.Contents where (c.ContentId == ContentId) select c.ContentTitle).FirstOrDefault<string>();
            return contentTitle;
        }

        public void InsertContent(Contents Content)
        {
            sqldbcontext.Contents.Add(Content);
        }

        public void InsertContentPage(ContentPages ContentPage)
        {
            sqldbcontext.ContentPages.Add(ContentPage);
        }

        public void InsertContentPageAttach(ContentAttachments ContentPageAtt)
        {
            sqldbcontext.ContentAttachments.Add(ContentPageAtt);
        }

        public void UpdateContent(Contents Content)
        {
            sqldbcontext.Entry(Content).State = EntityState.Modified;
        }

        public void UpdateContentPage(ContentPages ContentPage)
        {
            sqldbcontext.Entry(ContentPage).State = EntityState.Modified;
        }

        public void DeleteContPagebyId(int PageId)
        {

            ContentPages ContPages = sqldbcontext.ContentPages.Find(PageId);
            sqldbcontext.ContentPages.Remove(ContPages);

        }

        public bool DeleteContent(int ContId)
        {

            var ContAttactId = (from CA in sqldbcontext.ContentAttachments where (CA.ContentId == ContId) select CA);
            if (ContAttactId != null)
            {
                foreach (var contentAttachment in ContAttactId)
                { 
                    sqldbcontext.ContentAttachments.Remove(contentAttachment);
                }
            }

            var  ContIdPage = (from cp in sqldbcontext.ContentPages where (cp.ContentId == ContId) select cp);
            if (ContIdPage != null)
            {
                foreach (var PageId in ContIdPage)
                { 
                    sqldbcontext.ContentPages.Remove(PageId);
                }
            }
            var ContCtgId = (from c in sqldbcontext.ContentCategories where (c.ContentId == ContId) select c);
            if (ContCtgId != null)
            {
                foreach (var Id in ContCtgId)
                { 
                    sqldbcontext.ContentCategories.Remove(Id);
                }
            }
            var ContClass = (from c in sqldbcontext.ClassContents where (c.ContentId == ContId) select c);
            if (ContClass != null)
            {
                foreach (var Id in ContClass)
                { 
                    sqldbcontext.ClassContents.Remove(Id);
                }
            }
            Contents Cont = sqldbcontext.Contents.Find(ContId);
            if (Cont != null)
            {
                sqldbcontext.Contents.Remove(Cont);
                return true;
            }
            else
            {
                return false;
            }
        }

        //public int GetLastContPageId()
        //{
        //    return sqldbcontext.ContentPages.OrderByDescending(x => x.ContentPageId).FirstOrDefault().ContentPageId;

        //}

        public int GetContPageId(int ContId)
        {
            int ContentId = (from c in sqldbcontext.ContentPages where (c.ContentId == ContId) select c.ContentPageId).FirstOrDefault<int>();
            return ContentId;
        }

        public int GetContIdbyPageId(int PageId)
        {
            int ContentId = (from c in sqldbcontext.ContentPages where (c.ContentPageId == PageId) select c.ContentId.Value).FirstOrDefault<int>();
            return ContentId;
        }
        public void Save()
        {
            sqldbcontext.SaveChanges();
        }


        public IEnumerable<Categories> GetCategories(int UserId)
        {
            return from c in sqldbcontext.Categories where (c.PublisherUserId == UserId) select c;
        }

        public void InsertCategories(Categories Categories) { sqldbcontext.Categories.Add(Categories); }

        public void DeleteCategories(int CategoryId)
        {
            var ContCtgId = (from c in sqldbcontext.ContentCategories where (c.CategoryId == CategoryId) select c);
            if (ContCtgId!=null)
            {
                foreach (var ContCatgoryId in ContCtgId)
                { 
                    sqldbcontext.ContentCategories.Remove(ContCatgoryId);
                }
                sqldbcontext.SaveChanges();
            }

            Categories Categories = sqldbcontext.Categories.Find(CategoryId);
            if (Categories != null)
            {
                sqldbcontext.Categories.Remove(Categories);
            }
        }

        public void UpdateCategories(Categories Catg)
        {
            sqldbcontext.Entry(Catg).State = EntityState.Modified;
        }

        public void InsertContCategories(ContentCategories ContCategories)
        {
            sqldbcontext.ContentCategories.Add(ContCategories);

        }

        public void DeleteContCategories(int ContentId)
        {
            var ContCtgId = (from c in sqldbcontext.ContentCategories where (c.ContentId == ContentId) select c);
            foreach (var loopCC in ContCtgId)
            {                
                sqldbcontext.ContentCategories.Remove(loopCC);
                
            }
            // int CtgPageId = (from cp in sqldbcontext.ContentPages where (cp.ContentPageId == CtgId) select cp.ContentPageId).FirstOrDefault<int>();
        }

        public void DeleteContPages(int ContentId)
        {
            var ContPageId = (from c in sqldbcontext.ContentPages where (c.ContentId == ContentId) select c);
            foreach (var contentPage in ContPageId)
            { 
                sqldbcontext.ContentPages.Remove(contentPage);
            }
            // int CtgPageId = (from cp in sqldbcontext.ContentPages where (cp.ContentPageId == CtgId) select cp.ContentPageId).FirstOrDefault<int>();
        }
        public List<string> GetCategoryName(int ContId)
        {
            List<int> CatgId = (from c in sqldbcontext.ContentCategories where (c.ContentId == ContId) select c.CategoryId.Value).ToList();
            List<string> CatgName = new List<string>();
            foreach (int CatgIdList in CatgId)
            {
                string CategoryName = (from c in sqldbcontext.Categories where (c.CategoryId == CatgIdList) select c.CategoryName).FirstOrDefault<string>();
                CatgName.Add(CategoryName);
            }
            return CatgName;
        }


        public Categories GetCategorybyId(int CatgId)
        {
            return (from c in sqldbcontext.Categories where (c.CategoryId == CatgId) select c).FirstOrDefault();

          
        }
        public int GetCategoryId(string CatgName, int UserId)
        {
            int CatgId = (from c in sqldbcontext.Categories where (c.CategoryName == CatgName && c.PublisherUserId == UserId) select c.CategoryId).FirstOrDefault<int>();

            return CatgId;
        }

        public List<int> GetCategoryContentId(int CatgId)
        {
            List<int> ContId = (from c in sqldbcontext.ContentCategories where (c.CategoryId == CatgId) select c.ContentId.Value).ToList();


            return ContId;
        }

        public string GetUsername(int UserId)
        {
            string Username = (from c in sqldbcontext.Users where (c.UserId == UserId) select c.FirstName + " " + c.LastName).FirstOrDefault<string>();


            return Username;
        }



        public string PageDesc(int PageId)
        {
            string Desc = (from c in sqldbcontext.ContentPages where (c.ContentPageId == PageId) select c.PageDescription).FirstOrDefault<string>();

            return Desc;
        }

        public List<string> GetContentImageUrl(int ContentId)
        {
            return (from c in sqldbcontext.ContentAttachments where (c.ContentId == ContentId) select c.FolderFileName).ToList();
        }

        #region OverViewClass-Content-Student-QuizResult

        public List<ContentListModel.OverViewClassContent> GetContentsbyClassId(int ClassId)
        {
            return (from classes in sqldbcontext.Classes
                    join ClsContents in sqldbcontext.ClassContents
                    on classes.ClassId equals ClsContents.ClassId

                    //Contents
                    join Content in sqldbcontext.Contents on ClsContents.ContentId equals Content.ContentId

                    where classes.ClassId == ClassId

                    select new ContentListModel.OverViewClassContent
                    {
                        ContentId = Content.ContentId
                        ,
                        ContentTitle = Content.ContentTitle
                        ,
                        ContentStatus = Content.ContentStatus
                        ,
                        CategoryNames = (from Catgs in sqldbcontext.ContentCategories
                                         join CatgName in sqldbcontext.Categories on Catgs.CategoryId equals CatgName.CategoryId
                                         where Catgs.ContentId == Content.ContentId
                                         select CatgName.CategoryName)
                        ,
                        PublishedDate = Content.PublishedDate
                       ,
                        NoOfStudents = (from ContClas in sqldbcontext.ClassContents
                                        join ClsSubs in sqldbcontext.ClassSubscriptions on ContClas.ClassId equals ClsSubs.ClassId
                                        where ContClas.ContentId == Content.ContentId && ClsSubs.SubscriptionStatus==1
                                        group ClsSubs by new { ClsSubs.RequestedUserId } into g
                                        select g).Count()
                       ,
                        ExamAttended = (from ContQuiz in sqldbcontext.Contents
                                        join StudentRpt in sqldbcontext.QuizReports on ContQuiz.QuizId equals StudentRpt.QuizId
                                        where ContQuiz.ContentId == Content.ContentId
                                        select new { StudentRpt.CandidateUserId }).Count()

                    }).ToList();

        }

        public List<OverViewContentStudent> GetStudentsbyContentId(int ContentId)
        {
            return (from contents in sqldbcontext.Contents
                    join QuizRpt in sqldbcontext.QuizReports
                    on contents.QuizId equals QuizRpt.QuizId

                    where contents.ContentId == ContentId

                    select new OverViewContentStudent
                    {
                        ContentId = ContentId
                        ,
                        StudentForm = (from users in sqldbcontext.Users where users.UserId == QuizRpt.CandidateUserId.Value select users).FirstOrDefault()
                        ,

                        ExamAttendedOn = QuizRpt.QuizStartTime
                         ,
                        QuizEndTime = QuizRpt.QuizEndTime
                         ,
                        QuizReportId = QuizRpt.QuizReportId
                      ,
                        Attempt = QuizRpt.AttendedOrder.Value
                      ,
                        PercentageScored = QuizRpt.PassedScore.Value
                      ,
                        Result = QuizRpt.QuizResult
                    }).ToList();

        }

        public List<OverViewClasses> GetOverviewClasses(int PublisherId, string FromDate, string ToDate)
        {

            var TotalClasses = new List<Classes>();
            DateTime FromDt = Convert.ToDateTime(FromDate);
            DateTime ToDt = Convert.ToDateTime(ToDate);

            if (string.IsNullOrEmpty(FromDate) && string.IsNullOrEmpty(ToDate))
            {
                TotalClasses = (from classes in sqldbcontext.Classes where (classes.PublisherUserId == PublisherId) select classes).ToList();

            }
            else if (!string.IsNullOrEmpty(FromDate) && !string.IsNullOrEmpty(ToDate))
            {

                TotalClasses = (from classes in sqldbcontext.Classes
                                where (classes.PublisherUserId == PublisherId && ((classes.CreatedDate.Value > FromDt) || ((classes.CreatedDate.Value.Year == FromDt.Year) && (classes.CreatedDate.Value.Month == FromDt.Month) && (classes.CreatedDate.Value.Day == FromDt.Day)))
                                && ((classes.CreatedDate.Value < ToDt) || ((classes.CreatedDate.Value.Year == ToDt.Year) && (classes.CreatedDate.Value.Month == ToDt.Month) && (classes.CreatedDate.Value.Day == ToDt.Day))))
                                select classes).ToList();

            }
            else if (string.IsNullOrEmpty(FromDate) && !string.IsNullOrEmpty(ToDate))
            {

                TotalClasses = (from classes in sqldbcontext.Classes
                                where (classes.PublisherUserId == PublisherId &&
                                ((classes.CreatedDate.Value.Year == ToDt.Year) && (classes.CreatedDate.Value.Month == ToDt.Month) && (classes.CreatedDate.Value.Day == ToDt.Day)))
                                select classes).ToList();

            }

          

            var item = (from classes in TotalClasses

                    select new OverViewClasses
                    {
                        ClasId = classes.ClassId
                        ,
                        ClassName = classes.ClassName
                        ,
                        ClassDescription=classes.ClassDescription
                        ,
                        ClassType = classes.ClassType
                        ,
                        ClassStatus=classes.ClassStatus
                        ,
                        PublishedDate = classes.PublishedDate
                        ,
                        NoOfContents = (from contents in sqldbcontext.ClassContents where contents.ClassId == classes.ClassId select contents.ClassContentId).Count()
                        ,
                        NoOfStudents = (from students in sqldbcontext.ClassSubscriptions
                                        where students.ClassId == classes.ClassId && students.SubscriptionStatus==1                                          
                                        select students.SubscriptionId).Count()                    
                      
                    });
            

            return item.ToList();
        }

        public List<StudentContent> GetContentsbyStudentId(int StudentId,int publisherUserId)
        {
            return (from QuizRpt in sqldbcontext.QuizReports
                    join Content in sqldbcontext.Contents on QuizRpt.QuizId equals Content.QuizId
                    where QuizRpt.CandidateUserId == StudentId && Content.PublisherUserId==publisherUserId

                    select new StudentContent
                    {
                        StudentId = StudentId
                        ,
                        ContentId = Content.ContentId
                        ,
                        ContentName = Content.ContentTitle
                        ,
                        ClassNames = (from ClassCont in sqldbcontext.ClassContents
                                      join Class in sqldbcontext.Classes on ClassCont.ClassId equals Class.ClassId
                                      where ClassCont.ContentId == Content.ContentId
                                      select Class.ClassName)
                      ,
                        ExamAttendedOn = QuizRpt.QuizStartTime
                        ,
                        QuizEndTime = QuizRpt.QuizEndTime
                      ,
                        QuizReportId = QuizRpt.QuizReportId
                      ,
                        Attempt = QuizRpt.AttendedOrder.Value
                      ,
                        Scored = QuizRpt.PassedScore.Value
                      ,
                        Result = QuizRpt.QuizResult
                    }).ToList();

        }

        public List<StudentQuestionAnswer> StudentQuizResult(int QuizReportId)
        {


            var query = from QuestAnsInfo in sqldbcontext.QuestionAnswerInfo
                        where QuestAnsInfo.QuizReportId == QuizReportId
                        join Ans in sqldbcontext.QuestionAnswers on QuestAnsInfo.QuestionId equals Ans.QuestionId
                        into members
                        join image in sqldbcontext.QuestionImages on QuestAnsInfo.QuestionId equals image.QuestionId
                        into imagemembers
                        join QuestList in sqldbcontext.Questions on QuestAnsInfo.QuestionId equals QuestList.QuestionId
                        select new StudentQuestionAnswer
                        {
                            QuestionId = QuestAnsInfo.QuestionId.Value,
                            QuestionDescription = QuestList.QuestionDescription,
                            QuestionTypeId = QuestList.QuestTypeId,
                            Answers = (from u in members where QuestAnsInfo.QuestionId.Value == u.QuestionId select u),
                            QuestionAnswerInfoId = QuestAnsInfo.QuestionAnswerInfoId,
                            QuestionImage = (from Imagemem in imagemembers where QuestAnsInfo.QuestionId.Value == Imagemem.QuestionId select Imagemem),
                            UserSelectAnswerValue = QuestAnsInfo.Answer,
                            CorrectAnswerId = (from u in members where QuestAnsInfo.QuestionId.Value == u.QuestionId && u.CorrectAnswer == true select u.AnswerId).FirstOrDefault(),
                            CorrectAnswerValue = (from u in members where QuestAnsInfo.QuestionId.Value == u.QuestionId && u.CorrectAnswer == true select u.AnswerValue).FirstOrDefault(),
                            IsCorrectAnswer = QuestAnsInfo.IsCorrectAnswer
                        };

            return query.ToList();
        }

        public Users StudentbyQuizRptId(int QuizReportId)
        {
            int StudentId = (from Report in sqldbcontext.QuizReports where Report.QuizReportId == QuizReportId select Report.CandidateUserId.Value).FirstOrDefault();
            Users usr = (from User in sqldbcontext.Users where User.UserId == StudentId select User).FirstOrDefault();
            return usr;
        }

        public Classes GetClassbyId(int ClassId)
        {
            return (from cls in sqldbcontext.Classes where cls.ClassId == ClassId select cls).FirstOrDefault();

        }

        public Contents ContentbyQuizRptId(int QuizReportId)
        {
            return (from Report in sqldbcontext.QuizReports where Report.QuizReportId == QuizReportId 
                             join Cont in sqldbcontext.Contents on  Report.QuizId equals Cont.QuizId select Cont).FirstOrDefault();
           
        }

        public List<Contents> ContentbyQuizId(int QuizId)
        {
            return (from Cont in sqldbcontext.Contents
                    where Cont.QuizId == QuizId                   
                    select Cont).ToList();

        }

        public List<Classes> GetAvailableClasses(int PublisherUserId)
        {
            return (from Clss in sqldbcontext.Classes where Clss.PublisherUserId==PublisherUserId && Clss.ClassStatus == 1 select Clss).ToList();
        }

        public List<Classes> GetAssignedClasses(int ContentId)
        {
            return (from ClsCont in sqldbcontext.ClassContents
                    where ClsCont.ContentId == ContentId
                    join Clss in sqldbcontext.Classes on ClsCont.ClassId equals Clss.ClassId
                    select Clss).ToList();
        }

        public void InsertClassCont(ClassContents ClsCont)
        {
            sqldbcontext.ClassContents.Add(ClsCont);

        }

        public void DeleteClassCont(int ContentId)
        {
            var ClassContId = (from c in sqldbcontext.ClassContents where (c.ContentId == ContentId) select c);
            foreach (var classContent in ClassContId)
            { 
                sqldbcontext.ClassContents.Remove(classContent);
            }
           
        }

        #endregion

        private bool disposed = false;

        protected virtual void Dispose(bool disposing)
        {
            if (!this.disposed)
            {
                if (disposing)
                {
                    sqldbcontext.Dispose();
                }
            }
            this.disposed = true;
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }
    }
}
