﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data.Entity;
using IntelSkill.Models;


namespace IntelSkill.DAL
{
    public class SQLInitializer : DropCreateDatabaseIfModelChanges<SQLDBContext>
    {
        protected override void Seed(SQLDBContext context)
        {
            var questiontypes = new List<QuestionTypes>
            {
                new QuestionTypes { QuestTypeId=1, QuestTypeName = "Multiple Choice", QuestDataType="optional",   QuestTypeOrder = 1 },
                new QuestionTypes { QuestTypeId=2, QuestTypeName = "Fill-in-the-Blank", QuestDataType="textbox",   QuestTypeOrder = 2 },
                new QuestionTypes { QuestTypeId=3, QuestTypeName = "True/False", QuestDataType="radiobutton",   QuestTypeOrder = 3 },
                new QuestionTypes { QuestTypeId=4, QuestTypeName = "Matching", QuestDataType="compare",   QuestTypeOrder = 4 },
               
            };
            questiontypes.ForEach(q => context.QuestionTypes.Add(q));

            context.SaveChanges();

            var roles = new List<Roles>
            {
                new Roles {  RoleId=1,RoleName="Publisher", RoleGroup="Users" },
                new Roles {  RoleId=2,RoleName="Reader", RoleGroup="Users" },
                new Roles {  RoleId=3,RoleName="Student", RoleGroup="GroupedUsers" },
                new Roles {  RoleId=4,RoleName="Principal", RoleGroup="GroupedUsers" },
                new Roles {  RoleId=5,RoleName="Teacher", RoleGroup="GroupedUsers" },
                new Roles {  RoleId=6,RoleName="Assistant", RoleGroup="GroupedUsers" }, 
            };
            roles.ForEach(r => context.Roles.Add(r));

            context.SaveChanges();
        }
    }
}