﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using IntelSkill.Repository;
using IntelSkill.Models;

namespace IntelSkill.DAL
{
    public class UnitOfWork:IDisposable 
    {
        private SQLDBContext context = new SQLDBContext();
        private GenericRepository<Advertisements> advertisementsRepository;

        public GenericRepository<Advertisements> AdvertisementsRepository
        {
            get
            {
                if (this.advertisementsRepository == null)
                    this.advertisementsRepository = new GenericRepository<Advertisements>(context);
                return advertisementsRepository;
            }
        }

        private GenericRepository<Users> usersRepository { get; set; }

        private GenericRepository<Categories> categoriesRepository { get; set; }

        private GenericRepository<ClassContents> classcontentsRepository { get; set; }

        private GenericRepository<Classes> classesRepository { get; set; }

        private GenericRepository<ClassPayment> classpaymentsRepository { get; set; }

        private GenericRepository<ClassSubscription> classsubscriptionsRepository { get; set; }

        private GenericRepository<ContentAttachments> contentattachmentsRepository { get; set; }

        private GenericRepository<ContentCategories> contentcategoriesRepository { get; set; }

        private GenericRepository<ContentPages> contentpagesRepository { get; set; }

        private GenericRepository<Contents> contentsRepository { get; set; }

        private GenericRepository<QuestionAnswers> questionanswersRepository { get; set; }

        private GenericRepository<QuestionImages> questionimagesRepository { get; set; }

        private GenericRepository<Questions> questionsRepository { get; set; }

        private GenericRepository<QuestionTypes> questiontypesRepository { get; set; }

        private GenericRepository<QuizReports> quizreportsRepository { get; set; }

        private GenericRepository<Quizzes> quizzesRepository { get; set; }

        private GenericRepository<RefUsers> refusersRepository { get; set; }

       private GenericRepository<RefUsersPermission> refuserspermissions { get; set; }

       private GenericRepository<Rights> rightsRepository { get; set; }

       private GenericRepository<Roles> rolesRepository { get; set; }
         

        public void Save()
        {
            context.SaveChanges();
        }
        private bool disposed = false;
        protected virtual void Dispose(bool disposing)
        {
            if (!this.disposed)
            {
                if (disposing)
                {
                    context.Dispose();
                }
            }
            this.disposed = true;
        }

        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);
        }
       
    }
}