﻿using System;
using System.Collections.Generic; 
using System.ComponentModel.DataAnnotations;
namespace IntelSkill.Models
{
    public class RegistrationModel
    {

        public Users Form { get; set; }
        public IEnumerable<Roles> RoleList { get; set; }       
        public string ConfirmPassword { get; set; }
        public string ValidationMessage { get; set; }
        public string ValidationMessageType { get; set; }
    }

    public class SignInModel
    {

        [Required(ErrorMessage = "Username is required.")]
        [StringLength(50)]
        public string Email { get; set; }
        [Required(ErrorMessage = "Password is required.")]
        [StringLength(100, ErrorMessage = "The {0} must be at least {2} characters long.", MinimumLength = 6)]
        [DataType(DataType.Password)]
        public string Password { get; set; } 

        public string ValidationMessage { get; set; }

        public string ValidationMessageType { get; set; }
        public bool RememberMe { get; set; }

        public string RememberMePassword { get; set; }
    }


    public class ChangePasswordModel
    {
        public int CurrentUserId { get; set; }
        public int PublisherUserId { get; set; }
        public string OldPassword { get; set; }
        public string NewPassword { get; set; }
        public string ReTypePassword { get; set; }

        public string ValidationMessage { get; set; }
        public string ValidationMessageType { get; set; }
    
    }

    public class ForgotPasswordModel
    {
       
        public string Email { get; set; }
        public string ConfirmPassword { get; set; }
        public Users UserForm { get; set; }
        public bool IsForgotSuccess { get; set; }
        public bool IsForgotSessionExpired { get; set; }
    
        public string ValidationMessage { get; set; }
        public string ValidationMessageType { get; set; }
        
       
    }
}
