﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web.Mvc;
using System.Web;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace IntelSkill.Models
{
    #region People

    public class UserModel
    {
        public Users User { get; set; }
        public RefUsers RefUser { get; set; }
        public string Usrmodel { get; set; }
        public IEnumerable<Roles> RoleList { get; set; }
        public IEnumerable<UserListModel> UserList { get; set; }
        public UserListModel UserListonemail { get; set; }

        public PageRightsModel PageRightsList { get; set; }

        public string ConfirmPassword { get; set; }

        public string EditPassword { get; set; }

        public string ValidationMessage { get; set; }

        public string ValidationMessageType { get; set; }
        public bool? AddUser { get; set; }
        public bool? AddNewUser { get; set; }
        public bool? Edit { get; set; }
        public bool? Display { get; set; }
        public string RequestMail { get; set; }
        public bool IsRequestMailEnabled { get; set; }
        public string userpassword { get; set; }
        public List<OverViewContentStudent> OverViewContStudent { get; set; }

        public List<StudentContent> StudentCont { get; set; }

        public List<StudentQuestionAnswer> StudentQuizResult { get; set; }

        public List<SubscribersList> SubscribtionList { get; set; }

        public List<SubcribedClasses> SubcribedClasses { get; set; }

        public List<SubcribedContentResult> SubcribedContentResult { get; set; }

        public int QuestionOrder { get; set; }
       
      
       
       
    }

    public class OverViewContentStudent
    {

        public int ContentId { get; set; }
        public Users StudentForm { get; set; }
        public DateTime? ExamAttendedOn { get; set; }
        public DateTime? QuizEndTime { get; set; }
        public int Attempt { get; set; }
        public int PercentageScored { get; set; }
        public string Result { get; set; }
        public int QuizReportId { get; set; }
    }

    public class StudentContent
    {
        public int StudentId { get; set; }
        public int ContentId { get; set; }
        public string ContentName { get; set; }
        public IEnumerable<string> ClassNames { get; set; }
        public DateTime? ExamAttendedOn { get; set; }
        public DateTime? QuizEndTime { get; set; }
        public int Attempt { get; set; }
        public int Scored { get; set; }
        public string Result { get; set; }
        public int QuizReportId { get; set; }


    }

    public class StudentQuestionAnswer
    {
        public int QuestionId { get; set; }
        public string QuestionDescription { get; set; }
        public int? QuestionTypeId { get; set; }
        public int? Status { get; set; }
        public DateTime? CreatedDate { get; set; }
        public DateTime? ModifiedDate { get; set; }
        public IEnumerable<QuestionAnswers> Answers { get; set; }
        public int UserSelectAnswerId { get; set; }
        public int CorrectAnswerId { get; set; }
        public string CorrectAnswerValue { get; set; }
        public string UserSelectAnswerValue { get; set; }
        public IEnumerable<QuestionImages> QuestionImage { get; set; }
        public int QuestionAnswerInfoId { get; set; }
        public bool? IsCorrectAnswer { get; set; }

    }

    public class UserListModel
    {
        //User Tables Info.
        public int UserId { get; set; }

        public string Email { get; set; }

        public string Password { get; set; }

        public string FirstName { get; set; }

        public string LastName { get; set; }

        public string CompanyName { get; set; }

        public string CompanyLogo { get; set; }

        public System.Nullable<System.DateTime> ForgotPassTokenReq { get; set; }

        public System.Nullable<int> UserTypeId { get; set; }

        public System.Nullable<bool> UserStatus { get; set; }

        public System.Nullable<DateTime> CreatedDate { get; set; }
        public System.Nullable<int> CreatedUserId { get; set; }
        public System.Nullable<DateTime> ModifiedDate { get; set; }
        public System.Nullable<int> ModifiedUserId { get; set; }
        
        
       
        //RefUsers Table Info.
        public int RefUserId { get; set; }
        public int ParentUserId { get; set; }
        public int ChildUserId { get; set; }
        public int RoleId { get; set; }
        public string RoleName { get; set; }
    }

    public class PageRightsModel
    {

        private bool _add_new_content_value = true;
        private bool _save_content_in_draft_value = true;
        private bool _content_preview_value = true;
        private bool _content_publish_value = true;
        private bool _view_all_content_list_value = true;
        private bool _edit_content_value = true;
        private bool _delete_content_value = true;
        private bool _add_new_category_value = true;
        private bool _view_categories_value = true;
        private bool _edit_category_value = true;
        private bool _delete_category_value = true;
        private bool _view_most_used_category_value = true;
        private bool _add_new_public_class_value = true;
        private bool _view_all_public_class_value = true;
        private bool _edit_public_class_value = true;
        private bool _delete_public_class_value = true;
        private bool _save_public_class_in_draft_value = true;
        private bool _public_class_preview_value = true;
        private bool _public_class_publish_value = true;
        private bool _view_subscribed_students_value = true;
        private bool _activate_deactivate_subscribed_students_value = true;
        private bool _add_new_private_class_value = true;
        private bool _view_all_private_class_value = true;
        private bool _edit_private_class_value = true;
        private bool _delete_private_class_value = true;
        private bool _save_private_class_in_draft_value = true;
        private bool _private_class_preview_value = true;
        private bool _private_class_publish_value = true;
        private bool _add_new_student_for_private_class_value = true;
        private bool _class_edit_student_value = true;
        private bool _class_delete_student_value = true;
        private bool _build_quiz_value = true;
        private bool _save_quiz_in_draft_value = true;
        private bool _preview_quiz_value = true;
        private bool _publish_quiz_value = true;
        private bool _view_all_quiz_value = true;
        private bool _edit_quiz_value = true;
        private bool _delete_quiz_value = true;
        private bool _add_question_value = true;
        private bool _edit_question_value = true;
        private bool _view_question_value = true;
        private bool _delete_question_value = true;
        private bool _add_new_adminuser_value = true;
        private bool _edit_adminuser_value = true;
        private bool _delete_adminuser_value = true;
        private bool _view_quiz_reports_value = true;
        private bool _view_student_reports_value = true;
        private bool _view_exam_reports_value = true;
        private bool _add_new_student_for_public_class_value = true;
        private bool _add_new_student_value = true;
        private bool _edit_student_value = true;
        private bool _delete_student_value = true;
        private bool _view_student_value = true;
        private bool _view_user_value = true;
        private bool _view_user_permission_value = true;

        public bool _add_new_content
        {
            get { return _add_new_content_value; }
            set { _add_new_content_value = value; }
        }



        public bool _save_content_in_draft
        {
            get { return _save_content_in_draft_value; }
            set { _save_content_in_draft_value = value; }
        }



        public bool _content_preview
        {
            get { return _content_preview_value; }
            set { _content_preview_value = value; }
        }




        public bool _content_publish
        {
            get { return _content_publish_value; }
            set { _content_publish_value = value; }
        }




        public bool _view_all_content_list
        {
            get { return _view_all_content_list_value; }
            set { _view_all_content_list_value = value; }
        }




        public bool _edit_content
        {
            get { return _edit_content_value; }
            set { _edit_content_value = value; }
        }




        public bool _delete_content
        {
            get { return _delete_content_value; }
            set { _delete_content_value = value; }
        }




        public bool _add_new_category
        {
            get { return _add_new_category_value; }
            set { _add_new_category_value = value; }
        }




        public bool _view_categories
        {
            get { return _view_categories_value; }
            set { _view_categories_value = value; }
        }




        public bool _edit_category
        {
            get { return _edit_category_value; }
            set { _edit_category_value = value; }
        }




        public bool _delete_category
        {
            get { return _delete_category_value; }
            set { _delete_category_value = value; }
        }




        public bool _view_most_used_category
        {
            get { return _view_most_used_category_value; }
            set { _view_most_used_category_value = value; }
        }




        public bool _add_new_public_class
        {
            get { return _add_new_public_class_value; }
            set { _add_new_public_class_value = value; }
        }




        public bool _view_all_public_class
        {
            get { return _view_all_public_class_value; }
            set { _view_all_public_class_value = value; }
        }




        public bool _edit_public_class
        {
            get { return _edit_public_class_value; }
            set { _edit_public_class_value = value; }
        }




        public bool _delete_public_class
        {
            get { return _delete_public_class_value; }
            set { _delete_public_class_value = value; }
        }




        public bool _save_public_class_in_draft
        {
            get { return _save_public_class_in_draft_value; }
            set { _save_public_class_in_draft_value = value; }
        }




        public bool _public_class_preview
        {
            get { return _public_class_preview_value; }
            set { _public_class_preview_value = value; }
        }




        public bool _public_class_publish
        {
            get { return _public_class_publish_value; }
            set { _public_class_publish_value = value; }
        }




        public bool _view_subscribed_students
        {
            get { return _view_subscribed_students_value; }
            set { _view_subscribed_students_value = value; }
        }




        public bool _activate_deactivate_subscribed_students
        {
            get { return _activate_deactivate_subscribed_students_value; }
            set { _activate_deactivate_subscribed_students_value = value; }
        }




        public bool _add_new_private_class
        {
            get { return _add_new_private_class_value; }
            set { _add_new_private_class_value = value; }
        }




        public bool _view_all_private_class
        {
            get { return _view_all_private_class_value; }
            set { _view_all_private_class_value = value; }
        }




        public bool _edit_private_class
        {
            get { return _edit_private_class_value; }
            set { _edit_private_class_value = value; }
        }




        public bool _delete_private_class
        {
            get { return _delete_private_class_value; }
            set { _delete_private_class_value = value; }
        }




        public bool _save_private_class_in_draft
        {
            get { return _save_private_class_in_draft_value; }
            set { _save_private_class_in_draft_value = value; }
        }




        public bool _private_class_preview
        {
            get { return _private_class_preview_value; }
            set { _private_class_preview_value = value; }
        }




        public bool _private_class_publish
        {
            get { return _private_class_publish_value; }
            set { _private_class_publish_value = value; }
        }




        public bool _add_new_student_for_private_class
        {
            get { return _add_new_student_for_private_class_value; }
            set { _add_new_student_for_private_class_value = value; }
        }




        public bool _class_edit_student
        {
            get { return _class_edit_student_value; }
            set { _class_edit_student_value = value; }
        }




        public bool _class_delete_student
        {
            get { return _class_delete_student_value; }
            set { _class_delete_student_value = value; }
        }




        public bool _build_quiz
        {
            get { return _build_quiz_value; }
            set { _build_quiz_value = value; }
        }




        public bool _save_quiz_in_draft
        {
            get { return _save_quiz_in_draft_value; }
            set { _save_quiz_in_draft_value = value; }
        }




        public bool _preview_quiz
        {
            get { return _preview_quiz_value; }
            set { _preview_quiz_value = value; }
        }




        public bool _publish_quiz
        {
            get { return _publish_quiz_value; }
            set { _publish_quiz_value = value; }
        }




        public bool _view_all_quiz
        {
            get { return _view_all_quiz_value; }
            set { _view_all_quiz_value = value; }
        }




        public bool _edit_quiz
        {
            get { return _edit_quiz_value; }
            set { _edit_quiz_value = value; }
        }




        public bool _delete_quiz
        {
            get { return _delete_quiz_value; }
            set { _delete_quiz_value = value; }
        }




        public bool _add_question
        {
            get { return _add_question_value; }
            set { _add_question_value = value; }
        }




        public bool _edit_question
        {
            get { return _edit_question_value; }
            set { _edit_question_value = value; }
        }




        public bool _view_question
        {
            get { return _view_question_value; }
            set { _view_question_value = value; }
        }




        public bool _delete_question
        {
            get { return _delete_question_value; }
            set { _delete_question_value = value; }
        }




        public bool _add_new_adminuser
        {
            get { return _add_new_adminuser_value; }
            set { _add_new_adminuser_value = value; }
        }




        public bool _edit_adminuser
        {
            get { return _edit_adminuser_value; }
            set { _edit_adminuser_value = value; }
        }




        public bool _delete_adminuser
        {
            get { return _delete_adminuser_value; }
            set { _delete_adminuser_value = value; }
        }





        public bool _view_quiz_reports
        {
            get { return _view_quiz_reports_value; }
            set { _view_quiz_reports_value = value; }
        }




        public bool _view_student_reports
        {
            get { return _view_student_reports_value; }
            set { _view_student_reports_value = value; }
        }




        public bool _view_exam_reports
        {
            get { return _view_exam_reports_value; }
            set { _view_exam_reports_value = value; }
        }



        public bool _add_new_student_for_public_class
        {
            get { return _add_new_student_for_public_class_value; }
            set { _add_new_student_for_public_class_value = value; }
        }



        public bool _add_new_student
        {
            get { return _add_new_student_value; }
            set { _add_new_student_value = value; }
        }




        public bool _edit_student
        {
            get { return _edit_student_value; }
            set { _edit_student_value = value; }
        }




        public bool _delete_student
        {
            get { return _delete_student_value; }
            set { _delete_student_value = value; }
        }

        public bool _view_student
        {
            get { return _view_student_value; }
            set { _view_student_value = value; }
        }

        public bool _view_user
        {
            get { return _view_user_value; }
            set { _view_user_value = value; }
        }

        public bool _view_user_permission
        {
            get { return _view_user_permission_value; }
            set { _view_user_permission_value = value; }
        }

    }

    public class PageRightDataModel
    {

        public string ModuleName { get; set; }
        public string PageName { get; set; }

    }


    public class UserPermissionsModel
    {
        public PageRightsModel PageRightsList { get; set; }

        public IEnumerable<UserListModel> UsersList { get; set; }

        public IEnumerable<PageRightDataModel> ModuleList { get; set; }

        public IEnumerable<Rights> RightList { get; set; }

        public IEnumerable<Rights> AssignedRightSelectList { get; set; }

        public IEnumerable<RefUsers> UserRightsSelectList { get; set; }

        public IEnumerable<Roles> RoleList { get; set; }

        public string ValidationMessage { get; set; }

        public string ValidationMessageType { get; set; }

        public int RoleId { get; set; }
    }


    public class SubscribersList
    {
        public Users UserForm { get; set; }
        public int SubscribedClassCount { get; set; }       

    }

    public class SubcribedClasses
    {
        public Classes ClassForm { get; set; }
        public ClassPayment ClassPaymentForm { get; set; }
        public ClassSubscription ClassSubscribtion { get; set; }

    }
    public class SubcribedContentResult
    {
        public Contents Content { get; set; }
        public QuizReports QuizRptForm { get; set; }

    }
    #endregion

    #region Class Tools View's

    public class BuildClassModel
    {
        public Classes ClassModel { get; set; }

        public string RequestMail { get; set; }

        public bool IsRequestMailEnabled { get; set; }

        public List<int> PreviewContentIdList { get; set; }

        public int Available_ContentsList_Count { get; set; }

        public int Assigned_ContentList_Count { get; set; }

        public int Available_StudentList_Count { get; set; }

        public int Assigned_StudentList_Count { get; set; }

        public IEnumerable<string> SelectedItemId { get; set; }

        public List<Contents> Available_ContentList { get; set; }

        public List<Contents> Assigned_ContentList { get; set; }

        public List<Users> Available_StudentList { get; set; }

        public List<Users> Assigned_StudentList { get; set; }

        public List<Contents> ContentsViewModel { get; set; }

        public List<Users> Removed_StudentList { get; set; }

        public PageRightsModel PageRights { get; set; }

        public string ValidationMessage { get; set; }

        public string ValidationMessageType { get; set; }
    }

    public class AllClassModel
    {

        public string SearchBoxValue { get; set; }

        public List<ClassListModel> CurrentPageList { get; set; }

        public int AllClassCount { get; set; }

        public int AllPublishedCount { get; set; }

        public int AllYetToPublishCount { get; set; }

        public int AllDraftCount { get; set; }

        public string ValidationMessage { get; set; }

        public string ValidationMessageType { get; set; }

        public SelectList BulkActionList { get; set; } 

        public int page { get; set; }

        public List<OverViewClasses> OverViewClass { get; set; }

        public string FromDate { get; set; }

        public string ToDate { get; set; }

        public PageRightsModel PageRights { get; set; }
   

    }

    public enum ClassStatus
    {
        Draft,
        Published,
        YetToPublish
    }

    public class ClassListModel
    {
        public int ClassId { get; set; }
        public string ClassName { get; set; }
        public string ClassDescription { get; set; }
        public System.Nullable<System.DateTime> CreatedDate { get; set; }
        public System.Nullable<int> CreatedUserId { get; set; }
        public System.Nullable<System.DateTime> ModifiedDate { get; set; }
        public System.Nullable<int> ModifiedUserId { get; set; }
        public System.Nullable<System.DateTime> PublishedDate { get; set; }
        public System.Nullable<int> PublishedUserId { get; set; }
        public System.Nullable<bool> ClassType { get; set; }
        public System.Nullable<int> PublisherUserId { get; set; }
        public System.Nullable<int> ClassStatus { get; set; }
        public System.Nullable<bool> IsProfitable { get; set; }
        public System.Nullable<decimal> ProfitAmount { get; set; }
        public string StatusMessage { get; set; }
        public int NoOfStudents { get; set; }
        public string AuthorName { get; set; }
    }  

    public class OverViewClasses
    {
        public int ClasId { get; set; }
        public string ClassName { get; set; }
        public string ClassDescription { get; set; }
        public bool? ClassType { get; set; }
        public int? ClassStatus { get; set; }
        public DateTime? PublishedDate { get; set; }
        public int NoOfContents { get; set; }
        public int NoOfStudents { get; set; }
    }

    #endregion

    #region Question Tools View's

    public class ViewQuestionModel
    {
        public int SelectedQuizId { get; set; }

        public string PendingQuestionMessage { get; set; }

        private string _pendingMessageStyle="float: left; color: Red; font-size: 9pt; line-height: 9pt; margin-top: 8px;padding: 3px; margin-left: 5px; background-color: #FCEAEA; border: 1px solid #FF0000;";

        public string PendingMessageStyle
        {
            get { return _pendingMessageStyle; }
            set { _pendingMessageStyle = value; }
        }
        

        public SelectList QuizList { get; set; }

        public SelectList BulkActionList { get; set; }

        public List<QuestionListModel> CurrentPageList { get; set; }

        public QuestionModel QuestionModel { get; set; }

        public PageRightsModel PageRights { get; set; }

        public string ValidationMessage { get; set; }

        public string ValidationMessageType { get; set; }
    }

    public class QuestionListModel
    {
        public int QuestionId { get; set; }

        public string QuestionDescription { get; set; }

        public int QuestionStatus { get; set; }
    }

    public class QuestionModel
    {
        public Questions Question { get; set; }

        public List<QuestionTypes> TypeList { get; set; }

        public List<QuestionAnswers> AnswerList { get; set; }

        public List<QuestionImages> ImageList { get; set; }

        public List<QuestionAnswers> MatchAList { get; set; }

        public List<QuestionAnswers> MatchBList { get; set; }

    }

    public class ImageModel
    {
        public int ImageId { get; set; }
        public string ImageReferenceName { get; set; }
        public string ImageOrginalName { get; set; }
    }

    #endregion

    #region QuizModule

    public class QuizModel
    {
        public string ValidationMessage { get; set; }

        public string ValidationMessageType { get; set; }

        public Quizzes QuizForm { get; set; }

        public bool IsQuizTitle { get; set; }

        public string StatusName { get; set; }

        public string PublishOn { get; set; }

        public List<Questions> QuestionsList { get; set; }

        public PageRightsModel PageRights { get; set; }

        public bool IsPublished { get; set; }
    }

    public class QuizListModel
    {
        public int QuizId { get; set; }
        public string QuizTitle { get; set; }
        public DateTime? ModifiedDate { get; set; }
        public DateTime? DateAdded { get; set; }
        public DateTime? PublishedDate { get; set; }
        public int? Status { get; set; }
        public int TotalQuestions { get; set; }
        public int? QuestionAmount { get; set; }
        public int? TimeAllowed { get; set; }
        public int? AttemptLimit { get; set; }
        public int? PassingScore { get; set; }
        public int? QuizAttempts { get; set; }
        public PageRightsModel PageRights { get; set; }
        public List<QuizListModel> TotalQuizList { get; set; }
        public List<QuizListModel> PageQuizList { get; set; }
        public string ValidationMessage { get; set; }
        public string ValidationMessageType { get; set; }
        public int CurrentPage { get; set; }
        public int NumberOfPages { get; set; }

    }

    #endregion


    #region Content & Category Modules

    public class ContentModel
    {
        public int ContentId { get; set; }
        public string ContentTitle { get; set; }
        public DateTime ModifiedDate { get; set; }
        public DateTime CreatedDate { get; set; }
        public DateTime? PublishedDate { get; set; }
        public int Status { get; set; }
        public int PublisherId { get; set; }
        public int QuizId { get; set; }

        [DataType(DataType.Html)]
        public string PageDesc { get; set; }

        public string PublishOn { get; set; }
        public Categories Form { get; set; }

        public IEnumerable<CategoryList> ContCategoriesList { get; set; }

        public List<ContentPages> ContentPagingList { get; set; }

        public IEnumerable<Categories> CategoriesSelectList { get; set; }

        // public bool IsPreview { get; set; }
        public List<int> IsCategorySelectId { get; set; }

        public bool IsCategory { get; set; }

        public string Message { get; set; }

        public string MessageType { get; set; }

        public bool IsContentTitle { get; set; }

        //  public bool IsContentPreview { get; set; }

        public bool IsCatgEdit { get; set; }

        public ContentPages PagesForm { get; set; }

        public IEnumerable<ContentPages> ContentPageSelectList { get; set; }

        public int ContentPageId { get; set; }

        public bool IsPageEdit { get; set; }

        public bool? IsPageDiscard { get; set; }

        public bool IsCatgDefault { get; set; }

        public bool IsPublished { get; set; }

        public string StatusName { get; set; }

        public PageRightsModel PageRights { get; set; }

        public int PageIndex { get; set; }

        public bool IsContentListPreview { get; set; }

        public int? PublishedUserId { get; set; }

        public List<Classes> Assigned_ClassList { get; set; }

        public List<Classes> Available_ClassList { get; set; }

        public class CategoryList
        {
            public int CategoryId { get; set; }

            public string CategoryName { get; set; }

            public int? PublisherId { get; set; }
            public bool ContCat { get; set; }
        }

        public class UploadImages
        {
            public List<string> FileName { get; set; }

            public List<string> FolderName { get; set; }

        }
    }

    public class ContentListModel
    {
        public int ContentId { get; set; }
        public string ContentTitle { get; set; }
        public string Author { get; set; }
        public List<string> Category { get; set; }

        public string LastEdit { get; set; }

        public string DateAdded { get; set; }
        public int Status { get; set; }

        public string PageDesc { get; set; }

        public string PublishedDate { get; set; }

        public IEnumerable<ContentListModel> GetList { get; set; }

        public string Message { get; set; }

        public string MessageType { get; set; }

        public List<ContentPages> ContentPagingList { get; set; }

        public int ContentPageId { get; set; }

        public bool IsPageFilter { get; set; }

        public bool IsExam { get; set; }

        public PageRightsModel PageRights { get; set; }

        public List<ContentListModel> TotalContentList { get; set; }
        public List<ContentListModel> PageContentList { get; set; }

        public int CurrentPage { get; set; }
        public int NumberOfPages { get; set; }

        public List<OverViewClassContent> OverViewClsContent { get; set; }

        public List<OverViewClasses> OverViewClass { get; set; }



        public class OverViewClassContent
        {
            public int ContentId { get; set; }
            public string ContentTitle { get; set; }
            public int? ContentStatus { get; set; }
            public IEnumerable<string> CategoryNames { get; set; }
            public DateTime? PublishedDate { get; set; }
            public int NoOfStudents { get; set; }
            public int ExamAttended { get; set; }
        }

       


    }

    #endregion


    #region PublisherDashboardModule

    public class PublisherDashBoardModel
    {
        public PageRightsModel PageRights { get; set; }
        public DashboardListOverview DashboardOverview { get; set; }
        public List<DashboardSubsrciptionApproval> DashboardApproval { get; set; }
        public List<DashboardRoles> DashboardMyRole { get; set; }
        public List<DashboardPostContent> DashboardPostContent { get; set; }
        public string Dates { get; set; }
        public string Message { get; set; }
        public string MessageType { get; set; }
        public bool? IsRoleId { get; set; }


        public int QuizId { get; set; }
        public List<StudentExamOverviewModel> ListStudentExamOverview { get; set; }
        public List<StudentExamOverviewModel> ListStudentExamOverviewByQuiz { get; set; }
        public List<NewStudent> ListNewStudent { get; set; }
        public List<QuizListModel> ListQuiz { get; set; }

    }

    public class DashboardListOverview
    {
        public int TotalQuizzes { get; set; }
        public List<Classes> TotalClasses { get; set; }
        public int TotalContent { get; set; }
        public int TotalStudents { get; set; }
        public int TotalMultipleChoice { get; set; }
        public int TotalMatching { get; set; }
        public int TotalFillintheBlank { get; set; }
        public int TotalTrueFalse { get; set; }
        public int PassReport { get; set; }
        public int FailReport { get; set; }
        public int InCompleteReport { get; set; }
        public decimal dPassReport { get; set; }
        public decimal dFailReport { get; set; }
        public decimal dInCompleteReport { get; set; }
    }

    public class DashboardRoles
    {
        public Users UserForm { get; set; }
        public Roles RoleForm { get; set; }
     
    }

    public class DashboardPostContent
    {
        public Users UserForm { get; set; }
        public Classes ClassForm { get; set; }

    }

    public class DashboardSubsrciptionApproval
    {
        public string RequestedName { get; set; }
        public int ClassSubId { get; set; }
        public string ClassName { get; set; }
    }

    public class StudentExamOverviewModel
    {
        public int StudentId { get; set; }
        public string StudentName { get; set; }
        public int ExamTaken { get; set; }
        public int ExamOutstanding { get; set; }
        public int ExamReTaken { get; set; }
        public int ExamMaxAttempt { get; set; }
        public int ExamAverageScore { get; set; }
    }

    public class NewStudent
    {
        public int StudentId { get; set; }
        public string StudentName { get; set; }
        public string Email { get; set; }
    }

    #endregion


    #region Access Models

    public class AccessModel
    {
        public string AccessCode { get; set; }

        public int ClassId { get; set; }

        public int CurrentUserId { get; set; }

        public string DisplayName { get; set; }

        public string PublisherUser_FirstName { get; set; }

        public string PublisherUser_LastName { get; set; }

        public string CurrentUser_FirstName { get; set; }

        public string CurrentUser_LastName { get; set; }

        public int RoleId { get; set; }

        public int PublisherUserId { get; set; }        

        public string PublisherCompanyLogo { get; set; }

       
    }
    #endregion


}
