﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using IntelSkill.Models;

namespace IntelSkill.Repository
{
    public interface IClassRepository : IDisposable
    {
          
        #region Build Class Page Functions.

        Classes GetMyClass(int classId);

        List<Contents> GetMyContents(int userId);

        List<Contents> GetAssignedContents(int classId);

        List<Users> GetMyStudents(int userId);

        List<Users> GetAssignedStudents(int classId);

        int? GetUserIdByMail(string email);

        List<Contents> GetContentList(List<int> previewContentIdList);      

        int SaveClass(BuildClassModel classModel);

        bool CheckValidUser(string email, int currentUserId, int publisherUserId);

        AccessModel GetAccessDetails(string requestCode, string accessPwd, int _accessAttemptLimit);

        #endregion

        #region All Class Page Functions.

        List<ClassListModel> GetAllClassList(int userId, string searchquery, PageRightsModel pageRightsModel);

        bool DeleteClass(int classId);

     

        #endregion


        #region DashBoard

        List<DashboardPostContent> DashboardGetAssignedClasses(int AssignedUserId);
       
        #endregion
        
        void Save();




       
    }
}