﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using IntelSkill.Models;


namespace IntelSkill.Repository
{
  public  interface IContentRepository
    {
      IEnumerable<Contents> GetContentList(string ContentTitle,int UserId);
      IEnumerable<ContentPages> GetContentPages(int ContentId);
      IEnumerable<Contents> GetAllContentList();
      IEnumerable<Contents> GetContentListById(int ContentId);
      List<Contents> GetContentListbyUserId(int UserID);
      string GetContentTitle(int ContentId);
      int GetContentId(string ContentTitle);
        void InsertContent(Contents Content);
        void InsertContentPage(ContentPages ContentPage);
        void InsertContentPageAttach(ContentAttachments ContentPageAtt);
        void UpdateContent(Contents Content);
        void UpdateContentPage(ContentPages ContentPage);
        bool DeleteContent(int ContId);
       // int GetLastContPageId();
        int GetContPageId(int ContId);
        int GetContIdbyPageId(int PageId);
        void Save();

        IEnumerable<Categories> GetCategories(int UserId);
        void InsertCategories(Categories Categories);
        void DeleteCategories(int CategoryId);
        void UpdateCategories(Categories Catg);
        void InsertContCategories(ContentCategories ContCategories);
        void DeleteContCategories(int ContentId);
        void DeleteContPages(int ContentId);
        List<ContentCategories> GetContentCategory(int ContentId);
        List<string> GetCategoryName(int ContId);
        List<int> GetCategoryContentId(int CatgId);
        Categories GetCategorybyId(int CatgId);
        int GetCategoryId(string CatgName, int UserId);
        string GetUsername(int UserId);
        
        string PageDesc(int PageId);
        List<string> GetContentImageUrl(int ContentId);
        void DeleteContPagebyId(int PageId);

        List<ContentListModel.OverViewClassContent> GetContentsbyClassId(int ClassId);
        List<OverViewContentStudent> GetStudentsbyContentId(int ContentId);
        List<OverViewClasses> GetOverviewClasses(int PublisherId, string FromDate, string ToDate);

        List<StudentContent> GetContentsbyStudentId(int StudentId, int publisherUserId);
        List<StudentQuestionAnswer> StudentQuizResult(int QuizReportId);
        Users StudentbyQuizRptId(int QuizReportId);
        Classes GetClassbyId(int ClassId);
        Contents ContentbyQuizRptId(int QuizReportId);
        List<Contents> ContentbyQuizId(int QuizId);

        List<Classes> GetAvailableClasses(int PublisherUserId);
        List<Classes> GetAssignedClasses(int ContentId);
        void InsertClassCont(ClassContents ClsCont);
        void DeleteClassCont(int ContentId);

    }
}
