﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using IntelSkill.Models;


namespace IntelSkill.Repository
{
    public interface IReaderRepository
    {
        IEnumerable<ClassSubscription> GetSubscribers();
        void InsertSubscriber(ClassSubscription Subscribe);
        void UpdatSuebscriber(ClassSubscription SubscriptionId);
        List<Users> GetUsersOfReaders();
        List<Users> GetAllPublisher();
        List<Users> GetAllPublisherForReader(int currentUserid);
        IEnumerable<ClassSubscription> GetClassSubscription(int ReaderUserId);
        int GetClassSubcriptionCount(int classid);
        string GetPublisherName(int PublisherUserid);
        int SaveClassChanges(ClassSubscription classObj);
        Users GetUserDetails(int id);
        Users ChangePassword(string Password);
        string GetPassword(int userid);
        IEnumerable<ReaderContentModel> GetAllClass(int PublisherUserid);
       // int RoleId(int userid);
        IEnumerable<Users> userinformation(int userid);
        Users UserAccount(int userid);
        IEnumerable<Users> MyAccount(int id);
        List<QuizReports> GetNumberOfQuizes(int ReaderUserId);
        Quizzes GetQuizzesbyId(int quizid);
        QuizReports GetQizDetails(int ReaderUserId, int quizid);
        IEnumerable<QuestionTypes> GetQuestions();
        List<Questions> GetAllQuestions(int quizid);
        //Search Functionality
        IEnumerable<ReaderContentModel> GetAllClassSearched(string searchtext, int PublisherUserid);
        IEnumerable<ReaderContentModel> GetAllPublisherClassSearched(string searchtext, int PublisherUserid);
       
        void GetAllClass(int readerUserId, ref List<Classes> listClasses, ref List<Users> listUsers, ref List<ReaderContentModel> listContents, ref string DefaultPublisherName, ref string DefaultClassName, int classId);
        IEnumerable<ContentPages> GetContentPagesDescr(int ContentId);
        int? GetPublisherId(int ContId);
        IEnumerable<ReaderContentModel> GetContents(string searchtext, int loggeduserId);
        IEnumerable<ReaderContentModel> GetClasses(string searchtext);
        IEnumerable<ReaderContentModel> GetClassbyPublisher(string searchtext, int UserId);
        List<Categories> Getallcategories();
        IEnumerable<ReaderContentModel> AdvancedSearchClasses(string clstype, string Catid, string pubId, string IsQzt);
        IEnumerable<ReaderContentModel> AdvancedSearchClassesbyPublisher(string clstype, string Catid, string pubId, string IsQzt, int userid);
        #region Exam IRepositroy


        Quizzes GetQuizDetails(int QuizId);
        IEnumerable<QuestionAnswerModel> QuestionAnswer(int QuizId);
        Questions GetQuestionsbyId(int QuestionId);
        QuestionAnswers CorrectAnswerId(int QuestionId);
        List<QuizReports> QuizReportList(int QuizId, int UserId);
        void InsertQuizReport(QuizReports QuizRpt);
        void UpdateQuizReport(QuizReports QuizRpt);
        void UpdateQuestionAnswerInfo(QuestionAnswerInfo QuestInfo);
        List<QuestionAnswerInfo> GetQuestionAnsInfo(int QuizId, int UserId);
        void InsertQuestionAnswerInfo(QuestionAnswerInfo QuestInfo);
        IEnumerable<QuestionAnswerModel> GetQuestionAns(int QuizId, int UserId);
        IEnumerable<QuestionAnswerModel> ResultQuestionAnswers(int QuizId, int UserId);
       
        #endregion

         void Save();
         void InsertClassPaymenet(ClassPayment clsPay);
         ClassPayment GetClassPaymentDetails(int ClassId, int ReaderUserId);
    }
}