﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using IntelSkill.Models;


namespace IntelSkill.Repository
{
    public interface IUsersRepository
    {


        UserListModel GetUser(string email);

        Users GetUser(string email, string password);

        #region ForgotPassword
        Users GetUserbyEmail(string email);
        Users GetUserByID(int id); 
        #endregion
        IEnumerable<Users> GetUser(int publisherUserId, int roleId);

        IEnumerable<Users> GetUsers();

        UserListModel GetUserDetail(string email, string password);

        IEnumerable<UserListModel> GetUserList(int publisherUserId, string roleGroup);

        IEnumerable<Roles> GetUserRoles(string roleGroup);

        IEnumerable<UserListModel> GetUsersSearchResults(int accessAccountId, string searchquery, int roleId);

        UserListModel GetUserbyId(int id);
        UserListModel GetUsersbyIdandcurrentuserid(int id, int cid,int rid);
        bool InsertUser(Users model);
        bool InsertRefUser(UserModel model);

        bool InsertUser(UserModel model);


        bool RegistrationUserInsert(UserModel model);

        bool UpdateUser(Users users);

        bool UpdateUser(UserModel model);

        bool DeleteUser(int userid, int CurrentUser, int Role);
        bool UpdateUser(RefUsers refuser);
        RefUsers GetUserRow(int pid, int cid);
        bool SearchEmail(UserModel model);
        UserListModel GetUserListonEmailAdmin(int publisherUserId, UserModel model);
        UserListModel GetUserListonEmailStudent(int publisherUserId, UserModel model);


        List<PageRightDataModel> GetPageRights(int currentUserId, int publisherUserId);

        IEnumerable<UserListModel> GetUsersbyRole(int publisherUserId, int roleId);

        IEnumerable<Rights> GetRights();

        IEnumerable<PageRightDataModel> GetModules();

        IEnumerable<Roles> GetSignUpRoles();

        IEnumerable<Rights> GetUserRights(int userId);

        bool IsValidUser(string emailId, int publisherId);

        bool SaveUserRights(int userId, int publisherUserId, List<int> rightid);

        void Save();

        IEnumerable<Users> GetAllStudents(int publisherUserId);


        // Current Logged as User (Publisher/ Reader/ etc.,)

        Users GetMyProfileInfo(int userId);

        bool MyProfileUpdate(Users userInfo);

        Users GetAccountByPassword(int userId, string currentPassword);

        bool ChangePassword(ChangePasswordModel model);
        //

        //DashBoard      
        IEnumerable<StudentExamOverviewModel> GetStudentExamOverView(int loggedId, string FromDate, string ToDate);
        IEnumerable<StudentExamOverviewModel> GetStudentExamOverviewByQuiz(int logged_userId, int quizid, string FromDate, string ToDate);
        IEnumerable<NewStudent> GetNewStudent(int logged_userId, string FromDate, string ToDate);
        List<DashboardRoles> DashboardRoles(int PublisherId);


        // Access Role Login.

        AccessModel GetRoleAccessDetails(int publisherId, int currentUserId, int roleId);
     
       //SubscriptionList
        List<SubscribersList> SubscribersList(int PublisherId);
        List<SubcribedClasses> SubcribedClasses(int UserId, int PublisherId);
        List<SubcribedContentResult> SubcribedContentResult(int ClassId);
    }
}