﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc; 
using IntelSkill.DAL;
using IntelSkill.Models;
using IntelSkill.Repository;
using IntelSkill.Utilities;

namespace IntelSkill.Utilities
{
    public class PageAction
    {
        private IUsersRepository usersRepository;
        PageRightsModel pageRightsModel = null;

        public PageAction()
        {
            this.usersRepository = new UsersRepository(new SQLDBContext());
        }


        public PageRightsModel _DoRightsAction(int currentUserId,int publisherUserId, int roleId)
        {
            var _pageRights = usersRepository.GetPageRights(currentUserId, publisherUserId);
            pageRightsModel = new PageRightsModel();
            if (roleId > 3)
            {
                pageRightsModel._add_new_student_for_public_class = (_pageRights.Where(x => x.PageName == "Add New Student for Public Class").Count() > 0);
                pageRightsModel._add_new_public_class = (_pageRights.Where(x => x.PageName == "Add New Public Class").Count() > 0);
                pageRightsModel._view_all_public_class = (_pageRights.Where(x => x.PageName == "View All Public Class").Count() > 0);
                pageRightsModel._edit_public_class = (_pageRights.Where(x => x.PageName == "Edit Public Class").Count() > 0);
                pageRightsModel._delete_public_class = (_pageRights.Where(x => x.PageName == "Delete Public Class").Count() > 0);
                pageRightsModel._save_public_class_in_draft = (_pageRights.Where(x => x.PageName == "Save Public Class in Draft").Count() > 0);
                pageRightsModel._public_class_preview = (_pageRights.Where(x => x.PageName == "Public Class Preview").Count() > 0);
                pageRightsModel._public_class_publish = (_pageRights.Where(x => x.PageName == "Public Class Publish").Count() > 0);
                pageRightsModel._view_subscribed_students = (_pageRights.Where(x => x.PageName == "View Subscribed Students").Count() > 0);
                pageRightsModel._activate_deactivate_subscribed_students = (_pageRights.Where(x => x.PageName == "Activate/Deactivate Subscribed Students").Count() > 0);
                pageRightsModel._add_new_private_class = (_pageRights.Where(x => x.PageName == "Add New Private Class").Count() > 0);
                pageRightsModel._view_all_private_class = (_pageRights.Where(x => x.PageName == "View All Private Class").Count() > 0);
                pageRightsModel._edit_private_class = (_pageRights.Where(x => x.PageName == "Edit Private Class").Count() > 0);
                pageRightsModel._delete_private_class = (_pageRights.Where(x => x.PageName == "Delete Private Class").Count() > 0);
                pageRightsModel._save_private_class_in_draft = (_pageRights.Where(x => x.PageName == "Save Private Class in Draft").Count() > 0);
                pageRightsModel._private_class_preview = (_pageRights.Where(x => x.PageName == "Private Class Preview").Count() > 0);
                pageRightsModel._private_class_publish = (_pageRights.Where(x => x.PageName == "Private Class Publish").Count() > 0);
                pageRightsModel._add_new_student_for_private_class = (_pageRights.Where(x => x.PageName == "Add New Student for Private Class").Count() > 0);
                pageRightsModel._class_edit_student = (_pageRights.Where(x => x.PageName == "Edit Student" && x.ModuleName == "Class Tools").Count() > 0);
                pageRightsModel._class_delete_student = (_pageRights.Where(x => x.PageName == "Delete Student" && x.ModuleName == "Class Tools").Count() > 0);

                /*Content Tools*/
                pageRightsModel._add_new_content = (_pageRights.Where(x => x.PageName == "Add New Content").Count() > 0);
                pageRightsModel._save_content_in_draft = (_pageRights.Where(x => x.PageName == "Save Content in Draft").Count() > 0);
                pageRightsModel._content_preview = (_pageRights.Where(x => x.PageName == "Content Preview").Count() > 0);
                pageRightsModel._content_publish = (_pageRights.Where(x => x.PageName == "Content Publish").Count() > 0);
                pageRightsModel._view_all_content_list = (_pageRights.Where(x => x.PageName == "View All Content List").Count() > 0);
                pageRightsModel._edit_content = (_pageRights.Where(x => x.PageName == "Edit Content").Count() > 0);
                pageRightsModel._delete_content = (_pageRights.Where(x => x.PageName == "Delete Content").Count() > 0);
                pageRightsModel._add_new_category = (_pageRights.Where(x => x.PageName == "Add New Category").Count() > 0);
                pageRightsModel._view_categories = (_pageRights.Where(x => x.PageName == "View Categories").Count() > 0);
                pageRightsModel._edit_category = (_pageRights.Where(x => x.PageName == "Edit Category").Count() > 0);
                pageRightsModel._delete_category = (_pageRights.Where(x => x.PageName == "Delete Category").Count() > 0);
                pageRightsModel._view_most_used_category = (_pageRights.Where(x => x.PageName == "View Most Used Category").Count() > 0);
                /*Content Tools End*/

                pageRightsModel._edit_student = (_pageRights.Where(x => x.PageName == "Edit Student" && x.ModuleName == "Students").Count() > 0);
                pageRightsModel._delete_student = (_pageRights.Where(x => x.PageName == "Delete Student" && x.ModuleName == "Students").Count() > 0);
                pageRightsModel._add_new_student = (_pageRights.Where(x => x.PageName == "Add New Student" && x.ModuleName == "Students").Count() > 0);
                pageRightsModel._view_student = (_pageRights.Where(x => x.PageName == "View Student" && x.ModuleName == "Students").Count() > 0);

                pageRightsModel._add_new_adminuser = (_pageRights.Where(x => x.PageName == "Add New User" && x.ModuleName == "Admin Users").Count() > 0);
                pageRightsModel._edit_adminuser = (_pageRights.Where(x => x.PageName == "Edit User" && x.ModuleName == "Admin Users").Count() > 0);
                pageRightsModel._delete_adminuser = (_pageRights.Where(x => x.PageName == "Delete User" && x.ModuleName == "Admin Users").Count() > 0);
                pageRightsModel._view_user = (_pageRights.Where(x => x.PageName == "View User" && x.ModuleName == "Admin Users").Count() > 0);
                pageRightsModel._view_user_permission = false;

                /*Quiz Tools*/
                pageRightsModel._build_quiz = (_pageRights.Where(x => x.PageName == "Build Quiz").Count() > 0);
                pageRightsModel._save_quiz_in_draft = (_pageRights.Where(x => x.PageName == "Save Quiz in Draft").Count() > 0);
                pageRightsModel._preview_quiz = (_pageRights.Where(x => x.PageName == "Preview Quiz").Count() > 0);
                pageRightsModel._publish_quiz = (_pageRights.Where(x => x.PageName == "Publish Quiz").Count() > 0);
                pageRightsModel._view_all_quiz = (_pageRights.Where(x => x.PageName == "View All Quiz").Count() > 0);
                pageRightsModel._edit_quiz = (_pageRights.Where(x => x.PageName == "Edit Quiz").Count() > 0);
                pageRightsModel._delete_quiz = (_pageRights.Where(x => x.PageName == "Delete Quiz").Count() > 0);
                pageRightsModel._add_question = (_pageRights.Where(x => x.PageName == "Add Question").Count() > 0);
                pageRightsModel._edit_question = (_pageRights.Where(x => x.PageName == "Edit Question").Count() > 0);
                pageRightsModel._view_question = (_pageRights.Where(x => x.PageName == "View Question").Count() > 0);
                pageRightsModel._delete_question = (_pageRights.Where(x => x.PageName == "Delete Question").Count() > 0);
                /*Quiz Tools End*/

                /*Reports*/
                pageRightsModel._view_quiz_reports = (_pageRights.Where(x => x.PageName == "View Quiz Reports").Count() > 0);
                pageRightsModel._view_student_reports = (_pageRights.Where(x => x.PageName == "View Student Reports").Count() > 0);
                pageRightsModel._view_exam_reports = (_pageRights.Where(x => x.PageName == "View Exam Reports").Count() > 0);
                /*Reports End*/

            }
            return pageRightsModel;
        }


    }
     
}