﻿using System;
using System.Collections.Generic;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Net.Mail;
using System.IO;

namespace DotNetVersion
{
    public partial class Registration : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {

            if (!IsPostBack)
            {


            }

        }

        public class RegistrationForm
        {

            public string FirstName;
            public string LastName;
            public string Gender;
            public int DOBDay;
            public int DOBMonth;
            public int DOBYear;
            public string Qualification;
            public string CollegeName;
            public string Location;
            public string ContactNumber;
            public string EmailAddress;

            public string Courses;

        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            RegistrationForm FormObj = new RegistrationForm();

            FormObj.FirstName = txtFirstName.Text;
            FormObj.LastName = txtLastName.Text;
            FormObj.Gender = ddlGender.SelectedItem.Text;
            FormObj.DOBDay = Convert.ToInt32(txtDay.Text);
            FormObj.DOBMonth = Convert.ToInt32(txtMonth.Text);
            FormObj.DOBYear = Convert.ToInt32(txtYear.Text);
            FormObj.Qualification = txtQualification.Text;
            FormObj.CollegeName = txtCollegeName.Text;
            FormObj.Location = txtLocation.Text;
            FormObj.ContactNumber = txtContactNumber.Text;

            FormObj.EmailAddress = txtEmail.Text;

            string CCNACourse = string.Empty;
            string EmbeddedSystems = string.Empty;

            CCNACourse = chkCCNACourse.Checked ? "CCNA (CISCO CERTIFICATIONS)" : "";
            EmbeddedSystems = chkEmbeddedCourse.Checked ? "EMBEDDED SYSTEMS" : "";
            FormObj.Courses = CCNACourse.Length > 0 ? CCNACourse : EmbeddedSystems;
            FormObj.Courses = EmbeddedSystems.Length > 0 ? EmbeddedSystems : CCNACourse;

            FormObj.Courses = CCNACourse.Length > 0 && EmbeddedSystems.Length > 0 ? CCNACourse + ", " + EmbeddedSystems : FormObj.Courses;

            SendMailToAdmin(FormObj, true);

            SendMailToRegisteredPerson(FormObj, true);

            SetCookies();

            divRegistration.Style.Add("display", "none");
            divThankyou.Style.Add("display", "block");
        }

        private void SetCookies()
        {
            Response.Cookies["STP"].Value = "Registered";
            Response.Cookies["STP"].Expires = DateTime.Now.AddYears(1);
        }

        private void SendMailToAdmin(RegistrationForm FormObj, bool isHtml)
        {

            string RegistrationAlertContent = File.ReadAllText(Server.MapPath("/emailtemplates") + "/registrationadminalert.htm");

            string ACCOUNT_NAME = "info@intelbull.com";
            string BOX_MESSAGE = @"Registration has been done by " + FormObj.FirstName + " " + FormObj.LastName + ". Please go through below details." +
                "<div>Contact Detail</div><div style='clear:both;height:1px;'></div>" +
                "<div style='width:30%;float:left;'>Email</div><div style='width:65%;float:left;'>:" + FormObj.EmailAddress + "</div><div style='clear:both;height:1px;'></div>" +
                "<div style='width:30%;float:left;'>Contact Number</div><div style='width:65%;float:left;'>:" + FormObj.ContactNumber + "</div><div style='clear:both;height:1px;'></div>" +
                  "<div  style='width:30%;float:left;'>Preferred Course(s)</div><div  style='width:65%;float:left;'>:" + FormObj.Courses + "</div><div style='clear:both;height:1px;'></div>" +
                  "<p>Personal Detail</p>" +
                "<div style='width:30%;float:left;'>Gender</div><div  style='width:65%;float:left;'>:" + FormObj.Gender + "</div><div style='clear:both;height:1px;'></div>" +
                "<div style='width:30%;float:left;'>Date Of Birth</div><div  style='width:65%;float:left;'>:" + FormObj.DOBDay + "/" + FormObj.DOBMonth + "/" + FormObj.DOBYear + "</div><div style='clear:both;height:1px;'></div>" +
                "<div style='width:30%;float:left;'>Qualification</div><div  style='width:65%;float:left;'>:" + FormObj.Qualification + "</div><div style='clear:both;height:1px;'></div>" +
                "<div style='width:30%;float:left;'>College Name</div><div  style='width:65%;float:left;'>:" + FormObj.CollegeName + "</div><div style='clear:both;height:1px;'></div>" +
                "<div style='width:30%;float:left;'>Location</div><div  style='width:65%;float:left;'>:" + FormObj.Location + "</div><div style='clear:both;height:1px;'></div>" +
                "<p>&nbsp;</p>";


            RegistrationAlertContent = RegistrationAlertContent.Replace("@REGISTER_FORM_DETAILS", BOX_MESSAGE);

            try
            {
                SmtpClient smtp = new SmtpClient();

                smtp.Credentials = new System.Net.NetworkCredential("info@intelbull.com", "mail@12345");

                smtp.Port = 25;
                smtp.Host = "mail.intelbull.com";
                smtp.EnableSsl = false;
                MailMessage message = new MailMessage(FormObj.EmailAddress, ACCOUNT_NAME, FormObj.FirstName + " " + FormObj.LastName + " has sent message", RegistrationAlertContent);
                message.IsBodyHtml = isHtml;
                smtp.Send(message);
            }
            catch (Exception ex)
            {

            }
        }

        private void SendMailToRegisteredPerson(RegistrationForm FormObj, bool isHtml)
        {

            string RegistrationThankYouContent = File.ReadAllText(Server.MapPath("/emailtemplates") + "/thankyouregistration.htm");

            string ACCOUNT_NAME = "info@intelbull.com";
            string BOX_MESSAGE = @"<p>Dear " + FormObj.FirstName + " " + FormObj.LastName + "" +
                "<p style='font-size:14px;'>Thank you for registration with Sarvajith Tech Park</p>" +
                  "<p style='font-size:14px;'>We will process your registration and revert back to you.</p>" +
                   "<p style='font-size:18px;margin-top:150px;'>Thanks & Regards,</p>" +
                    "<p>Sarvajith Tech Park</p><p>Administrator</p>" +
                "<p>&nbsp;</p>";


            RegistrationThankYouContent = RegistrationThankYouContent.Replace("@REGISTER_FORM_DETAILS", BOX_MESSAGE);

            try
            {
                SmtpClient smtp = new SmtpClient();

                smtp.Credentials = new System.Net.NetworkCredential("info@intelbull.com", "mail@12345");

                smtp.Port = 25;
                smtp.Host = "mail.intelbull.com";
                smtp.EnableSsl = false;
                MailMessage message = new MailMessage(ACCOUNT_NAME, FormObj.EmailAddress, "Thank you for registration with Sarvajith Tech Park, Pondicherry", RegistrationThankYouContent);
                message.IsBodyHtml = isHtml;
                smtp.Send(message);
            }
            catch (Exception ex)
            {

            }
        }
    }
}