﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI.HtmlControls;
using System.Web.UI;
using System.Web.UI.WebControls;

namespace WebAdministrator
{
    public class BaseAdminPage : System.Web.UI.Page
    {
         

        private void Page_PreInit(object sender, System.EventArgs e)
        {
            PreRequisitesFiles();
        }

        protected override void OnLoad(EventArgs e)
        {
            if (!IsPostBack)
            {
                base.OnLoad(e);

                PageHeaderTags();
            }

         
        }

        private void PageHeaderTags()
        {
            if (!String.IsNullOrEmpty(BaseMetaKeywords))
            {

                HtmlMeta tag = new HtmlMeta();

                tag.Name = "keywords";

                tag.Content = BaseMetaKeywords;

                Header.Controls.Add(tag);

            }



            if (!String.IsNullOrEmpty(BaseMetaDescription))
            {

                HtmlMeta tag = new HtmlMeta();

                tag.Name = "description";

                tag.Content = BaseMetaDescription;

                Header.Controls.Add(tag);

            }
        }

        private void PreRequisitesFiles()
        { 
            Literal literal = (Literal)Page.Master.FindControl("HeaderFiles");

            if (literal != null)
            {
                literal.Text += @"<link rel='stylesheet' href='" + GetCurrentPath() + @"../css/960.css' type='text/css' media='screen' charset='utf-8' />
                            <link rel='stylesheet' href='" + GetCurrentPath() + @"../css/template.css' type='text/css' media='screen' charset='utf-8' />
                            <link rel='stylesheet' href='" + GetCurrentPath() + @"../css/colour.css' type='text/css' media='screen' charset='utf-8' />
                            ";
            }
        }

        public string GetCurrentPath()
        {
            string pathfolder = (Request.Url.AbsolutePath.ToLower().Contains("accounts")) ? "../" : "";
            return pathfolder;
        }
        public string BaseMetaDescription { get; set; }

        public string BaseMetaKeywords { get; set; }
    }
}