﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.IO;
using B2BBizLayer.Classes;
using B2BPropLayer.Classes;

namespace WebAdministrator.Authenticated
{
    public partial class AddCategory : BaseAdminPage
    {
        BLAdminCategory bladminCategory = null;
        PLAdminCategory pladminCategory = null;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                divBannerImageUpload.Style.Add("display", "block");
                divBannerImagePreview.Style.Add("display", "none");

                divIconImageUpload.Style.Add("display", "block");
                divIconImagePreview.Style.Add("display", "none");

                BaseMetaKeywords = "WEST";
                BaseMetaDescription = "HELLO TEST";
                BindCategories();
                BindSelectedCategory();
            }
        }
        private void BindSelectedCategory()
        {
            if (Request.QueryString["category_Id"] != null)
            {

                int category_Id = 0;
                Int32.TryParse(Request.QueryString["category_Id"].ToString(), out category_Id);

                if (category_Id > 0)
                {
                    bladminCategory = new BLAdminCategory();

                    DataSet ds = bladminCategory.SelectCategory(category_Id);

                    if (ds.Tables.Count > 1)
                    {
                        txtCategoryName.Text = ds.Tables[0].Rows[0]["CategoryName"].ToString();
                        txtDescription.Text = ds.Tables[0].Rows[0]["Description"].ToString();
                        txtSEOTitle.Text = ds.Tables[0].Rows[0]["SEO_Title"].ToString();
                        txtSEOMetaKeyword.Text = ds.Tables[0].Rows[0]["SEO_MetaKeyword"].ToString();
                        txtSEOMetaDescription.Text = ds.Tables[0].Rows[0]["SEO_MetaDescription"].ToString();
                        txtSEOMarqueeText.Text = ds.Tables[0].Rows[0]["SEO_MarqueeText"].ToString();
                        ddlPosition.SelectedValue = ds.Tables[0].Rows[0]["Position"].ToString();
                        chkbxActive.Checked = Boolean.Parse(ds.Tables[0].Rows[0]["IsActive"].ToString());

                        if (!string.IsNullOrEmpty(ds.Tables[0].Rows[0]["Banner"].ToString()))
                        {
                            imgBannerLogo.ImageUrl = "/ImageHandler.ashx?file=" + ds.Tables[0].Rows[0]["Banner"].ToString() + "&file_location=/Uploads/Common/Categories/Banners&h=70&w=400";
                            divBannerImageUpload.Style.Add("display", "none");
                            divBannerImagePreview.Style.Add("display", "block");
                        }
                        else { divBannerImageUpload.Style.Add("display", "block"); divBannerImagePreview.Style.Add("display", "none"); }

                        if (!string.IsNullOrEmpty(ds.Tables[0].Rows[0]["Icon"].ToString()))
                        {
                            imgIconLogo.ImageUrl = "/ImageHandler.ashx?file=" + ds.Tables[0].Rows[0]["Icon"].ToString() + "&file_location=/Uploads/Common/Categories/Icons&h=32&w=32";
                            divIconImageUpload.Style.Add("display", "none");
                            divIconImagePreview.Style.Add("display", "block");
                        }
                        else { divIconImageUpload.Style.Add("display", "block"); divIconImagePreview.Style.Add("display", "none"); }

                        if (ds.Tables[0].Rows[0]["Parent_Id"].ToString() != "0")
                        {
                            SetupCurrentCategories(ds.Tables[1]);

                            ddlCategory1.SelectedValue = Level1_categoryId;
                            ddlCategory1_SelectedIndexChanged(null, null);

                            ddlCategory2.SelectedValue = Level2_categoryId;
                            ddlCategory2_SelectedIndexChanged(null, null);

                            ddlCategory3.SelectedValue = Level3_categoryId;

                        }
                        else
                        {
                            ddlCategory1.Items.Clear();
                            ddlCategory1.Items.Add(new ListItem("-select category-", "0")); Panel_Category.Style.Add("display", "none");
                        }

                    }
                }
            }
        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            if (Page.IsValid)
            {
                pladminCategory = new PLAdminCategory();

                string[] validFileTypes = { "bmp", "gif", "png", "jpg", "jpeg" };

                string Bannerext = System.IO.Path.GetExtension(FUBanner.PostedFile.FileName);
                string Iconext = System.IO.Path.GetExtension(FUIcon.PostedFile.FileName);

                bool isBannerValidFile = false;
                bool isIconValidFile = false;
                for (int i = 0; i < validFileTypes.Length; i++)
                {

                    if (Bannerext == "." + validFileTypes[i])
                    {

                        isBannerValidFile = true;

                        continue;

                    }

                    if (Iconext == "." + validFileTypes[i])
                    {

                        isIconValidFile = true;

                        continue;

                    }

                }

                string BannerUploadPath = string.Empty;
                string IconUploadPath = string.Empty;

                if (isBannerValidFile)
                {
                    string fileRandomName = Guid.NewGuid().ToString().Substring(0, 15);
                    string fileextension = System.IO.Path.GetExtension(FUBanner.FileName);

                    BannerUploadPath = GetUserUploadPath("Common/Categories/Banners"); 
                   
                    BannerUploadPath += "\\" + fileRandomName + fileextension;

                    pladminCategory.Banner = fileRandomName + fileextension;
                }
                else
                {
                    LabelMessage.InnerHtml = "Banner invalid format.";
                }


                if (isIconValidFile)
                {
                    IconUploadPath = string.Empty;
                    string fileRandomName = Guid.NewGuid().ToString().Substring(0, 15);
                    string fileextension = System.IO.Path.GetExtension(FUIcon.FileName);

                    IconUploadPath = GetUserUploadPath("Common/Categories/Icons"); 
                   
                    IconUploadPath += "\\" + fileRandomName + fileextension;

                    pladminCategory.Icon = fileRandomName + fileextension;
                }
                else
                {
                    LabelMessage.InnerHtml = "Icon invalid format.";
                }

                bladminCategory = new BLAdminCategory();


                pladminCategory.CategoryName = txtCategoryName.Text;


                int category_Id = 0;

                if (Request.QueryString["category_Id"] != null)
                    Int32.TryParse(Request.QueryString["category_Id"].ToString(), out category_Id);

                pladminCategory.Category_Id = category_Id;

                pladminCategory.Description = txtDescription.Text;

                pladminCategory.SEO_Title = txtSEOTitle.Text;
                pladminCategory.SEO_MetaKeyword = txtSEOMetaKeyword.Text;
                pladminCategory.SEO_MetaDescription = txtSEOMetaDescription.Text;
                pladminCategory.SEO_MarqueeText = txtSEOMarqueeText.Text;
                pladminCategory.Parent_Id = GetSelectedCategoryId();
                int position = 0;
                Int32.TryParse(ddlPosition.SelectedItem.Value, out position);

                pladminCategory.Position = position;
                pladminCategory.IsActive = chkbxActive.Checked;

                int retval = 0;

                if (category_Id > 0)
                {
                    retval = bladminCategory.UpdateCategory(pladminCategory);

                    if (retval > 0)
                    {
                        BindCategories();
                        BindSelectedCategory();
                    }
                }
                else
                {
                    retval = bladminCategory.InsertCategory(pladminCategory);

                    if (retval > 0)
                        ClearFields();
                }

                if (retval > 0)
                {
                    if (isBannerValidFile)
                        FUBanner.SaveAs(BannerUploadPath);

                    if (isIconValidFile)
                        FUIcon.SaveAs(IconUploadPath);

                    LabelMessage.InnerHtml = "category successfully updated.";
                    LabelMessage.Style.Add("display", "block");
                }
                else { LabelMessage.InnerHtml = "category adding failed."; LabelMessage.Style.Add("display", "block"); }
            }

        }

        private void ClearFields()
        {
            txtCategoryName.Text = string.Empty;
            txtDescription.Text = string.Empty;

            txtSEOTitle.Text = string.Empty;
            txtSEOMetaKeyword.Text = string.Empty;
            txtSEOMetaDescription.Text = string.Empty;
            txtSEOMarqueeText.Text = string.Empty;

            ddlPosition.SelectedValue = "0";
            chkbxActive.Checked = true;

            ddlCategory1.SelectedValue = "0";
            ddlCategory2.SelectedValue = "0";
            ddlCategory3.SelectedValue = "0";

        }

        private string GetUserUploadPath(string uploadDirectory)
        {
            string rootUploadPath = Server.MapPath("/Uploads");

            if (!Directory.Exists(rootUploadPath))
            {
                Directory.CreateDirectory(rootUploadPath);
            }

            string[] DirectoryList = uploadDirectory.Split(new char[] { '/' });


            foreach (string currentDirectory in DirectoryList)
            {
                if (currentDirectory.Length > 0)
                {
                    rootUploadPath += "\\" + currentDirectory;

                    if (!Directory.Exists(rootUploadPath))
                    {
                        Directory.CreateDirectory(rootUploadPath);
                    }
                }
            }

            return rootUploadPath;
        }

        private string Level1_categoryId { get; set; }
        private string Level2_categoryId { get; set; }
        private string Level3_categoryId { get; set; }
        private string Level4_categoryId { get; set; }

        private string SetupCurrentCategories(DataTable dataTable)
        {
            if (dataTable.Rows.Count > 0)
            {
                if (!string.IsNullOrEmpty(dataTable.Rows[0]["up3_recId"].ToString()))
                {
                    Level1_categoryId = dataTable.Rows[0]["up3_recId"].ToString();
                    Level2_categoryId = dataTable.Rows[0]["up2_recId"].ToString();
                    Level3_categoryId = dataTable.Rows[0]["up1_recId"].ToString();
                    Level4_categoryId = dataTable.Rows[0]["node_recId"].ToString();
                }
                else if (!string.IsNullOrEmpty(dataTable.Rows[0]["up2_recId"].ToString()))
                {
                    Level1_categoryId = dataTable.Rows[0]["up2_recId"].ToString();
                    Level2_categoryId = dataTable.Rows[0]["up1_recId"].ToString();
                    Level3_categoryId = dataTable.Rows[0]["node_recId"].ToString();
                    Level4_categoryId = "0";
                }
                else if (!string.IsNullOrEmpty(dataTable.Rows[0]["up1_recId"].ToString()))
                {
                    Level1_categoryId = dataTable.Rows[0]["up1_recId"].ToString();
                    Level2_categoryId = dataTable.Rows[0]["node_recId"].ToString();
                    Level3_categoryId = "0";
                    Level4_categoryId = "0";
                }
                else if (!string.IsNullOrEmpty(dataTable.Rows[0]["node_recId"].ToString()))
                {
                    Level1_categoryId = dataTable.Rows[0]["node_recId"].ToString();
                    Level2_categoryId = "0";
                    Level3_categoryId = "0";
                    Level4_categoryId = "0";
                }
            }

            return "0";
        }

        private int GetSelectedCategoryId()
        {
            int selected_categoryId = 0;



            if (selected_categoryId == 0)
            {
                if (ddlCategory3.Items.Count > 1)
                {
                    if (ddlCategory3.SelectedItem.Value != "0")
                    {
                        selected_categoryId = ConvertToInteger(ddlCategory3.SelectedItem.Value);
                    }

                }
            }

            if (selected_categoryId == 0)
            {
                if (ddlCategory2.Items.Count > 1)
                {
                    if (ddlCategory2.SelectedItem.Value != "0")
                    {
                        selected_categoryId = ConvertToInteger(ddlCategory2.SelectedItem.Value);
                    }

                }
            }

            if (selected_categoryId == 0)
            {
                if (ddlCategory1.Items.Count > 1)
                {
                    if (ddlCategory1.SelectedItem.Value != "0")
                    {
                        selected_categoryId = ConvertToInteger(ddlCategory1.SelectedItem.Value);
                    }

                }
            }

            return selected_categoryId;
        }

        private int ConvertToInteger(string _strValue)
        {
            int retval = 0;

            Int32.TryParse(_strValue, out retval);

            return retval;


        }

        private void BindCategories()
        {
            bladminCategory = new BLAdminCategory();

            DataSet ds = bladminCategory.SelectCategoryByParent(0);
            ddlCategory1.Items.Clear();
            ddlCategory1.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory1.AppendDataBoundItems = true;
            ddlCategory1.DataSource = ds.Tables[0].DefaultView;
            ddlCategory1.DataTextField = "CategoryName";
            ddlCategory1.DataValueField = "Category_Id";
            ddlCategory1.DataBind();

            //Default

            ddlCategory2.Items.Clear();
            ddlCategory2.Items.Add(new ListItem("-select category-", "0"));

            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));

            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));

        }

        private DataSet BindChildCategories(int Parent_Id)
        {
            bladminCategory = new BLAdminCategory();

            DataSet ds = bladminCategory.SelectCategoryByParent(Parent_Id);

            return ds;
        }

        protected void ddlCategory1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Parent_Id = Int32.Parse(ddlCategory1.SelectedItem.Value);
            ddlCategory2.Items.Clear();
            ddlCategory2.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory2.AppendDataBoundItems = true;
            if (Parent_Id > 0)
            {
                ddlCategory2.DataSource = BindChildCategories(Parent_Id);
                ddlCategory2.DataTextField = "CategoryName";
                ddlCategory2.DataValueField = "Category_Id";
                ddlCategory2.DataBind();
            }

            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));


        }

        protected void ddlCategory2_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Parent_Id = Int32.Parse(ddlCategory2.SelectedItem.Value);
            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory3.AppendDataBoundItems = true;
            if (Parent_Id > 0)
            {
                ddlCategory3.DataSource = BindChildCategories(Parent_Id);
                ddlCategory3.DataTextField = "CategoryName";
                ddlCategory3.DataValueField = "Category_Id";
                ddlCategory3.DataBind();
            }


        }

        protected void lnkbtnRemoveBannerPhoto_Click(object sender, EventArgs e)
        {
            bladminCategory = new BLAdminCategory();

            int category_Id = 0;

            if (Request.QueryString["category_Id"] != null)
                Int32.TryParse(Request.QueryString["category_Id"].ToString(), out category_Id);

            string categoryPhoto = string.Empty;

            int retval = bladminCategory.DeleteCategoryPhoto(category_Id, out categoryPhoto, "Banner");

            if (retval > 0)
            {
                string imagepath = Server.MapPath("/Uploads/Common/Categories/Banners/" + categoryPhoto);
                if (File.Exists(imagepath))
                {
                    File.Delete(imagepath); imgBannerLogo.ImageUrl = "";
                }
                divBannerImageUpload.Style.Add("display", "block");
                divBannerImagePreview.Style.Add("display", "none");
            }
            else
            {
                {
                    divBannerImageUpload.Style.Add("display", "none");
                    divBannerImagePreview.Style.Add("display", "block");
                }
            }
        }

        protected void lnkbtnRemoveIconPhoto_Click(object sender, EventArgs e)
        {
            bladminCategory = new BLAdminCategory();

            int category_Id = 0;

            if (Request.QueryString["category_Id"] != null)
                Int32.TryParse(Request.QueryString["category_Id"].ToString(), out category_Id);

            string categoryPhoto = string.Empty;

            int retval = bladminCategory.DeleteCategoryPhoto(category_Id, out categoryPhoto, "Icon");

            if (retval > 0)
            {
                string imagepath = Server.MapPath("/Uploads/Common/Categories/Icons/" + categoryPhoto);
                if (File.Exists(imagepath))
                {
                    File.Delete(imagepath); imgIconLogo.ImageUrl = "";
                }

              
                divIconImageUpload.Style.Add("display", "block");
                divIconImagePreview.Style.Add("display", "none");
            }
            else
            {
                {
                    divIconImageUpload.Style.Add("display", "none");
                    divIconImagePreview.Style.Add("display", "block");
                }
            }
        }
    }
}