﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using System.IO;

using B2BBizLayer.Classes;
using B2BPropLayer.Classes;


namespace WebAdministrator.Authenticated
{
    public partial class AddProduct : BaseAdminPage
    {
        BLAdminProduct bladminProduct = null;
        PLAdminProduct pladminProduct = null;

        PLAdminUser pladminUser = null;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                divImageUpload.Style.Add("display", "block");
                divImagePreview.Style.Add("display", "none");

                BaseMetaKeywords = "WEST";
                BaseMetaDescription = "HELLO TEST";

                BindCategories();
                BindSelectedProduct();

              

            }
        }

        private void BindCategories()
        {
            bladminProduct = new BLAdminProduct();

            DataSet ds = bladminProduct.SelectCategory(0);
            ddlCategory1.Items.Clear();
            ddlCategory1.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory1.AppendDataBoundItems = true;
            ddlCategory1.DataSource = ds.Tables[0].DefaultView;
            ddlCategory1.DataTextField = "CategoryName";
            ddlCategory1.DataValueField = "Id";
            ddlCategory1.DataBind();

            //Default

            ddlCategory2.Items.Clear();
            ddlCategory2.Items.Add(new ListItem("-select category-", "0"));

            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));

            ddlCategory4.Items.Clear();
            ddlCategory4.Items.Add(new ListItem("-select category-", "0"));

        }

        private DataSet BindChildCategories(int Parent_Id)
        {
            bladminProduct = new BLAdminProduct();

            DataSet ds = bladminProduct.SelectCategory(Parent_Id);

            return ds;
        }

        private void BindSelectedProduct()
        {
            LoggedAccount();

            if (Request.QueryString["product_Id"] != null)
            {

                int product_Id = 0;
                Int32.TryParse(Request.QueryString["product_Id"].ToString(), out product_Id);

                if (product_Id > 0)
                {
                    bladminProduct = new BLAdminProduct();

                    DataSet ds = bladminProduct.SelectProduct(product_Id);

                    if (ds.Tables.Count > 1)
                    {
                        txtProductName.Text = ds.Tables[0].Rows[0]["ProductName"].ToString();
                        txtShortDescription.Text = ds.Tables[0].Rows[0]["ShortDescription"].ToString();
                        txtKeyword.Text = ds.Tables[0].Rows[0]["Keyword"].ToString();

                        txtProductCode.Text = ds.Tables[0].Rows[0]["ProductCode"].ToString();
                        txtLongDescription.Text = ds.Tables[0].Rows[0]["LongDescription"].ToString();

                        txtProductMRPAmount.Text = ds.Tables[0].Rows[0]["ProductMRPAmount"].ToString();
                        txtProductDiscountAmount.Text = ds.Tables[0].Rows[0]["ProductDiscountAmount"].ToString();
                        txtProductDiscountPercentage.Text = ds.Tables[0].Rows[0]["ProductDiscountPercentage"].ToString();

                        txtSEOTitle.Text = ds.Tables[0].Rows[0]["SEO_Title"].ToString();
                        txtSEOMetaKeyword.Text = ds.Tables[0].Rows[0]["SEO_MetaKeyword"].ToString();
                        txtSEOMetaDescription.Text = ds.Tables[0].Rows[0]["SEO_MetaDescription"].ToString();
                        txtSEOMarqueeText.Text = ds.Tables[0].Rows[0]["SEO_MarqueeText"].ToString();

                        ddlPosition.SelectedValue = ds.Tables[0].Rows[0]["Position"].ToString();
                        chkbxActive.Checked = Boolean.Parse(ds.Tables[0].Rows[0]["IsActive"].ToString());

                        SetupCurrentCategories(ds.Tables[1]);

                        ddlCategory1.SelectedValue = Level1_categoryId;

                        ddlCategory1_SelectedIndexChanged(null, null);
                        ddlCategory2.SelectedValue = Level2_categoryId;
                        ddlCategory2_SelectedIndexChanged(null, null);
                        ddlCategory3.SelectedValue = Level3_categoryId;
                        ddlCategory3_SelectedIndexChanged(null, null);
                        ddlCategory4.SelectedValue = Level4_categoryId;


                        if (!string.IsNullOrEmpty(ds.Tables[0].Rows[0]["PrimaryPhoto"].ToString()))
                        {
                            imgLogo.ImageUrl = "/ImageHandler.ashx?file=" + ds.Tables[0].Rows[0]["PrimaryPhoto"].ToString() + "&file_location=/Uploads/ProductImages&h=100&w=100";
                            divImageUpload.Style.Add("display", "none");
                            divImagePreview.Style.Add("display", "block");
                        }
                        else { divImageUpload.Style.Add("display", "block"); divImagePreview.Style.Add("display", "none"); }
                    }
                }
                else { txtProductDiscountAmount.Text = "0.00"; txtProductDiscountPercentage.Text = "0.00"; txtProductMRPAmount.Text = "0.00"; }
            }
        }

        private string Level1_categoryId { get; set; }
        private string Level2_categoryId { get; set; }
        private string Level3_categoryId { get; set; }
        private string Level4_categoryId { get; set; }

        private string SetupCurrentCategories(DataTable dataTable)
        {
            if (!string.IsNullOrEmpty(dataTable.Rows[0]["up3_recId"].ToString()))
            {
                Level1_categoryId = dataTable.Rows[0]["up3_recId"].ToString();
                Level2_categoryId = dataTable.Rows[0]["up2_recId"].ToString();
                Level3_categoryId = dataTable.Rows[0]["up1_recId"].ToString();
                Level4_categoryId = dataTable.Rows[0]["node_recId"].ToString();
            }
            else

                if (!string.IsNullOrEmpty(dataTable.Rows[0]["up2_recId"].ToString()))
                {
                    Level1_categoryId = dataTable.Rows[0]["up2_recId"].ToString();
                    Level2_categoryId = dataTable.Rows[0]["up1_recId"].ToString();
                    Level3_categoryId = dataTable.Rows[0]["node_recId"].ToString();
                    Level4_categoryId = "0";
                }
                else

                    if (!string.IsNullOrEmpty(dataTable.Rows[0]["up1_recId"].ToString()))
                    {
                        Level1_categoryId = dataTable.Rows[0]["up1_recId"].ToString();
                        Level2_categoryId = dataTable.Rows[0]["node_recId"].ToString();
                        Level3_categoryId = "0";
                        Level4_categoryId = "0";
                    }
                    else

                        if (!string.IsNullOrEmpty(dataTable.Rows[0]["node_recId"].ToString()))
                        {
                            Level1_categoryId = dataTable.Rows[0]["node_recId"].ToString();
                            Level2_categoryId = "0";
                            Level3_categoryId = "0";
                            Level4_categoryId = "0";
                        }

            return "0";
        }

        protected void btnSubmit_Click(object sender, EventArgs e)
        {
            if (Page.IsValid)
            {


                string[] validFileTypes = { "bmp", "gif", "png", "jpg", "jpeg" };

                string ext = ""; if (FUPhoto.PostedFile != null) ext = System.IO.Path.GetExtension(FUPhoto.PostedFile.FileName);

                bool isValidFile = false;

                for (int i = 0; i < validFileTypes.Length; i++)
                {

                    if (ext == "." + validFileTypes[i])
                    {

                        isValidFile = true;

                        break;

                    }

                }

                LoggedAccount();
                string UploadPath = string.Empty;
                pladminProduct = new PLAdminProduct();
                if (isValidFile)
                {
                    string fileRandomName = Guid.NewGuid().ToString().Substring(0, 15);
                    string fileextension = System.IO.Path.GetExtension(FUPhoto.FileName);

                    UploadPath = GetUserUploadPath("ProductImages");

                    UploadPath += "\\" + fileRandomName + fileextension;

                    pladminProduct.PrimaryPhoto = fileRandomName + fileextension;
                }
                else
                {

                    LabelMessage.InnerHtml = "image invalid format."; LabelMessage.Style.Add("display", "block");

                }

                pladminProduct.ProductName = txtProductName.Text;


                int product_Id = 0;

                if (Request.QueryString["product_Id"] != null)
                    Int32.TryParse(Request.QueryString["product_Id"].ToString(), out product_Id);

                pladminProduct.Product_Id = product_Id;
                pladminProduct.Category_Id = GetSelectedCategoryId();
                pladminProduct.ShortDescription = txtShortDescription.Text;
                pladminProduct.LongDescription = txtLongDescription.Text;

                pladminProduct.Keyword = txtKeyword.Text;
                pladminProduct.SEO_Title = txtSEOTitle.Text;
                pladminProduct.SEO_MetaKeyword = txtSEOMetaKeyword.Text;
                pladminProduct.SEO_MetaDescription = txtSEOMetaDescription.Text;
                pladminProduct.SEO_MarqueeText = txtSEOMarqueeText.Text; 
                pladminProduct.Date_Created = System.DateTime.Now;
                pladminProduct.Date_Modified = System.DateTime.Now;

                pladminProduct.ProductCode = txtProductCode.Text;
                pladminProduct.ProductMRPAmount = txtProductMRPAmount.Text;
                pladminProduct.ProductDiscountAmount = txtProductDiscountAmount.Text;
                pladminProduct.ProductDiscountPercentage = txtProductDiscountPercentage.Text;

                int position = 0;
                Int32.TryParse(ddlPosition.SelectedItem.Value, out position);

                pladminProduct.Position = position;
                pladminProduct.IsActive = chkbxActive.Checked;

                bladminProduct = new BLAdminProduct();

                int retval = 0;

                if (product_Id == 0)
                {
                    retval = bladminProduct.InsertProduct(pladminProduct, out product_Id);
                    if (retval > 0)
                    {


                    }

                }
                else
                {
                    retval = bladminProduct.UpdateProduct(pladminProduct); BindSelectedProduct();
                }


                if (retval > 0)
                {
                    if (UploadPath.Length > 0)
                        FUPhoto.SaveAs(UploadPath);
                    LabelMessage.InnerHtml = "Product successfully added."; LabelMessage.Style.Add("display", "block");
                }
                else { LabelMessage.InnerHtml = "Product adding failed."; LabelMessage.Style.Add("display", "block"); }
            }

        }

        private int GetSelectedCategoryId()
        {
            int selected_categoryId = 0;

            if (selected_categoryId == 0)
            {
                if (ddlCategory4.Items.Count > 1)
                {
                    if (ddlCategory4.SelectedItem.Value != "0")
                    {
                        selected_categoryId = ConvertToInteger(ddlCategory4.SelectedItem.Value);
                    }

                }
            }

            if (selected_categoryId == 0)
            {
                if (ddlCategory3.Items.Count > 1)
                {
                    if (ddlCategory3.SelectedItem.Value != "0")
                    {
                        selected_categoryId = ConvertToInteger(ddlCategory3.SelectedItem.Value);
                    }

                }
            }

            if (selected_categoryId == 0)
            {
                if (ddlCategory2.Items.Count > 1)
                {
                    if (ddlCategory2.SelectedItem.Value != "0")
                    {
                        selected_categoryId = ConvertToInteger(ddlCategory2.SelectedItem.Value);
                    }

                }
            }

            if (selected_categoryId == 0)
            {
                if (ddlCategory1.Items.Count > 1)
                {
                    if (ddlCategory1.SelectedItem.Value != "0")
                    {
                        selected_categoryId = ConvertToInteger(ddlCategory1.SelectedItem.Value);
                    }

                }
            }

            return selected_categoryId;
        }

        protected void ddlCategory1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Parent_Id = Int32.Parse(ddlCategory1.SelectedItem.Value);
            ddlCategory2.Items.Clear();
            ddlCategory2.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory2.AppendDataBoundItems = true;
            if (Parent_Id > 0)
            {
                ddlCategory2.DataSource = BindChildCategories(Parent_Id);
                ddlCategory2.DataTextField = "CategoryName";
                ddlCategory2.DataValueField = "Id";
                ddlCategory2.DataBind();
            }

            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));

            ddlCategory4.Items.Clear();
            ddlCategory4.Items.Add(new ListItem("-select category-", "0"));
        }

        protected void ddlCategory2_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Parent_Id = Int32.Parse(ddlCategory2.SelectedItem.Value);
            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory3.AppendDataBoundItems = true;
            if (Parent_Id > 0)
            {
                ddlCategory3.DataSource = BindChildCategories(Parent_Id);
                ddlCategory3.DataTextField = "CategoryName";
                ddlCategory3.DataValueField = "Id";
                ddlCategory3.DataBind();
            }

            ddlCategory4.Items.Clear();
            ddlCategory4.Items.Add(new ListItem("-select category-", "0"));
        }

        protected void ddlCategory3_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Parent_Id = Int32.Parse(ddlCategory3.SelectedItem.Value);
            ddlCategory4.Items.Clear();
            ddlCategory4.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory4.AppendDataBoundItems = true;
            if (Parent_Id > 0)
            {
                ddlCategory4.DataSource = BindChildCategories(Parent_Id);
                ddlCategory4.DataTextField = "CategoryName";
                ddlCategory4.DataValueField = "Id";
                ddlCategory4.DataBind();
            }
        }

        private string GetUserUploadPath(string uploadDirectory)
        {
            string rootUploadPath = Server.MapPath("/Uploads");

            if (!Directory.Exists(rootUploadPath))
            {
                Directory.CreateDirectory(rootUploadPath);
            }


            rootUploadPath += "\\" + uploadDirectory;

            if (!Directory.Exists(rootUploadPath))
            {
                Directory.CreateDirectory(rootUploadPath);

            }

            return rootUploadPath;
        }

        private void LoggedAccount()
        {
            if (Session["Username"] != null)
            {
                 
            }
            else { Response.Redirect("/admin/account/login.aspx", true); }
        }

        private int ConvertToInteger(string _strValue)
        {
            int retval = 0;

            Int32.TryParse(_strValue, out retval);

            return retval;


        }

        protected void lnkbtnRemovePhoto_Click(object sender, EventArgs e)
        {
            LoggedAccount();

            bladminProduct = new BLAdminProduct();
            int product_Id = 0;

            if (Request.QueryString["product_Id"] != null)
                Int32.TryParse(Request.QueryString["product_Id"].ToString(), out product_Id);

            string primaryPhoto = string.Empty;

            int retval = bladminProduct.DeleteProductPhoto(product_Id, out primaryPhoto);

            if (retval > 0)
            {
                string imagepath = Server.MapPath("/Uploads/ProductImages/" + primaryPhoto);
                if (File.Exists(imagepath))
                {

                    File.Delete(imagepath);
                }
                divImageUpload.Style.Add("display", "block");
                divImagePreview.Style.Add("display", "none");
            }
            else
            {
                {
                    divImageUpload.Style.Add("display", "none");
                    divImagePreview.Style.Add("display", "block");
                }
            }
        }
    }
}