﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

using B2BBizLayer.Classes;
using B2BPropLayer.Classes;

namespace WebAdministrator.Authenticated
{
    public partial class ManageCategories : BaseAdminPage
    {
        BLAdminCategory bladminCategory = null;

        public int pageSize = 10;
        public int rowCount = 0;
        public int pageIndex = 1;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {

                BaseMetaKeywords = "WEST";
                BaseMetaDescription = "HELLO TEST";
                BindDropDownCategories();

                BindCategories();

            }
        }

        private void BindDropDownCategories()
        {
            bladminCategory = new BLAdminCategory();

            DataSet ds = bladminCategory.SelectCategoryByParent(0);
            ddlCategory1.Items.Clear();
            ddlCategory1.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory1.AppendDataBoundItems = true;
            ddlCategory1.DataSource = ds.Tables[0].DefaultView;
            ddlCategory1.DataTextField = "CategoryName";
            ddlCategory1.DataValueField = "Category_Id";
            ddlCategory1.DataBind();

            //Default

            ddlCategory2.Items.Clear();
            ddlCategory2.Items.Add(new ListItem("-select category-", "0"));

            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));

        }

        private void BindCategories()
        {
            bladminCategory = new BLAdminCategory();

            DataSet ds = bladminCategory.GetCategoryList(pageIndex, pageSize, out rowCount);

            if (ds.Tables.Count > 0)
            {
                rptCategories.DataSource = ds.Tables[0].DefaultView;
                rptCategories.DataBind();

                PopulatePagingStatus(rowCount);
            }
        }

        private void PopulatePagingStatus(int rowCount)
        {
            double dblPageCount = (double)((decimal)rowCount / decimal.Parse(ddlPaging.SelectedValue));
            int pageCount = (int)Math.Ceiling(dblPageCount);

            if (rowCount == 0)
            {
            }
            else if (rowCount <= int.Parse(ddlPaging.SelectedValue))
            {
                lblShowingRecords.Text = "Showing 1 to " + rowCount + " of " + rowCount;
            }
            else if (pageIndex == 1)
            {
                lblShowingRecords.Text = "Showing 1 to " + ddlPaging.SelectedValue + " of " + rowCount;
            }
            else if (pageIndex != 1 && pageIndex < (pageCount - 1))
            {
                lblShowingRecords.Text = "Showing " + ((pageIndex - 1) * int.Parse(ddlPaging.SelectedValue) + 1) + " to " + (pageIndex * int.Parse(ddlPaging.SelectedValue)) + " of " + rowCount;
            }
            else if (pageIndex == pageCount)
            {
                lblShowingRecords.Text = "Showing " + ((pageIndex - 1) * int.Parse(ddlPaging.SelectedValue) + 1) + " to " + rowCount + " of " + rowCount;
            }


            PopulatePager(pageIndex, pageSize, rowCount);
        }

        private void PopulatePager(int pageIndex, int pageSize, int rowCount)
        {
            double dblPageCount = (double)((decimal)rowCount / decimal.Parse(ddlPaging.SelectedValue));
            int pageCount = (int)Math.Ceiling(dblPageCount);

            List<ListItem> pages = new List<ListItem>();

            if (pageCount > 0)
            {
                for (int i = 1; i <= pageCount; i++)
                {
                    pages.Add(new ListItem(i.ToString(), i.ToString(), i != pageIndex));
                }
            }
            rptPager.DataSource = pages;

            if ((pageCount - pageIndex) == 5)
            {
                rptPager.DataSource = pages.Skip(pageIndex - 5).Take(10).ToList();
            }
            else
            {
                rptPager.DataSource = pages.Take(10).ToList();
            }

            rptPager.DataBind();

        }

        protected void Page_Changed(object sender, EventArgs e)
        {
            pageIndex = int.Parse((sender as LinkButton).CommandArgument);
            Int32.TryParse(ddlPaging.SelectedItem.Value, out pageSize);

            BindCategories();
        }

        protected void rptCategories_ItemCommand(object source, RepeaterCommandEventArgs e)
        {

            if (e.Item.ItemType == ListItemType.AlternatingItem || e.Item.ItemType == ListItemType.Item)
            {
                if (e.CommandName == "DeleteCategory")
                {
                    bladminCategory = new BLAdminCategory();

                    int categoryId = 0;

                    Int32.TryParse(e.CommandArgument.ToString(), out categoryId);

                    bladminCategory.DeleteCategory(categoryId);

                    BindCategories();
                }
            }
        }

        protected void ddlCategory1_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Parent_Id = Int32.Parse(ddlCategory1.SelectedItem.Value);
            ddlCategory2.Items.Clear();
            ddlCategory2.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory2.AppendDataBoundItems = true;
            if (Parent_Id > 0)
            {
                DataSet ds = BindChildCategories(Parent_Id);
                ddlCategory2.DataSource = ds.Tables[0].DefaultView;
                ddlCategory2.DataTextField = "CategoryName";
                ddlCategory2.DataValueField = "Category_Id";
                ddlCategory2.DataBind();

                ReBindCategoryList(ds.Tables[0]);
            }
            else { BindCategories(); }

            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));
        }

        private void ReBindCategoryList(DataTable dataTable)
        {
            rptCategories.DataSource = dataTable.DefaultView;
            rptCategories.DataBind();
        }

        protected void ddlCategory2_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Parent_Id = Int32.Parse(ddlCategory2.SelectedItem.Value);
            ddlCategory3.Items.Clear();
            ddlCategory3.Items.Add(new ListItem("-select category-", "0"));
            ddlCategory3.AppendDataBoundItems = true;
            if (Parent_Id > 0)
            {
                DataSet ds = BindChildCategories(Parent_Id);
                ddlCategory3.DataSource = ds.Tables[0].DefaultView;
                ddlCategory3.DataTextField = "CategoryName";
                ddlCategory3.DataValueField = "Category_Id";
                ddlCategory3.DataBind();

                ReBindCategoryList(ds.Tables[0]);
            }
            else { ddlCategory1_SelectedIndexChanged(sender, e); }
        }
        private DataSet BindChildCategories(int Parent_Id)
        {
            bladminCategory = new BLAdminCategory();

            DataSet ds = bladminCategory.SelectCategoryByParent(Parent_Id);

            return ds;
        }
        protected void ddlCategory3_SelectedIndexChanged(object sender, EventArgs e)
        {
            int Parent_Id = Int32.Parse(ddlCategory3.SelectedItem.Value);

            if (Parent_Id > 0)
            {
                DataSet ds = BindChildCategories(Parent_Id);

                ReBindCategoryList(ds.Tables[0]);
            }
            else { ddlCategory2_SelectedIndexChanged(sender, e); }
        }

    }
}