﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;

using B2BBizLayer.Classes;
using B2BPropLayer.Classes;

namespace WebAdministrator.Authenticated
{
    public partial class ManageProducts : BaseAdminPage
    {
        BLAdminProduct bladminProduct = null;
        PLAdminUser pladminUser = null;

        public int pageSize = 10;
        public int rowCount = 0;
        public int pageIndex = 1;

        protected void Page_Load(object sender, EventArgs e)
        {
            if (!IsPostBack)
            {
                BaseMetaKeywords = "WEST";
                BaseMetaDescription = "HELLO TEST";

                BindProducts();

            }
        }

        private void BindProducts()
        {
            bladminProduct = new BLAdminProduct();

           

             DataSet ds = bladminProduct.SelectProduct(pageIndex, pageSize, out rowCount);

                if (ds.Tables.Count > 0)
                {
                    rptProducts.DataSource = ds.Tables[0].DefaultView;
                    rptProducts.DataBind();

                    if (ds.Tables[0].Rows.Count > 0)
                    {
                        PouplatePagingStatus(rowCount);
                        divNoList.Style.Add("display", "none");

                    }
                    else { divNoList.Style.Add("display", "block"); divNoList.InnerHtml = "No Products."; }
                }
            
        }

      
        private void PouplatePagingStatus(int rowCount)
        {
            double dblPageCount = (double)((decimal)rowCount / decimal.Parse(ddlPaging.SelectedValue));
            int pageCount = (int)Math.Ceiling(dblPageCount);

            if (rowCount == 0)
            {
            }
            else if (rowCount <= int.Parse(ddlPaging.SelectedValue))
            {
                lblShowingRecords.Text = "Showing 1 to " + rowCount + " of " + rowCount;
            }
            else if (pageIndex == 1)
            {
                lblShowingRecords.Text = "Showing 1 to " + ddlPaging.SelectedValue + " of " + rowCount;
            }
            else if (pageIndex != 1 && pageIndex < (pageCount - 1))
            {
                lblShowingRecords.Text = "Showing " + ((pageIndex - 1) * int.Parse(ddlPaging.SelectedValue) + 1) + " to " + (pageIndex * int.Parse(ddlPaging.SelectedValue)) + " of " + rowCount;
            }
            else if (pageIndex == pageCount)
            {
                lblShowingRecords.Text = "Showing " + ((pageIndex - 1) * int.Parse(ddlPaging.SelectedValue) + 1) + " to " + rowCount + " of " + rowCount;
            }


            PopulatePager(pageIndex, pageSize, rowCount);
        }

        private void PopulatePager(int pageIndex, int pageSize, int rowCount)
        {
            double dblPageCount = (double)((decimal)rowCount / decimal.Parse(ddlPaging.SelectedValue));
            int pageCount = (int)Math.Ceiling(dblPageCount);

            List<ListItem> pages = new List<ListItem>();

            if (pageCount > 0)
            {
                for (int i = 1; i <= pageCount; i++)
                {
                    pages.Add(new ListItem(i.ToString(), i.ToString(), i != pageIndex));
                }
            }
            rptPager.DataSource = pages;

            if ((pageCount - pageIndex) == 5)
            {
                rptPager.DataSource = pages.Skip(pageIndex - 5).Take(10).ToList();
            }
            else
            {
                rptPager.DataSource = pages.Take(10).ToList();
            }

            rptPager.DataBind();

        }

        protected void rptProducts_ItemCommand(object source, RepeaterCommandEventArgs e)
        {
            if (e.Item.ItemType == ListItemType.AlternatingItem || e.Item.ItemType == ListItemType.Item)
            {
                if (e.CommandName == "DeleteProduct")
                {
                    bladminProduct = new BLAdminProduct();

                    int productId = 0;

                    Int32.TryParse(e.CommandArgument.ToString(), out productId);

                    bladminProduct.DeleteProduct(productId);

                    BindProducts();
                } 
            }
        } 

        protected void Page_Changed(object sender, EventArgs e)
        {
            pageIndex = int.Parse((sender as LinkButton).CommandArgument);
            Int32.TryParse(ddlPaging.SelectedItem.Value, out pageSize);

            BindProducts();
        } 
    }
}